@echo off

echo This will compile, link and configure the 
echo       Parallel Conjugate Gradient Program
echo only if the compiler is on path and the environment variable has 
echo been setup in your autoexec.bat file

echo compiling master task ...
echo on
t8c fem /v/zi/zd
t8c renum /v/zi/zd
echo off

echo compiling worker task ...
echo on 
t8c jcc /v/zi/zd
echo off

echo linking master task ...
linkt fem renum e:\tc2v2\crtlt8.bin  e:\tc2v2\taskharn.t8, fem.b4 /g

echo linking worker task ...
linkt jcc e:\tc2v2\sacrtlt8.bin  e:\tc2v2\taskharn.t8, jcc.b4 /g

echo configuring ...
config single.cfg single.app
config femcg.cfg  femcg.app 

echo If you did not encounter any error messages
echo your application is ready, so 
echo it may be started by typing:
echo runn single     - (single transputer version)
echo or 
echo runn femcg      - (for 14 processors)
@echo on
