#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define LIL 2
#define MM  5
#define NC  5

char titel[50];
int *subdom;

int nn,ne,nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;

int *nod,nodl[LIL][3],nodq[LIL][5],
nco[MM][4],nsnod[LIL][5],
mat[5],nc[NC],ngs[LIL];

double dt,damp;

/*double *cord;*/

double amat[5][10],aload[NC][3];

void rinput(FILE *);
/*void routput(in_t *SUB,FILE *);*/
void alloc_array(int **arr, int no, char *s);
void pr_v(int *, int *,int *, int *, int, int, FILE *, FILE *);
void elinsub(int numele, int numpro, int *me, int *inter, int *xinter, 
             char *file_sav);

main()
{
char file[30], file_sav[30];
FILE *fpi, *fpt;
int *mp,*mn ,*nen,*nep,*map,*ad,*ap,*mask,*nw,*maskel,*maskno,*maskin,
    *locmask,*me,*mep,*inter,*xinter, numpro;
time_t tim1, tim2;

printf("Enter input file (.dat assumed)\n");
gets(file); strcpy(file_sav,file); strcat(file,".dat");

printf("\nEnter the number of processors\n");
scanf("%d",&numpro);

time(&tim1);

if((fpi = fopen(file,"r")) == (FILE *) NULL)
{printf("cannot open %s\n",file); exit(1);}

rinput(fpi);
alloc_array(&mp, ne+1,"mp");
alloc_array(&mn,3*( ne)+1,"mn");
alloc_array(&nep, nn+1,"nep");
alloc_array(&nen,15*( ne)+1,"nen");/*assuming 10 elem per node */
alloc_array(&map, nn+1,"map");
alloc_array(&ad,3*15*( ne)+1,"ad");/*-------    do   ----------*/
alloc_array(&ap, ne+1,"ap");
alloc_array(&mask, ne+1,"mask");
alloc_array(&nw, nn+1,"nw");
alloc_array(&maskel, ne+1,"maskel");
alloc_array(&maskno, ne+1,"maskno");
alloc_array(&maskin, ne+1,"maskin");
alloc_array(&locmask, ne+1,"locmask");
alloc_array(&me, ne+1,"me");
alloc_array(&mep,numpro+1,"mep");
alloc_array(&inter,15*( ne/numpro)+1,"inter");
alloc_array(&xinter,ne+1,"xinter");
alloc_array(&subdom,ne+1,"subdom");

foelco( nod-1,mn,mp, ne,3);
fonoco(mn,mp,nen,nep, nn, ne,map);

adjncy_node(mn,mp,nen,nep,ad,ap,mask, ne,map);

autsub(mn,mp,nen,nep, nn, ne,numpro,nw,ad,ap,me,mep,
       maskel,maskno,maskin,locmask,inter,xinter);

elinsub(ne, numpro, me, inter, xinter, file_sav);
fclose(fpi);

time(&tim2);
strcpy(file, file_sav); strcat(file,".in");
if((fpt = fopen(file,"w")) == (FILE *) NULL)
{printf("cannot open %s\n",file); exit(1);}
fprintf(fpt,"Time = %f min\n",((double)tim2 - (double)tim1)/60.);
fprintf(stdout,"Time = %f min\n",((double)tim2 - (double)tim1)/60.);
fclose(fpt);
printf("*** information file %s.in generated ***\n",file_sav);
return(1);
}

 
void alloc_array(int **arr, int no, char *s)
{
if((*arr = calloc(no, (sizeof(int)))) == NULL)
{printf("out of core for %s\n", s); exit(1);}
}


/* function to read in the data from the primary data file */

void rinput(FILE *fp11)
{
char bf[256];
int i,j,k,n;
double val,x1,y1,z1;

   fgets( titel,50,fp11);
   fputs( titel,stdout);
   fgets(bf,256,fp11);
   sscanf(bf,"%lf%lf",&( dt),&( damp));
   printf("%f %f \n", dt, damp);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",
   &( nn),&( ne),&( nb),&( nm),&( nl),
   &( ndime), &( nstr), &( nbe), &( kmax),
   &( nmax), &( iln));

   fgets(bf,256,fp11);
   sscanf(bf,"%d",&( nq));
/*
   if(( cord = calloc(3*( nn)+1, sizeof(double))) == NULL)
   {printf("out of core for  cord\n"); exit(1);}
*/
   if(( nod = calloc(4*( ne)+1, sizeof(int))) == NULL)
   {printf("out of core for  nod\n"); exit(1);}


   for(i = 0; i <  nn; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",&n, &x1, &y1,&z1);
/*    cord[3*i + 0] = x1;
    cord[3*i + 1] = y1;
    cord[3*i + 2] = z1; */
   }



   if( ne > 0)
   {
      for(i = 0; i <  ne; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d",
      &n,&( nod[4*i + 0]),&( nod[4*i + 1]),
      &( nod[4*i + 2]),&( nod[4*i + 3]));
      }
   }



/*   if( nl > 0)
   {
      for(i = 0; i <  nl;i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d",&n,&nodl[i][0],&nodl[i][1],
      &nodl[i][2]);
      }
   }



   if(nq > 0)
   {
      for(i = 0; i < nq; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d %d",&n,&nodq[i][0],&nodq[i][1],
      &nodq[i][2],&nodq[i][3],&nodq[i][4]);
      }
   }
*/


   for(i = 0; i <  nm; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %lf %lf %lf %lf %lf",&n,
   &( mat[i]),&( amat[i][0]),&( amat[i][1]),
   &( amat[i][2]),&( amat[i][3]),&( amat[i][4]));
   }



   for(i = 0; i <  nb; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d",
   &( nco[i][0]),&( nco[i][1]),&( nco[i][2])
   ,&( nco[i][3]));
   }



   if( iln > 0)
   {
   for(i = 0; i < NC;  nc[i++] = 0);/*zero for use in nb_iln */
    iln = 0;
more:
    iln++;
   i =  iln - 1;

   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",
   &( nc[i]),&( aload[i][0]),&( aload[i][1]),&( aload[i][2]));

   if( nc[i] <  nn)
   goto more;
   }

/*   if(nstr > 0)
   {
   for(i = 0; i < nstr; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d",&ngs[i]);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d",&nsnod[i][0],&nsnod[i][1],
   &nsnod[i][2],&nsnod[i][3],&nsnod[i][4],&nsnod[i][5],&nsnod[i][6],
   &nsnod[i][7]);
   }
   }
*/
}


void elinsub(int numele, int numpro, int *me, int *inter, int *xinter, 
             char *file_sav)
{
char file[30];
FILE *fp0, *fp1;
register  i, j, isub;
int jstart, jstop;
int nres , lsub, nsub, elem, ie, ic;

strcpy(file, file_sav);
strcat(file, ".dec");
if((fp0=fopen(file,"w")) == (FILE *) NULL)
{printf("cannot open %s\n", file_sav); exit(1);}


if((fp1=fopen("dec.dat","w")) == (FILE *) NULL)
{printf("cannot open dec.dat\n"); exit(1);}


ie = 0;

lsub = numele/numpro;
nres = fmod(numele, numpro);
if(nres !=  0) lsub += 1;

nsub = numpro;
 
for(isub = 1; isub <= nsub; isub++)
{
fprintf(fp1,"Subdomain No. %3d\n", isub);
if(isub == nsub) lsub = numele - ie;
   for(ic = 1; ic <= lsub; ic++)
   {
   ie++;
   elem = me[ie];
   fprintf(fp1,"%5d %5d\n",ie, elem); 
   subdom[elem] = isub;
   }
fprintf(fp1,"\n");
}


fprintf(fp1,"The interface nodes are :\n");
for(i = 1; i <= numpro; i++)
{
jstart = xinter[i];
jstop = xinter[i+1] - 1;
fprintf(fp1," %3d",i);
   for(j=jstart; j <= jstop; j++)
   fprintf(fp1," %3d", inter[j]);
fprintf(fp1,"\n");
}

for(i = 1; i <= numele; i++)
fprintf(fp0, "%5.2f\n",(float)subdom[i]);

fclose(fp0);
fclose(fp1);
free(subdom);

printf("file *** dec.dat *** generated\n");
printf("file *** %s *** generated\n", file);

}
