@echo off

echo This will compile, link and configure the parallel mesh generator
echo only if the compiler is on path and the environment variable has 
echo been setup in your autoexec.bat file

echo compiling master task ...
t8c  drm1 /v/zi/zd
t8c  drm2 /v/zi/zd

echo compiling worker task ...
t8c drw1 /v/zi/zd

echo compiling master router
t8c rm001 /v/zi/zd

echo compiling worker router
t8c rw001 /v/zi/zd


echo linking master task ...
linkt drm1 drm2 e:\tc2v2\crtlt8.bin  e:\tc2v2\taskharn.t8, drm1.b4 /g

echo linking worker task ...
linkt drw1 e:\tc2v2\sacrtlt8.bin  e:\tc2v2\taskharn.t8, drw1.b4 /g

echo linking master router task ...
linkt rm001 e:\tc2v2\sacrtlt8.bin  e:\tc2v2\taskharn.t8, rm001.b4 /g

echo linking worker router task ...
linkt rw001 e:\tc2v2\sacrtlt8.bin  e:\tc2v2\taskharn.t8, rw001.b4 /g

echo configuring ...
config nineproc.cfg nineproc.app
config sinp9wk.cfg sinp9wk.app

echo If you did not encounter any error messages
echo your application is ready 
echo it may be started by typing
echo runn nineproc       - (for 9 processors)
echo runn sinp9wk        - (for 9 processor emulation on a single processor)
@echo on
:end
