@echo off

echo This will compile, link and configure the parallel mesh generator
echo only if the compiler is on path and the environment variable has 
echo been setup in your autoexec.bat file

echo compiling master task ...
t8c  drm1 /v/zi/zd

t8c  drm2 /v/zi/zd

echo compiling worker task ...
t8c drw1 /v/zi/zd

echo compiling master router
rem t8c rm001 /v/zi/zd

echo compiling worker router
rem t8c rw001 /v/zi/zd


echo linking master task ...
linkt drm1 drm2 d:\tr\tc2v2\crtlt8.bin  d:\tr\tc2v2\taskharn.t8, drm1.b4 /g

echo linking worker task ...
linkt drw1 d:\tr\tc2v2\sacrtlt8.bin  d:\tr\tc2v2\taskharn.t8, drw1.b4 /g

echo linking master router task ...
rem linkt rm001 d:\tr\tc2v2\sacrtlt8.bin  d:\tr\tc2v2\taskharn.t8, rm001.b4 /g

echo linking worker router task ...
rem linkt rw001 d:\tr\tc2v2\sacrtlt8.bin  d:\tr\tc2v2\taskharn.t8, rw001.b4 /g

echo configuring ...
rem config nineproc.cfg nineproc.app
config sinp9wk.cfg sinp9wk.app

runn sinp9wk

@echo on
:end
