#include"plotpp.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#ifdef __TURBOC__
#include<alloc.h>
#else
#include<malloc.h>
#endif

/* Global variables */
extern int triang, cable, autoscale, sepele, string, err, stres, dec,eps,mes;
extern int numyes, nuele,views;
extern char titel[100];
extern char *plotfile;
extern char device[2];
extern int plotline;
extern float sfs;
extern float dt,damp,brightness, red, green, blue;
extern int  nn,ne,nb,nm,nl,ndime,kt,nt,nstr,nbe,kmax,nmax,iln,nq;
extern int far nod[5000][5];
extern int nodq[10][4];
extern float  tcor[5000][2], *errorr;
extern float  aminst, amaxst, amaxer, aminer;
extern int ipv, norm;
extern float b, af;
extern float redfact, scalefac, shiftx, shifty;
extern char til[80];
extern char calcomp[2], laser[2], screen[2];
extern int xxmax,xxmin,yymax,yymin;
extern FILE *in,*out,*eorr,*stress,*c100,*decom;
extern int nxx;

/* Main graphics function */

plot(ichan,nd1,nd2,isoyes)
int ichan,nd1,nd2,isoyes;
{
double twdowx,twdowy,cmxoff2,cmyoff2,sf;
double xmin,ymin,xmax,ymax,xrange,yrange;
int   kbug=0;

/* open channel to plotfile */
   opench( ichan, &twdowx, &twdowy);

/* find max min coordinate values */
   maxmin(xmin,xmax,ymin,ymax,xrange,yrange,&sf,twdowx,twdowy,&cmxoff2,&cmyoff2);

/* calculate the shift in origin and the scalefactor for ps */
   setscale(cmxoff2,cmyoff2);

/* open graphics window and clear screen */
   openg(kbug,sf);

   if (triang)
     {
       if(ne>0) psplottri(sf);
       if(nq>0) psplotquad(sf);
     }

   nodnum(kbug,sf);

   elemno(sf);

   if(dec!=1) indexerrstr();

/* in order to keep this version with other program
keep nd2,nd1,isoyes which are not used in fact here */
   nd2=nd1*nd2*isoyes;
/* close the postscript picture file */
   closing();
   return 1;
}


/* open channel to plotfile */

opench(ichan,twdowx,twdowy)
int ichan;
double *twdowx,*twdowy;
{
 int linlas=1; /* linscr=5 */
 int ich;
 plotline=linlas;
 *twdowx=250.00;
 *twdowy=200.00;
 ich=ichan-6;

  switch (ich)
  {
   case 1:
    plotfile="pltf1.plt";
    break;

    case 2:
    plotfile="pltf2.plt";
    break;

    case 3:
     plotfile="pltf3.plt";
     break;

     case 4:
     plotfile="pltf4.plt";
     break;
   }

 return 1;
}


/* find max and min coordinate values */

maxmin(xmin,xmax,ymin,ymax,xrange,yrange,sf,twdowx,twdowy,cmxoff2,cmyoff2)
double xmin,xmax,ymin,ymax,xrange,yrange,twdowx,twdowy;
double *sf,*cmxoff2,*cmyoff2;
{
 int j;
 double xd,yd;
 double sf1,sf2,cmxmin,cmymin,cmxrng,cmyrng,cmxoff1,cmyoff1;
 xmax=tcor[1][0];
 xmin=tcor[1][0];
 ymin=tcor[1][1];
 ymax=tcor[1][1];
 for(j=1;j<=nn;j++)
  {
   xd=tcor[j][0];
   yd=tcor[j][1];
   if(xd<xmin) xmin=xd;
   else if(xd>xmax) xmax=xd;
   if(yd<ymin) ymin=yd;
   else if(yd>ymax) ymax=yd;
  }

 xrange=xmax-xmin;
 yrange=(ymax-ymin)*1.1;
 if(autoscale)
  {
    if(xrange==0) sf1=1.0e+10;
    else sf1=(twdowx-(20.0e+00))/xrange;

    if(yrange==0) sf2=1.0e+10;
    else sf2=(twdowy-(20.0e+00))/yrange;

    if(sf1<sf2) *sf=sf1;
    else *sf=sf2;
  }
 else *sf=sfs;

 cmxrng=*sf*xrange;
 cmyrng=*sf*yrange;
 cmxmin=*sf*xmin;
 cmymin=*sf*ymin;
 cmxoff1=(twdowx-cmxrng)/2;
 cmyoff1=(twdowy-cmyrng)/3;
 *cmxoff2=cmxoff1-cmxmin;
 *cmyoff2=cmyoff1-cmymin;
 fprintf(out,"\n\n max min values:    %lf    %lf    %lf    %lf", xmin,xmax,ymin,ymax);

 return 1;
}

/* function to calculate the scale of the picture */
setscale(cmxoff2,cmyoff2)
double cmxoff2,cmyoff2;
{
 scalefac=72.0/25.4/0.24;
 shiftx=cmxoff2*scalefac;
 shifty=cmyoff2*scalefac;

 return 1;
}

/* function to open plot file */
openg(kbug,sf)
int kbug;
double sf;
{
 if(kbug>2) printf("   %s   opened",plotfile);
/* draw border call sr pboder to set up ps instructions to draw border */
 pborder(sf);
 return 1;
}


/* function pborder */
pborder(sf)
double sf;
{
 int j,jj,i;
 int n3,ix3,iy3;
 double xc,yc,x3,y3,xq,yq,xdif,ydif;
 int np,ixq,iyq,x1,y1,x2,y2;
 char ch='%';

/* open the file for output the postscript picture file */
  if((c100=fopen(plotfile,"w"))==NULL)
    {
      printf("Can not open file");
      exit(1);
     }

  x1=10000;
  x2=0;
  y1=10000;
  y2=0;

 if(ne>0)
 {
  for(j=1;j<=ne;j++)
    {
      for(i=1;i<=3;i++)
	  {
	    np=nod[j][i];
	    xq=tcor[np][0];
	    yq=tcor[np][1];
	    xq=sf*xq*scalefac+shiftx;
	    yq=sf*yq*scalefac+shifty;
	    ixq=(int)(xq);
	    iyq=(int)(yq);

	  if(redfact>0)
	     {

	      xdif=0;
	      ydif=0;
	      for(jj=1;jj<=3;jj++)
		  {
		    xdif=xdif+tcor[nod[j][jj]][0];
		    ydif=ydif+tcor[nod[j][jj]][1];
		  }
		xc=xdif/3;
		yc=ydif/3;

	       np=nod[j][i];
	       xq=tcor[np][0];
	       yq=tcor[np][1];
	       xq=xq+(xc-xq)*redfact;
	       yq=yq+(yc-yq)*redfact;
	       xq=sf*xq*scalefac+shiftx;
	       yq=sf*yq*scalefac+shifty;
	       ixq=(int)(xq);
	       iyq=(int)(yq);
	       }
	 if(x1>ixq) x1=ixq;
	 if(x2<ixq) x2=ixq;
	 if(y1>iyq) y1=iyq;
	 if(y2<iyq) y2=iyq;

	    }
       }
  }
   if(nq>0)
   {
    for(j=1;j<=nq;j++)
    {
      for(i=1;i<=4;i++)
	  {
	    np=nodq[j][i-1];
	    xq=tcor[np][0];
	    yq=tcor[np][1];
	    xq=sf*xq*scalefac+shiftx;
	    yq=sf*yq*scalefac+shifty;
	    ixq=(int)(xq);
	    iyq=(int)(yq);

	  if(redfact>0)
	     {

	      xdif=0;
	      ydif=0;
	      for(jj=1;jj<=4;jj++)
		  {
		    xdif=xdif+tcor[nodq[j][jj-1]][0];
		    ydif=ydif+tcor[nodq[j][jj-1]][1];
		  }
		xc=xdif/3;
		yc=ydif/3;

	       np=nodq[j][i-1];
	       xq=tcor[np][0];
	       yq=tcor[np][1];
	       xq=xq+(xc-xq)*redfact;
	       yq=yq+(yc-yq)*redfact;
	       xq=sf*xq*scalefac+shiftx;
	       yq=sf*yq*scalefac+shifty;
	       ixq=(int)(xq);
	       iyq=(int)(yq);
	       }
	 if(x1>ixq) x1=ixq;
	 if(x2<ixq) x2=ixq;
	 if(y1>iyq) y1=iyq;
	 if(y2<iyq) y2=iyq;

	    }
       }
    }

  x1=(int)(x1*0.24-2);
  x2=(int)(x2*0.24+2);
  y1=(int)(y1*0.24-2);
  y2=(int)(y2*0.24+2);
  fprintf(c100,"%%!ps-adobe-2.0 epsf-2.0\n%%%cBoundingBox:  %d %d %d %d \n/l {lineto} def  /m {moveto} def ",ch,x1,y1,x2,y2);
  fprintf(c100,"\n577 14 translate\t90  rotate");
//  printf("\nEnter the title:");
//   scanf("%s",til);

/* fprintf(c100,"\n/small /Times-Roman findfont 55 scalefont def");
 fprintf(c100,"\n/normal /Times-Roman findfont 65 scalefont def");
 fprintf(c100,"\n/large /Times-Roman findfont 80 scalefont def");
 fprintf(c100,"\n/bold /Times-Bold findfont 60 scalefont def"); */

  fprintf(c100," \n/helvetica findfont 20 scalefont setfont");
  fprintf(c100,"\n0.20  0.20  scale \nnewpath");



  return 1;
}

/* function to number nodes  */

nodnum(kbug,sf)
int kbug;
double sf;

{
 int jt;
/* int ixo,iyo; */
 double x,y;
 int ix,iy;

 if(numyes)
  {
    fprintf(c100," \n/helvetica findfont    10 0.24 div scalefont setfont ");

    for(jt=1;jt<=nn;jt++)
     {
	 x=sf*tcor[jt][0]*scalefac+shiftx;
	 y=sf*tcor[jt][1]*scalefac+shifty;
	 ix=(int)(x);
	 iy=(int)(y);
	 fprintf(c100,"\n%d %d  m ( %d ) show", ix,iy,jt);

       if(kbug>2) fprintf(out,"\n tcor[%d][*]     %lf      %lf",jt,tcor[jt][0],tcor[jt][1]);
      }
   }

 return 1;
}

/* mark elements if required */
elemno(sf)
double sf;
{
 int j,jj;
 double xdif,ydif;
 int ixdif,iydif;
 int kbug=0;

 if(nuele)
  {
   if(ne>0)
   {
    for(j=1;j<=ne;j++)
    {
      xdif=0.0e+0;
      ydif=0.0e+0;

      for(jj=1;jj<=3;jj++)
       {
	 xdif=xdif+tcor[nod[j][jj]][0];
	 ydif=ydif+tcor[nod[j][jj]][1];
       }

	 xdif=sf*xdif/3*scalefac+shiftx;
	 ydif=sf*ydif/3*scalefac+shifty;

	 ixdif=(int)(xdif);
	 iydif=(int)(ydif);

	 fprintf(c100,"\n%d %d m ( %d ) show", ixdif,iydif,j);
	 if(kbug>2) fprintf(out,"\n xdif ydif :     %lf    %lf",xdif,ydif);
     }
   }
  if(nq>0)
   {
    for(j=1;j<=nq;j++)
    {
      xdif=0.0e+0;
      ydif=0.0e+0;

      for(jj=1;jj<=4;jj++)
       {
	 xdif=xdif+tcor[nodq[j][jj-1]][0];
	 ydif=ydif+tcor[nodq[j][jj-1]][1];
       }

	 xdif=sf*xdif/4*scalefac+shiftx;
	 ydif=sf*ydif/4*scalefac+shifty;

	 ixdif=(int)(xdif);
	 iydif=(int)(ydif);

	 fprintf(c100,"\n%d %d m ( %d ) show", ixdif,iydif,j);
	 if(kbug>2) fprintf(out,"\n xdif ydif :     %lf    %lf",xdif,ydif);
    }
  }
 }
 return 1;
}

/* plot triangular elements in ps file */
 psplottri(sf)
 double sf;
{
 int j,jj,i;
 int n3,ix3,iy3,ixq,iyq;
 double xc,yc,x3,y3,xq,yq,x,y,xdif,ydif;
 int np;
 int kbug;
 int x1,x2,y1,y2,xu,yu,xl,yl,pig;

 xxmax=0;
 xxmin=10000;
 yymax=0;
 yymin=10000;

/* plot elements */
for(j=1;j<=ne;j++)
 {
   n3=nod[j][3];
   x3=tcor[n3][0];
   y3=tcor[n3][1];
   x=sf*x3*scalefac+shiftx;
   y=sf*y3*scalefac+shifty;
   ix3=(int)(x);
   iy3=(int)(y);
   if(redfact>0)
   {
    xdif=0.0e+0;
    ydif=0.0e+0;
    for(jj=1;jj<=3;jj++)
      {
	xdif=xdif+tcor[nod[j][jj]][0];
	ydif=ydif+tcor[nod[j][jj]][1];
       }
     xc=xdif/3;
     yc=ydif/3;

/* modify x3 y3 */
   x3=x3+(xc-x3)*redfact;
   y3=y3+(yc-y3)*redfact;
   x3=sf*x3*scalefac+shiftx;
   y3=sf*y3*scalefac+shifty;
   ix3=(int)(x3);
   iy3=(int)(y3);
  }

  fprintf(c100,"\n%d %d m",ix3,iy3);
  if(xxmax<ix3) xxmax=ix3;
  if(xxmin>ix3) xxmin=ix3;
  if(yymax<iy3) yymax=iy3;
  if(yymin>iy3) yymin=iy3;

  for(i=1;i<=3;i++)
     {
      np=nod[j][i];
      xq=tcor[np][0];
      yq=tcor[np][1];
      xq=sf*xq*scalefac+shiftx;
      yq=sf*yq*scalefac+shifty;
      ixq=(int)(xq);
      iyq=(int)(yq);
      if(redfact>0)
	{
	  np=nod[j][i];
	  xq=tcor[np][0];
	  yq=tcor[np][1];
	  xq=xq+(xc-xq)*redfact;
	  yq=yq+(yc-yq)*redfact;
	  xq=sf*xq*scalefac+shiftx;
	  yq=sf*yq*scalefac+shifty;
	  ixq=(int)(xq);
	  iyq=(int)(yq);
	 }

       fprintf(c100,"\n%d %d l",ixq,iyq);
       if(xxmax<ixq) xxmax=ixq;
       if(xxmin>ixq) xxmin=ixq;
       if(yymax<iyq) yymax=iyq;
       if(yymin>iyq) yymin=iyq;

    }

    if(dec) shadedom(j);
    else if(stres) shadste(j);
    else if(err)   shaderr(j);
    else if(mes)
    {
     fprintf(c100,"\n closepath gsave 1.0 setgray fill grestore stroke");
     fprintf(c100,"\n 0.0 setgray");
    }
    else fprintf(c100,"\n  stroke");
/*
    if (err||stres)
     {
       if(dec!=1)
       {
	  if(stres) shadste(j);
	  else
	    {
	     if(norm==1) shaderr1(j);
	     else shaderr(j);
	    }
	}
       else shadedom(j);

      }
      else fprintf(c100,"\n  stroke");
*/
 }

 x1=(int)((xxmin*0.24-2)/0.24);
 x2=(int)((xxmax*0.24+2)/0.24);
 y1=(int)((yymin*0.24-2)/0.24);
 y2=(int)((yymax*0.24+2)/0.24);
 xu=x1;
 yu=(int)((yymax*0.24+4)/0.24);
 xl=(int)((xxmin*0.24+5)/0.24);
 yl=(int)((yymin*0.24-20)/0.24);



 if(!eps)
 {
 fprintf(c100,"\nnewpath \n%d  %d m\n%d  %d l\n%d  %d l\n%d  %d l\nclosepath stroke",x1,y1,x2,y1,x2,y2,x1,y2);
 fprintf(c100,"\n%d %d  m  \nnormal setfont (TITEL:%s)  show 2 setlinewidth stroke",xu,yu,til);
 printf("Input figure number:");
 scanf("%d",&pig);

 fprintf(c100,"\n%d %d m \nbold setfont (FIG.%d:) show ",xl,yl,pig);
 fprintf(c100,"\n%d %d m \nsmall setfont (subdomains(%d elements) patitioned using SGM) show",xl+250,yl,ne);
 }
return 1;
}

/* plot quadrilateral elements in ps file */
/* psplotquad(sf) */
 psplotquad(sf)
 double sf;
{
 int j,i,jj;
 int n4,ix,iy,ixq,iyq;
 double x4,y4,xdif,ydif,xc,yc,xq,yq;
 double x,y;/* kbug=0; */
 int np;
 char *chstr;
 int kbug;

 /* plot elements */
if (nq>0) {
 for(j=1;j<=nq;j++)
   {
    n4=nodq[j][3];
    x4=tcor[n4][0];
    y4=tcor[n4][1];
    x=sf*x4*scalefac+shiftx;
    y=sf*y4*scalefac+shifty;
    ix=(int)(x);
    iy=(int)(y);
    if(redfact>0)
      {
 /* find the center of element */
	xdif=0.0e+0;
	ydif=0.0e+0;
	for(jj=0;jj<4;jj++)
	 {
	  xdif=xdif+tcor[nodq[j][jj]][0];
	  ydif=ydif+tcor[nodq[j][jj]][1];
	 }
	 xc=xdif/4;
	 yc=ydif/4;
 /* modify x3 y3 */
	 x4=x4+(xc-x4)*redfact;
	 y4=y4+(yc-y4)*redfact;
	 x4=sf*x4*scalefac+shiftx;
	 y4=sf*y4*scalefac+shifty;
	 ix=(int)(x4);
	 iy=(int)(y4);
       }
    fprintf(c100,"\n%d %d m",ix,iy);

    for(i=0;i<4;i++)
       {
	np=nodq[j][i];
	xq=tcor[np][0];
	yq=tcor[np][1];
	xq=sf*xq*scalefac+shiftx;
	yq=sf*yq*scalefac+shifty;
	ixq=(int)(xq);
	iyq=(int)(yq);
	if(redfact>0)
	  {
	    np=nodq[j][i];
	    xq=tcor[np][0];
	    yq=tcor[np][1];
	    xq=xq+(xc-xq)*redfact;
	    yq=yq+(yc-yq)*redfact;
	    xq=sf*xq*scalefac+shiftx;
	    yq=sf*yq*scalefac+shifty;
	    ixq=(int)(xq);
	    iyq=(int)(yq);
	   }
	 fprintf(c100,"\n %d %d  l ", ixq,iyq);
	}

   if(err||stres)
      {
       if(dec)				// if(dec!=1)
	 {
	  if(norm==1) shaderr1(j);
	  else shaderr(j);
	}
       else shadedom(j);
      }

      else fprintf(c100,"   stroke");
  }

  if(norm==1)
   {
    fprintf(c100," \n/times-roman findfont 50 scalefont setfont\n 1200 0 m (relative error plot max error=%lf%) show",amaxer);
   }
   else
    {
     if(err)
       {
	 if(dec) goto c;
	  else fprintf(c100,"\n /times-roman findfont 50 scalefont setfont\n 1200 0 m (error plot) show");
       }
   }
}
c:   return 1;
}

/* shade the elements with respect to specified parameter */
/* function shaderr(j) */
shaderr1(j)
int j;
{
 double shade;

 if(err)
  {
   if(dec) *(errorr+j)=10*(*(errorr+j));
   if(abs(*(errorr+j)>1)) shade=0.0;
   if(abs(*(errorr+j)<1)) shade=0.1;
   if(abs(*(errorr+j)<0.9)) shade=0.2;
   if(abs(*(errorr+j)<0.8)) shade=0.3;
   if(abs(*(errorr+j)<0.7)) shade=0.4;
   if(abs(*(errorr+j)<0.6)) shade=0.5;
   if(abs(*(errorr+j)<0.5)) shade=0.6;
   if(abs(*(errorr+j)<0.4)) shade=0.7;
   if(abs(*(errorr+j)<0.3)) shade=0.8;
   if(abs(*(errorr+j)<0.2)) shade=0.9;
   if(abs(*(errorr+j)<0.1)) shade=1.0;
   shade=1.0;
   fprintf(c100,"\n closepath gsave %f setgray fill grestore stroke",shade);
   fprintf(c100,"\n 0.0 setgray");
  }
return 1;
}

/* shade the elements with respect to specified parameter
   function shaderr1(j) */
shaderr(j)
int j;
{
 double shade;


 if((abs((*(errorr+j))/amaxer))>=1.0) shade=0.0;
 if((abs((*(errorr+j))/amaxer))<1.0) shade=0.1;
 if((abs((*(errorr+j))/amaxer))<0.9) shade=0.2;
 if((abs((*(errorr+j))/amaxer))<0.8) shade=0.3;
 if((abs((*(errorr+j))/amaxer))<0.7) shade=0.4;
 if((abs((*(errorr+j))/amaxer))<0.6) shade=0.5;
 if((abs((*(errorr+j))/amaxer))<0.5) shade=0.6;
 if((abs((*(errorr+j))/amaxer))<0.4) shade=0.7;
 if((abs((*(errorr+j))/amaxer))<0.3) shade=0.8;
 if((abs((*(errorr+j))/amaxer))<0.2) shade=0.9;
 if((abs((*(errorr+j))/amaxer))<0.1) shade=1.0;


 getrgberr(*(errorr+j));
 shade=1.0*shade;
// fprintf(c100,"\nclosepath gsave  %f setgray fill \ngrestore strok",shade);
 fprintf(c100,"\nclosepath gsave   %f  %f  %f setrgbcolor fill \ngrestore stroke",red,green,blue);
 fprintf(c100,"\n0.0 setgray");

return 1;
}

/* function getrgberr(evalue)  */
getrgberr(evalue)
double evalue;

{
  double btf;
  double colfac1,colfac2,colfac3,amaxstr;

  amaxstr=amaxer;
  btf=1.0-brightness;

  red=1.0;
  green=0.0;
  blue=1.0;
  colfac1=1.0-red;
  colfac2=1.0-green;
  colfac3=1.0-blue;
  red = 1. -  pow(  (evalue/amaxstr*colfac1) , btf );
  green=1. -  pow(  (evalue/amaxstr*colfac2) , btf);
  blue=  1. - pow(   (evalue/amaxstr*colfac3), btf);

  return 1;
}


/* function closing the postscript file */
 closing()
{
  if(err || stres || dec) fprintf(c100,"\nshowpage");
  else fprintf(c100,"\n stroke 4.2 4.2 scale\nshowpage");
  return 1;
}


