 /* program to plot the adaptive mesh into postscript form file  */

#include"plotpp.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#ifdef __TURBOC__
#include<alloc.h>
#else
#include<malloc.h>
#endif

/* Global variables */
int triang, cable, autoscale, sepele, string, err, stres, dec,eps,mes;
int numyes, nuele,views;
char titel[100];
char *plotfile= NULL;
char device[2];
int plotline;
extern float *errorr;
float sfs;
float dt,damp,brightness, red, green, blue;
int  nn,ne,nb,nm,nl,ndime,kt,nt,nstr,nbe,kmax,nmax,iln,nq;
float  aminst, amaxst, amaxer, aminer;
int ipv, norm;
float redfact, scalefac, shiftx, shifty;
char til[80];
char calcomp[2], laser[2], screen[2];
int xxmax,xxmin,yymax,yymin;
int nin=7, nout=8;

FILE *in,*out,*eorr,*stress,*c100,*decom;
int nxx;

main()
{

float  twdowx,twdowy;
int nomb,isoyes,ichan;
char but[3];
char ch;
int nd1,nd2;

/* input datafile which contains the topology of adaptive mesh */
  if ((in=fopen("input.dat","r")) ==NULL){
       printf("Can nnot open file input\n");
       exit(1);
       }

/* output file for reanalysis    */
  if ((out=fopen("plotout.dat","w")) ==NULL ){
       printf("Can not open file output\n");
       exit(1);
       }

/* the head of this program */
  printf("\n************************************************************");
  printf("\n*							   *");
  printf("\n* 	  		Mesh Plotter     		   *");
  printf("\n*                        Pc Version                        *");
  printf("\n*   			  			           *");
  printf("\n*   			  			           *");
  printf("\n*	     Program for drawing Subdomain Meshes	   *");
  printf("\n*	     using encapsulated postscript format          *");
  printf("\n*            The Max number of elements is 3500            *");
  printf("\n*            The Max number of points is 3500              *");
  printf("\n*            The Max number of subdomains is 15            *");
    printf("\n*   			  			           *");
  printf("\n************************************************************");

 printf("\n\n press any key to star......");
 getch();

  eps=1;

  printf("\nBrightness controll factor [0.]...[1.]\n");
  scanf("%f",&brightness);

  triang=1;

/* initial program values */
  err=stres=dec=mes=0;
  norm=1;
    printf("\nD-Plot subdomain mesh\n");
    printf("S-Plot stress \n");
    printf("E-Plot analysis error\n");
    printf("M-only plot mesh topology\n");
    printf("Q-Exit program\n");
    printf("\nYour choice?");
    scanf("%s",but);
    ch=but[0];

      switch (ch)
       {
	case 'D':
	case 'd':
	 dec=1;
	 break;

	case 'E':
	case 'e':
	 err=1;
	 break;

	case 'S':
	case 's':
	 stres=1;
	 break;

	case 'M':
	case 'm':
	 mes=1;
	 break;

	case 'Q':
	case 'q':
	 exit();
	 break;

	default:
	printf("\n your choose is not a available one");
	printf("\n try again.....");
	exit();
    }


   printf("Plot cable elements ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') cable=1;
   else cable=0;

   printf("Plot g strings ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') string=1;
   else string=0;

   printf("number nodes ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if(toupper(ch)=='T') numyes=1;
   else numyes=0;

   printf("Number elements ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') nuele=1;
   else nuele =0;

/* !!!the redfact is used to control the output graphic
    whether or not they are detached. */
   printf("Element reduction factor ? (0.0 - 1.0)\n");
   scanf("%f",&redfact);

   printf("Auto scale ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') autoscale=1;
   else autoscale=0;

   if (!autoscale){
		     printf("Scale factor ? \n");
		     scanf("%f",&sfs);
		  }

 /* function to read the mesh and subdomain data in */
   data();

  printf("\nplot single view ? (t/f)\n");
  scanf("%s",but);
  ch=but[0];
  if (toupper(ch)=='T') views=1;
  else views=0;

  if(views){
	     printf("View no 1/2/3/4 ?\n");
	     scanf("%d", &nomb);

	     switch (nomb)
		   {
		     case 1:
			nd1=1;
			nd2=2;
			ichan=7;
			isoyes=0;
			plot(ichan,nd1,nd2,isoyes);
			break;

		      case 2:
			 nd1=1;
			 nd2=3;
			 ichan=8;
			 isoyes=0;
			 plot(ichan,nd1,nd2,isoyes);
			 break;

		      case 3:
			 nd1=2;
			 nd2=3;
			 ichan=9;
			 isoyes=0;
			 plot(ichan,nd1,nd2,isoyes);
			 break;

		      case 4:
			 nd1=1;
			 nd2=1;
			 ichan=10;
			 isoyes=1;
			 plot(ichan,nd1,nd2,isoyes);
                         break;
		   }
	     }

		 printf("\n%f %f\n", aminer,amaxer);

    fclose(in);
    fclose(out);
    fclose(c100);
    fclose(eorr);
    fclose(decom);
    if(stres)  fclose(stress);
    free((float*)errorr);
    return 1 ;
 }

