#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <conio.h>
#include  <math.h>
#include  <graphics.h>
#define    XX  extern           /* set 'common' variables to extern */
#include  "plt.h"      /* header for Plot program */

#define   SCREEN   's'
#define   CALCOMP  'c'
#define   LASER    'l'
#define   PI        4.0*atan(1.0)

    float  xrange,yrange;
    float  sf1,sf2,xmax,ymax,xmin,ymin;
    float  cmxoff1,cmyoff1;
    /* Set palette colours  ---  Background always black.                */
    /* c[0-5] - black,white,yellow,green,brown.                          */
    /* rest are graded blue to red for stress grades.                    */
    int c[] = {0,63,62,2,20,9,17,25,11,43,7,61,45,37,44,36};

void  getgfloat(float *, float, float, char *);







/*  perform graphics routines  */
void plot()
{
		int   i,views,xpos,ypos,isoyes,nd[2], test_free;
		char  nomb,choice,another, buf[60], chr;
/*    bool  strss,def; */

    void  plotsize   ();                    /* sets window dimensions */
    void  grcord     (int , int []);
    void  scale      ();
    void  openg      ();
    void  nodnum     ();
    void  plottri    ();
    void  orthog     ();
    void  strsplot   (float);
    void  avstrsplot (float);
    void  dflnplot   (float);
    void  getgchoice (char *, float, float, char *);
    int   getgview   (char *,int,int,int [],bool *,char *);

/*    if (device == CALCOMP || device == LASER) { */  /* Set output file */
/*	char plotfile[]  = "pltn.plt";            */
/*	plotfile[3]      = (char) ich;            */  /* Substitute for n */
/*    }                                           */

    views = TRUE;
    printf("*******************************\n");
    printf("*For   Error   Plot  Enter [0]*\n");
    printf("*For Stress Sxx Plot Enter [1]*\n");
    printf("*For Stress Syy Plot Enter [2]*\n");
    printf("*For Stress Sxy Plot Enter [3]*\n");
    printf("*For Plain Mesh Plot Enter [4]*\n");
    printf("*For Domain Decomp   Enter [5]*\n");
    printf("*******************************\n");
    chr = getch();
    switch(chr){
    case '0' : idx = 0; break;
    case '1' : idx = 1; break;
    case '2' : idx = 2; break;
    case '3' : idx = 3; break;
    case '4' : idx = 4; break;
    case '5' : idx = 5; break;
    }
    if(idx == 0)
    {
    if(next != 1) strcat(file_name,".err");
    }
    if(idx == 1 || idx == 2 || idx == 3)
    {
    if(next != 1) strcat(file_name,".str");
    }
    if(idx == 5)
    {
    if(next != 1) strcat(file_name,".dec");
    }
    while (views) {
      plotsize ();                   /* set window dimensions for 'device' */
      openg();                       /* open graphics window, set palette
					and draw border                    */

      getgview (&nomb,10,320,nd,&isoyes," What view type ?  "
		   "(Plan/Front Elevation/End Elevation/Isometric;"
		   " P/F/E/I)");

      grcord (isoyes, nd);            /* Set up graphics coordinate array */

      scale ();                                       /* Set scale factor */

      if (device == SCREEN)
      {
		test_free = 0;
		if(idx == 0 || idx == 1 || idx == 2 || idx == 3 || idx == 5)
        { choice = 'a';
		if(next != 1)
		if((str=calloc(3*ne,sizeof(float)))== NULL)  /*allocate stress matrix*/
		{printf("out of core for ste\n");exit(1);}
		test_free = 1;}

	switch (choice)
	{
	  case 'd':                    /* Deflection profiles      */
	    dflnplot(redfact);
	    break;
	  case 'i':                    /* Inter-element stresses   */
	    strsplot(redfact);
	    break;
	  case 'a':                    /* Average element stresses */
	    avstrsplot(redfact);
	    break;
	  default:
	    break;
	}
	if(next != 1 && test_free == 1) free(str);
	nodnum ();                     /* Plot Elements */
	if (triang==TRUE)
	{
	  plottri ();}
/*	  plotquad();
	}
	If (cable)
	  pltcbl  ();
	if (string)
	  pltgst  (); */
      }
      getgchoice(&another,485,335," Another View  T/F ? ");
      if (another == 't')
	views = TRUE;
      else
	views = FALSE;
      closegraph();  	/* Close graphics window */
    }
    restorecrtmode();
}











/* Set window dimensions for 'device' */
void  plotsize ()
{
    switch(device)                   /* Set window dimensions   */
    {
      case SCREEN:                   /* EGA -- 640 x 350 pixels */
	twdowx = 639.00;
	twdowy = 315.00;
	break;
      case CALCOMP:
	twdowx = twdowy = 860;
	break;
      case LASER:
	twdowx = 250;
	twdowy = 200;
	break;
      default:
	printf ("\n\n  Invalid device type '%c' in function 'plot'\n",
		device);
	break;
    }
}

/*  Set up graphics coordinate array */
void grcord  (int isoyes, int nd[])
{
    float a[3], sang[3], cang[3],x,y,z;
    int   i;
    a[0] = 0.00;
    a[2] = 0.00;

	if(isoyes)
        {
/*
	getgfloat (&a[0],10,220," ");
	getgfloat (&a[2],10,200," ");
*/
	getgfloat(a,  10,220," Vert  < = ");
	getgfloat(a+2,10,200," Horiz < = ");

	a[1] = 0.00;
	for (i = 0; i < 3; i++) {
	    a[i] *= PI/180.00;
	    cang[i] = cos(a[i]);
	    sang[i] = sin(a[i]);
	}
	for (i = 0; i < nn; i++) {
	  x  =  cord[ndime*i+0];
	  y  =  cord[ndime*i+1];
	  z  =  cord[ndime*i+2];
	  tcor[2*i+0] = cang[1]*cang[2]*x - cang[1]*sang[2]*y + sang[1]*z;
	  tcor[2*i+1] = (sang[0]*sang[2]-cang[0]*sang[1]*cang[2])*x
		     + (sang[0]*cang[2]+cang[0]*sang[1]*sang[2])*y
		     +  cang[0]*cang[1]*z;
	}
    }
    else
	for (i = 0; i < nn; i++) {
	    tcor[2*i+0] = cord[ndime*i+nd[0]];
	    tcor[2*i+1] = cord[ndime*i+nd[1]];
	}
}


/*  Set up scale factors  */
void  scale  ()
{
    int    i;
    float  xd,yd;

    xmax = xmin = tcor[2*0+0];
    ymax = ymin = tcor[2*0+1];

    for (i = 0; i < nn; i++)  {
	xd = tcor[2*i+0];
	yd = tcor[2*i+1];
	if (xd < xmin)
	    xmin = xd;
	else if (xd > xmax)
	    xmax = xd;
	if (yd < ymin)
	    ymin = yd;
	else if (yd > ymax)
	    ymax = yd;
    }
    xrange =  xmax - xmin;
    yrange = (ymax - ymin) * 1.1;
    if (autoscale == TRUE) {
	if (xrange == 0.0)
	    sf1 = 1.0E+10;
	else
	    sf1 = (twdowx - 100.0)/xrange;
	if (yrange == 0.0)
	    sf2 = 1.0E+10;
	else
	    sf2 = (twdowy - 50.0)/yrange;
	(sf1 < sf2) ? (sf = sf1) : (sf = sf2);    }
    else
	sf = sfs;

    cmxoff1 = (twdowx - (sf*xrange))/2.0;         /* Set origin */
    cmyoff1 = (twdowy - (sf*yrange))/3.0;
    cmxoff2 = cmxoff1 - (sf*xmin) + 70;
    cmyoff2 = cmyoff1 - (sf*ymin) + 20;
}

/*  Open graphics window and draw border  */
void  openg  ()
{
    int   i, xc, g_driver, g_mode, g_error;

    g_driver = VGA;
    g_mode   = VGAHI;
/*    if (registerbgidriver(EGAVGA_driver) < 0)
    {
      printf("Error registering driver: EGAVGA\n");
      exit(1);
    }              */
    initgraph(&g_driver,&g_mode,"");
    g_error = graphresult();
    if (g_error < 0) {
      printf("\n initgraph error: %s --- subroutine openg\n",
				     grapherrormsg(g_error));
      exit(1);
    }
    for (i=0; i<16; ++i)
      setpalette(i,c[i]);

  /*    setbkcolor(EGA_WHITE); */

    setcolor(4);            /* brown */
    moveto(     0,     0);                    /* Draw Border */
    lineto(twdowx,     0);
    lineto(twdowx,twdowy);
    lineto(     0,twdowy);
    lineto(     0,     0);

    setcolor(1);            /* white */
    xc = (twdowx - textwidth(titel))/2;
    outtextxy(xc,8,titel);                  /* Print Title */
}

/* Number Nodes */
void nodnum()
{
    int   jt, xcoord, ycoord;

    if (numyes) {
      setcolor(2);          /* yellow */
      for (jt=0; jt<nn; ++jt)
      {
	char text[100];
	xcoord = (int)(cmxoff2 + sf*tcor[2*jt+0]);
	ycoord = (int)(twdowy - cmyoff2 - sf*tcor[2*jt+1]);
	sprintf(text,"%d",jt+1);
	settextstyle(SMALL_FONT,HORIZ_DIR,4);
	outtextxy(xcoord,ycoord,text);
      }
    }
}


/* Plot triangular elements */
void plottri()
{
    int   j,jj,nodref,xcoord,ycoord;
    int   n3,i;
    char  text[100];
    float xdif,ydif,x3,y3,xc,yc,xq,yq;

    if (nuele) {                        /* Number elements */
      setcolor(4);      /* brown */
	for (j=0; j<ne; ++j) {
	  xdif = 0.00;
	  ydif = 0.00;
	  for (jj=0; jj<3; ++jj) {
	    nodref = nod[4*j+jj] - 1;
	    xdif += tcor[2*nodref+0];
	    ydif += tcor[2*nodref+1];
	  }
	  xdif /= 3.0;
	  ydif /= 3.0;
	  xcoord = (int)(cmxoff2 + xdif*sf);
	  ycoord = (int)(twdowy  -  cmyoff2 - ydif*sf);
	  sprintf(text,"%d",j+1);
	  settextstyle(SMALL_FONT,HORIZ_DIR,4);
	  outtextxy(xcoord,ycoord,text);
	}
    }
    setcolor(3);            /* green */
    for (j=0; j<ne; ++j) {
     n3 = nod[4*j+2] - 1;
     x3 = tcor[2*n3+0];
     y3 = tcor[2*n3+1];
     if (redfact > 0.0) {         /* Find centre of element */
       xdif = ydif = 0.0;
       for (jj=0; jj<3; ++jj) {
	 nodref = nod[4*j+jj] - 1;
	 xdif += tcor[2*nodref+0];
	 ydif += tcor[2*nodref+1];
       }
       xc = xdif/3.00;
       yc = ydif/3.00;
       x3 += (xc-x3)*redfact;       /* Modify x3,y3 */
       y3 += (yc-y3)*redfact;
     }
     xcoord = (int)(cmxoff2 + x3*sf);
     ycoord = (int)(twdowy - cmyoff2 - y3*sf);
     moveto(xcoord,ycoord);
     for (i=0; i<3; i++) {
       nodref = nod[4*j+i] - 1;
       xq = tcor[2*nodref+0];
       yq = tcor[2*nodref+1];
       if (redfact > 0.0) {
	 xq += (xc-xq)*redfact;
	 yq += (yc-yq)*redfact;
       }
       xcoord = (int)(cmxoff2 + xq*sf);
       ycoord = (int)(twdowy - cmyoff2 - yq*sf);
       lineto(xcoord,ycoord);
     }
    }
}


/*  get plot option from screen */
void getgchoice (char *option,float xpos,float ypos, char *text)
{
    int    textlen;

    setcolor(1);      /* white */
    outtextxy(xpos,ypos,text);
    textlen = textwidth(text) + 3;

    *option = tolower(getch());
    outtextxy(xpos+textlen,ypos,option);
}

/*  get 'float' variable from screen */
void getgfloat (float *value,float xpos,float ypos, char *text)
{
    char         c[80];
    int          textlen;

    setcolor(1);      /* white */
    outtextxy(xpos,ypos,text);
    textlen = textwidth(text) + 5;

    gets(c);
    *value = atof(c);
    outtextxy(xpos+textlen,ypos,c);
}



/*  assign 'view type' variables  */
int getgview(char *view,int xpos,int ypos,int nd[],bool *iso,char *text)
{
    bool   valid;
    int    ch,textlen;

    settextstyle(SMALL_FONT,HORIZ_DIR,4);
    setcolor(1);     /* White */

    valid = FALSE;
    while (!valid) {

	outtextxy(xpos,ypos,text);
	textlen = textwidth(text) + 10;
	outtextxy(xpos+textlen,ypos,"                   ");
	if ((ch = getch()) != '\r')
	    *view = tolower(ch);

	valid = TRUE;                /* Until proved FALSE */
	switch (*view) {
	    case 'p':
		outtextxy(xpos+textlen,ypos,": Plan View");
		nd[0] = 0;
		nd[1] = 1;
		*iso  = FALSE;
		return(1);
	    case 'f':
		outtextxy(xpos+textlen,ypos,": Front Elevation");
		nd[0] = 0;
		nd[1] = 2;
		*iso  = FALSE;
		return(2);
	    case 'e':
		outtextxy(xpos+textlen,ypos,": End Elevation");
		nd[0] = 1;
		nd[1] = 2;
		*iso  = FALSE;
		return(3);
	    case 'i':
		outtextxy(xpos+textlen,ypos,": Isometric View");
		nd[0] = nd[1] = 0;
		*iso  = TRUE;
		return(4);
	    default:
		printf("\n\n View type '%c' is not valid \n",toupper(*view));
		valid = FALSE;
		return(0);
	}
   }
return(10000);
}


