
#include  <stdio.h>
#include  <ctype.h>
#define  XX  extern         /*  Set global variables to 'extern'  */
#include  "plt.h"  /*  Program specific header block */


/*  assign 'view type' variables  */
int getview(char *view, int nd[], bool *iso, char *text)
{
    bool valid;
    int  ch;

    printf("\n function 'getview' has been accessed \n");

    valid = FALSE;
    while (!valid) {

	printf ("%s:", text);

	if ((ch = getch()) != '\r')
	    *view = tolower(ch);

	valid = TRUE;                /* Until proved FALSE */
	switch (*view) {
	    case 'p':
		printf (" Plan View \n");
		nd[0] = 0;
		nd[1] = 1;
		*iso  = FALSE;
		return(1);
	    case 'f':
		printf (" Front Elevation \n");
		nd[0] = 0;
		nd[1] = 2;
		*iso  = FALSE;
		return(2);
	    case 'e':
		printf (" End Elevation \n");
		nd[0] = 1;
		nd[1] = 2;
		*iso  = FALSE;
		return(3);
	    case 'i':
		printf (" Isometric View \n");
		nd[0] = nd[1] = 0;
		*iso  = TRUE;
		return(4);
	    default:
		printf ("\n\n View type '%c' is not valid \n",toupper(*view));
		valid = FALSE;
		return(0);
	}
    }
return(1000);
}


