#define NEW 1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void nomask(int *mp, int *mn, int *maskno, int nelem);
void interf(int *mn, int *mp, int *me, int *maskno, int *maskin,
               int *locmask, int *inter, int *xinter, int nlabel,
               int ntot, int nsub, int numnod);


void autsub(int *mn, int *mp, int *nep, int *np, int numnod, int numele,
       int numpro, int *nw, int *ad, int *ap, int *me,int *mep, int *maskel,
       int *maskno, int *maskin, int *locmask, int *inter, int *xinter)
{
register i, j;
int lsub, nres, nlabel, nstop, minw, ntot, nstart, jstart, jstop,
    lc, nsub, node, nelem, mlabel = 0;

/*----- COMPUTE # OF ELEMENTS PER SUBDOMAIN */

lsub = numele/numpro;
nres = fmod(numele, numpro);
if(nres !=  0) lsub += 1;

/*------ FORM NW ARRAY */

for(i = 1; i <= numnod; i++)
nw[i] = np[i+1] - np[i];

/*-------INIT MASKEL & XINTER */

for(i = 1; i <= numele; i++)
maskel[i] = 0;

xinter[1] = 1;

/*-------- INIT MASKNO TO NW */

for(i = 1; i <= numnod; i++)
maskno[i] = nw[i];

nlabel = 0;
mlabel = 0;
nsub = 1;
mep[1] = 1;

/*------- LOCATE NODE WITH NEXT MIN. AVAILABLE WT. */

lab_310 :
nstop = nlabel;
minw = 999;
for(i = 1; i <= numnod; i++)
{
if(maskno[i] == 0) continue;
#if NEW
if(maskin[i] == 0 && nsub != 1) continue;
#endif
if(maskno[i] < minw){
  minw = maskno[i];
  node = i;
  }
}

/*------- INIT THE LIST WITH ELEMENTS ATTATCHED TO "NODE" */

ntot = 0;
for(i = 1; i <= nw[node]; i++)
{
j = np[node] + i - 1;
/*----- find an element attatched to "node */
nelem = nep[j];
if(maskel[nelem] == 1) continue;
ntot += 1;
maskel[nelem] = 1;
/*------- store info in "me" */
me[nlabel+ntot] = nelem;
/*------- reduce mask value for all nodes connected to this element */
nomask(mp, mn, maskno, nelem);
/*------- check for loop exit */
if(ntot == lsub) goto lab_710;
}

/*------- RECURSIVELY ADD TO LIST NEW ADJACENT ELEMENTS */

lab_600 :
nstart = nstop;
nstop = nlabel + ntot;
/*nnstart = nstart + 1;*/
for(i = nstart + 1; i <= nstop; i++)
{
jstart = ap[me[i]];
jstop  = ap[me[i]+1] - 1;
lc = 0;
   for(j = jstart; j <= jstop; j++)
   {
   nelem = ad[j];
   if(maskel[nelem] == 1) continue;
   lc += 1;
   ntot += 1;
   maskel[nelem] = 1;
   me[nlabel + ntot] = nelem;
   nomask(mp, mn, maskno, nelem);
   if(ntot == lsub)  goto lab_710;
   }
/*------- break eventual cycling (scattered subdomain) */
if(lc == 0 && ((nlabel +ntot) == nstop) && i == nstop){
  nlabel += ntot;
  goto lab_310;
  } 
} 
if((nlabel + ntot) == numele) goto lab_710;
if(ntot < lsub) goto lab_600;

/*------- MARK INTERFACE NODES */

lab_710 :
interf(mn,mp,me,maskno,maskin,locmask,inter,xinter,mlabel,
      (ntot+nlabel-mlabel),nsub,numnod);
nsub += 1;
nlabel += ntot;
mlabel = nlabel;
mep[nsub] = mep[nsub-1] + ntot;
/*------- continue with next subdomain */
if(nlabel < numele) goto lab_310;

}

void nomask(int *mp, int *mn, int *maskno, int nelem)
{
register i, istart, istop, inode;

istart = mp[nelem];
istop = mp[nelem + 1] - 1;

for(i = istart; i <= istop; i++)
{
inode = mn[i];
maskno[inode] = maskno[inode] - 1;
}

}

void interf(int *mn, int *mp, int *me, int *maskno, int *maskin,
               int *locmask, int *inter, int *xinter, int nlabel,
               int ntot, int nsub, int numnod)
{
register i;
int ip, is, istart, istop, ipos, nelem,
jstart, jstop, jpos, node;

for(i = 1; i <= numnod; i++)
locmask[i] = 0;
ip = 0;
is = xinter[nsub] - 1;
istart = nlabel + 1;
istop = nlabel + ntot;

for(ipos = istart; ipos <= istop; ipos++)
{
nelem = me[ipos];
jstart = mp[nelem];
jstop = mp[nelem + 1] - 1;
   for(jpos = jstart; jpos <= jstop; jpos++)
   {
   node = mn[jpos];
   if((maskno[node] != 0 || maskin[node] == 1) && locmask[node] == 0){
      maskin[node] = 1;
      locmask[node] = 1;
      ip += 1;
      inter[ip + is] = node;
      }
    }
}
xinter[nsub + 1] = xinter[nsub] + ip;

}



