 /* C version of the FORTRAN PLOTP.F77 program (SUN Unix)  */

#include <stdio.h>
#include <string.h>
#include <math.h>


/* Global variables */
int triang, cable, autoscale, sepele, string, err, stres, dec,eps;
int numyes, nuele,views;
char titel[100]; 
char *plotfile= NULL;
char device[2];
int plotline;
float sfs;
double dt,damp,brightness, red, green, blue;
int  nn,ne,nb,nm,nl,ndime,kt,nt,nstr,nbe,kmax,nmax,iln,nq;
double cord[25000][5];
int nod[30000][5], nodl[3000][4],nodq[10][5]; 
int mat[20];
double amat[20][10], dtl[3], dtt[3][3], ang[3], tr[3][3];
int nco[100][4], nc[30]; 
double  aload[30][3],tcor[25000][5], errorr[30000], ste[30000][5];
double  aminst, amaxst, amaxer, aminer;
int ipv, norm;
double b, af, cang[4], sang[4];
int ngs[90], nsnod[90][50];                 
double redfact, scalefac, shiftx, shifty;
char til[80];
/* double device; */
char calcomp[2], laser[2], screen[2];
int xxmax,xxmin,yymax,yymin;
/* char screen='s',laser='l',calcomp='c'; */
int nin=7, nout=8;

FILE *in,*out,*eorr,*stress,*c100;
int nxx;
/* declaring the functions */

int plot();  
int opench(); 
int setga(); 

int maxmin(); 
int setscale(); 
int openg(); 
int pborder();
int nodnum(); 
int elemno(); 
int elemno();
int elemno(); 
int psplottri(); 
int psplotquad(); 
int shaderr(); 
int shaderr1(); 
int getrgberr(); 
int shadste();
int getrgbstr(); 
int pltcb1(); 
int pltgst(); 
int closing();
int data();
int maxstr(); 
int maxerr();
int gsdata();
int index();
int shadedom(); 
int indexerrstr();

main()
{

double  twdowx,twdowy;
int nomb,isoyes,ichan;
char but[3];
char ch;
int nd1,nd2;


  if ((in=fopen("input.dat","r")) ==NULL){
       printf("Can nnot open file input\n");
       exit(1);
       }

  if ((out=fopen("plotout.dat","w")) ==NULL ){
       printf("Can not open file output\n");
       exit(1);
       }

  printf("Output device is postscript file pltf*.plt\n");

  printf("Plot encapsulted postscript file? (t/f)\n");
  scanf("%s",but);
  ch=but[0];
  if(toupper(ch)=='T') eps=1;
    else eps=0;

  printf("Brightness controll factor [0.]...[1.]\n");
  scanf("%lf",&brightness);

  printf("Plot membrane elements? (t/f)\n");
  scanf("%s",but);
    ch=but[0];
  if(toupper(ch) =='T') triang=1;
    else triang=0;

  printf("Plot element errors or Domain dec? (t/f)\n");
  scanf("%s",but);
  ch=but[0];
  if(toupper(ch) =='T') err=1;
  else err=0;

  if (err){
	   printf("Is this for domain decomposition plot ?(t/f)\n");
           scanf("%s",but);
	   ch= but[0];
	   if (toupper(ch)=='T') dec=1;
	   else dec=0;
	  }
 
 if (!dec) {
              printf("If color error plot w.r.t. max error is required [1]\n");
	      scanf("%d",&norm);

	      if(err==0)
			{
			  printf("plot stress? (t/f)\n");
			  scanf("%s",but);
                           ch=but[0];
			  if(toupper(ch)=='T') stres=1;
			  else stres=0;
			}
            }


   printf("Plot cable elements ? (t/f)\n");
   scanf("%s",but);   
   ch=but[0]; 
   if (toupper(ch)=='T') cable=1;
   else cable=0;

   printf("Plot g strings ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') string=1;
   else string=0;

   printf("number nodes ? (t/f)\n");
   scanf("%s",but);   
   ch=but[0];
   if(toupper(ch)=='T') numyes=1;
   else numyes=0;

   printf("Number elements ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') nuele=1;
   else nuele =0;

   printf("Element reduction factor ? (0.0 - 1.0)\n");
   scanf("%lf",&redfact);

   printf("Auto scale ? (t/f)\n");
   scanf("%s",but);
   ch=but[0];
   if (toupper(ch)=='T') autoscale=1;
   else autoscale=0;

   if (!autoscale){
		     printf("Scale factor ? \n");
		     scanf("%f",&sfs);
		  }

   data();

  printf("\nplot single view ? (t/f)\n");
  scanf("%s",but);
  ch=but[0];
  if (toupper(ch)=='T') views=1;
  else views=0;

  if(views){
	     printf("View no 1/2/3/4 ?\n");
	     scanf("%d", &nomb);

	     switch (nomb)
		   {
		     case 1:
			nd1=1;
			nd2=2;
			ichan=7;
			isoyes=0;
			plot(ichan,nd1,nd2,isoyes);
			break;

		      case 2:
			 nd1=1;
			 nd2=3;
			 ichan=8;
			 isoyes=0;
			 plot(ichan,nd1,nd2,isoyes);
			 break;

		      case 3:
			 nd1=2;
			 nd2=3;
			 ichan=9;
			 isoyes=0;
			 plot(ichan,nd1,nd2,isoyes);
			 break;

		      case 4:
			 nd1=1;
			 nd2=1;
			 ichan=10;
			 isoyes=1;
			 plot(ichan,nd1,nd2,isoyes);
                         break;
		   }
	     }

		 printf("\n%lf %lf %lf %lf\n", aminer,amaxer,aminst,amaxst); 

    fclose(in);
    fclose(out);
    fclose(c100);
    fclose(eorr);
    if(stres)  fclose(stress);

    return 1 ;
 }

/* this is to form a graphics function */

plot(ichan,nd1,nd2,isoyes) 
int ichan,nd1,nd2,isoyes;
{
double twdowx,twdowy,cmxoff2,cmyoff2,sf;
double xmin,ymin,xmax,ymax,xrange,yrange;
/* double linthick=0.2; */
/* int pen=2;
 */
int   kbug=0;
/* open channel to plotfile */
   opench( ichan, &twdowx, &twdowy);
   
/* set up graphics coordinate array */
   setga( isoyes, nd1, nd2);
    
/* find max min coordinate values */
   maxmin(xmin,xmax,ymin,ymax,xrange,yrange,&sf,twdowx,twdowy,&cmxoff2,&cmyoff2);
 
/* calculate the shift in origin and the scalefactor for ps */
   setscale(cmxoff2,cmyoff2);
  
/* open graphics window and clear screen */
   openg(kbug,sf);
   
   if (triang)
     {
       psplottri(sf);

       psplotquad(sf); 
     }

   if (cable) pltcb1(sf); 

   if (string) pltgst(sf);

   nodnum(kbug,sf);

   elemno(sf);

   if(dec!=1) indexerrstr();

   closing();
   return 1;
}


/* open channel to plotfile */

opench(ichan,twdowx,twdowy) 
int ichan;
double *twdowx,*twdowy;
{
 int linlas=1; /* linscr=5 */
 int ich;
 plotline=linlas;
 *twdowx=250.00;
 *twdowy=200.00;
 ich=ichan-6;

  switch (ich)
  {

   case 1:
    plotfile="pltf1.plt";

    break;

    case 2:
     plotfile="pltf2.plt";
    break;

    case 3:
     plotfile="pltf3.plt";
     break;

     case 4:
     plotfile="pltf4.plt";
      break;
   }

 return 1;
}

/* set up graphics coordinate array */
setga(isoyes,nd1,nd2) 
int isoyes,nd1,nd2;
{
 int i;
 double pi;
 double a1,a2,a3;

 if(isoyes)  printf("\nisoyes= true");
 else printf("\nisoyes=falese");

 if(isoyes)
  {
   printf("input vertical angle");
   scanf("%lf",&a1);
   printf("input horizontal angle");
   scanf("%lf",&a3);
   a2=0;
   pi=4.0*atan(1);
   a1=a1*pi/180;
   a2=a2*pi/180;
   a3=a3*pi/180;
   cang[1]=cos(a1);
   sang[1]=sin(a1);
   cang[2]=cos(a2);
   sang[2]=sin(a2);
   cang[3]=cos(a3);
   sang[3]=sin(a3);

   for(i=1;i<=nn;i++)
     {
       tcor[i][1]=cang[2]*cang[3]*cord[i][1]-cang[2]*sang[3]*cord[i][2]+sang[2]*cord[i][3];
       tcor[i][2]=(sang[1]*sang[3]-cang[1]*sang[2]*cang[3])*cord[i][1]+(sang[1]*cang[3]+cang[1]*sang[2]*sang[3])*cord[i][2]+cang[2]*cord[i][3];
     }
   }
   else
    {
      for(i=1;i<=nn;i++)
       {
	 tcor[i][1]=cord[i][nd1];
	 tcor[i][2]=cord[i][nd2];
       }
     }
 return 1;
}

/* find max and min coordinate values */
 
maxmin(xmin,xmax,ymin,ymax,xrange,yrange,sf,twdowx,twdowy,cmxoff2,cmyoff2)
double xmin,xmax,ymin,ymax,xrange,yrange,twdowx,twdowy;
double *sf,*cmxoff2,*cmyoff2;
{
 int j;
 double xd,yd;
 double sf1,sf2,cmxmin,cmymin,cmxrng,cmyrng,cmxoff1,cmyoff1;
 xmax=tcor[1][1];
 xmin=tcor[1][1];
 ymin=tcor[1][2];
 ymax=tcor[1][2];
 for(j=1;j<=nn;j++)
  {
   xd=tcor[j][1];
   yd=tcor[j][2];
   if(xd<xmin) xmin=xd;
   else if(xd>xmax) xmax=xd;
   if(yd<ymin) ymin=yd;
   else if(yd>ymax) ymax=yd;
  }

 xrange=xmax-xmin;
 yrange=(ymax-ymin)*1.1;
 if(autoscale)
  {
    if(xrange==0) sf1=1.0e+10;
    else sf1=(twdowx-(20.0e+00))/xrange;

    if(yrange==0) sf2=1.0e+10;
    else sf2=(twdowy-(20.0e+00))/yrange;

    if(sf1<sf2) *sf=sf1;
    else *sf=sf2;
  }
 else *sf=sfs;

 cmxrng=*sf*xrange;
 cmyrng=*sf*yrange;
 cmxmin=*sf*xmin;
 cmymin=*sf*ymin;
 cmxoff1=(twdowx-cmxrng)/2;
 cmyoff1=(twdowy-cmyrng)/3;
 *cmxoff2=cmxoff1-cmxmin;
 *cmyoff2=cmyoff1-cmymin;
 fprintf(out,"\n\n max min values:    %lf    %lf    %lf    %lf", xmin,xmax,ymin,ymax);

 return 1;
}

 setscale(cmxoff2,cmyoff2) 
double cmxoff2,cmyoff2;
{
 scalefac=72.0/25.4/0.24;
 shiftx=cmxoff2*scalefac;
 shifty=cmyoff2*scalefac;

 return 1;
}

 openg(kbug,sf) 
 int kbug;
 double sf;
{
 if(kbug>2) printf("   %s   opened",plotfile);
/* draw border call sr pboder to set up ps instructions to draw border */
 pborder(sf);
 return 1;
}


/* function pborder */
pborder(sf)
double sf;
{
 int j,jj,i;
 int n3,ix3,iy3;
 double xc,yc,x3,y3,xq,yq,xdif,ydif;
 int np,ixq,iyq,x1,y1,x2,y2;
 char ch='%';
  if((c100=fopen(plotfile,"w"))==NULL)
    {
      printf("Can not open file");
      exit(1);
     }

  x1=10000;
  x2=0;
  y1=10000;
  y2=0;

  for(j=1;j<=ne;j++)
    {
      for(i=1;i<=3;i++)
          {
            np=nod[j][i];
            xq=tcor[np][1];
            yq=tcor[np][2];
            xq=sf*xq*scalefac+shiftx;
            yq=sf*yq*scalefac+shifty;
            ixq=(int)(xq);
            iyq=(int)(yq);

          if(redfact>0)
             {
              
              xdif=0;
              ydif=0;
              for(jj=1;jj<=3;jj++)
                  {
                    xdif=xdif+tcor[nod[j][jj]][1];
                    ydif=ydif+tcor[nod[j][jj]][2];
                  }
                xc=xdif/3;
                yc=ydif/3;

               np=nod[j][i];
               xq=tcor[np][1];
               yq=tcor[np][2];
               xq=xq+(xc-xq)*redfact;
               yq=yq+(yc-yq)*redfact;
               xq=sf*xq*scalefac+shiftx;
               yq=sf*yq*scalefac+shifty;
               ixq=(int)(xq);
               iyq=(int)(yq);
               }
         if(x1>ixq) x1=ixq;
         if(x2<ixq) x2=ixq;
         if(y1>iyq) y1=iyq;
         if(y2<iyq) y2=iyq;

            }
       }  
                  

  x1=(int)(x1*0.24-2);
  x2=(int)(x2*0.24+2);
  y1=(int)(y1*0.24-2);
  y2=(int)(y2*0.24+2);
  fprintf(c100,"%%!ps-adobe-2.0 epsf-2.0\n%%%cBoundingBox:  %d %d %d %d \n/l {lineto} def  /m {moveto} def ",ch,x1,y1,x2,y2);
  printf("\nEnter the title:");
   scanf("%s",til);

/* fprintf(c100,"\n/small /Times-Roman findfont 55 scalefont def");
 fprintf(c100,"\n/normal /Times-Roman findfont 65 scalefont def");
 fprintf(c100,"\n/large /Times-Roman findfont 80 scalefont def");
 fprintf(c100,"\n/bold /Times-Bold findfont 60 scalefont def"); */

  fprintf(c100," \n/helvetica findfont 30 scalefont setfont");
  fprintf(c100,"\n0.20  0.20  scale \nnewpath");

  
   
  return 1;
}

/* function to number nodes nodnum(kbug,sf,cmxoff2,cmyoff2)  */

 nodnum(kbug,sf) 
int kbug;
double sf;

{
 int jt;
/* int ixo,iyo; */
 double x,y;
 int ix,iy;

 if(numyes)
  {
/*    ixo=(int)(shiftx);
      iyo=(int)(shifty);
*/

    fprintf(c100," \n/helvetica findfont    10 0.24 div scalefont setfont ");

    for(jt=1;jt<=nn;jt++)
     {
   
	 x=sf*tcor[jt][1]*scalefac+shiftx;
	 y=sf*tcor[jt][2]*scalefac+shifty;
	 ix=(int)(x);
	 iy=(int)(y);
	 fprintf(c100,"\n%d %d  m ( %d ) show", ix,iy,jt);
	 

       if(kbug>2) fprintf(out,"\n tcor[%d][*]     %lf      %lf",jt,tcor[jt][1],tcor[jt][2]);
      }
   }

 return 1;
}

/* mark elements if required */
 elemno(sf)
double sf;

{
 int j,jj;
 double xdif,ydif;
 int ixdif,iydif;
 int kbug=0;

 if(nuele)
  {
   for(j=1;j<=ne;j++)
    {
      xdif=0.0e+0;
      ydif=0.0e+0;

      for(jj=1;jj<=3;jj++)
       {
	 xdif=xdif+tcor[nod[j][jj]][1];
	 ydif=ydif+tcor[nod[j][jj]][2];
       }

	 xdif=sf*xdif/3*scalefac+shiftx;
	 ydif=sf*ydif/3*scalefac+shifty;

	 ixdif=(int)(xdif);
	 iydif=(int)(ydif);

	 fprintf(c100,"\n%d %d m ( %d ) show", ixdif,iydif,j);
	 if(kbug>2) fprintf(out,"\n xdif ydif :     %lf    %lf",xdif,ydif);
   }

  }

 return 1;
}

/* plot triangular elements in ps file */
 psplottri(sf) 
 double sf;

{
 int j,jj,i;
 int n3,ix3,iy3,ixq,iyq;
 double xc,yc,x3,y3,xq,yq,x,y,xdif,ydif;
 int np;
 int kbug=0;
 int x1,x2,y1,y2,xu,yu,xl,yl,pig;

 xxmax=0;
 xxmin=10000;
 yymax=0;
 yymin=10000;
 
/* plot elements */
for(j=1;j<=ne;j++)
 {
   n3=nod[j][3];
   x3=tcor[n3][1];
   y3=tcor[n3][2];
   x=sf*x3*scalefac+shiftx;
   y=sf*y3*scalefac+shifty;
   ix3=(int)(x);
   iy3=(int)(y);
   if(redfact>0)
   {
    xdif=0.0e+0;
    ydif=0.0e+0;
    for(jj=1;jj<=3;jj++)
      {
	xdif=xdif+tcor[nod[j][jj]][1];
	ydif=ydif+tcor[nod[j][jj]][2];
       }
     xc=xdif/3;
     yc=ydif/3;

/* modify x3 y3 */
   x3=x3+(xc-x3)*redfact;
   y3=y3+(yc-y3)*redfact;
   x3=sf*x3*scalefac+shiftx;
   y3=sf*y3*scalefac+shifty;
   ix3=(int)(x3);
   iy3=(int)(y3);
  }

  fprintf(c100,"\n%d %d m",ix3,iy3);
  if(xxmax<ix3) xxmax=ix3;
  if(xxmin>ix3) xxmin=ix3;
  if(yymax<iy3) yymax=iy3;
  if(yymin>iy3) yymin=iy3;

  for(i=1;i<=3;i++)
     {
      np=nod[j][i];
      xq=tcor[np][1];
      yq=tcor[np][2];
      xq=sf*xq*scalefac+shiftx;
      yq=sf*yq*scalefac+shifty;
      ixq=(int)(xq);
      iyq=(int)(yq);
      if(redfact>0)
	{
	  np=nod[j][i];
	  xq=tcor[np][1];
	  yq=tcor[np][2];
	  xq=xq+(xc-xq)*redfact;
	  yq=yq+(yc-yq)*redfact;
	  xq=sf*xq*scalefac+shiftx;
	  yq=sf*yq*scalefac+shifty;
	  ixq=(int)(xq);
	  iyq=(int)(yq);
	 }

       fprintf(c100,"\n%d %d l",ixq,iyq);
       if(xxmax<ixq) xxmax=ixq;
       if(xxmin>ixq) xxmin=ixq;
       if(yymax<iyq) yymax=iyq;
       if(yymin>iyq) yymin=iyq;

    }

    if (err||stres)
     {
       if(dec!=1)
       {
	  if(norm==1) shaderr1(j);
	    else shaderr(j);
 
  
	    shadste(j);
	}
	else shadedom(j);
      }

      else fprintf(c100,"\n  stroke");

 }

 x1=(int)((xxmin*0.24-2)/0.24);
 x2=(int)((xxmax*0.24+2)/0.24);
 y1=(int)((yymin*0.24-2)/0.24);
 y2=(int)((yymax*0.24+2)/0.24);
 xu=x1;
 yu=(int)((yymax*0.24+4)/0.24);
 xl=(int)((xxmin*0.24+5)/0.24);
 yl=(int)((yymin*0.24-20)/0.24);



 if(!eps)
 {
 fprintf(c100,"\nnewpath \n%d  %d m\n%d  %d l\n%d  %d l\n%d  %d l\nclosepath stroke",x1,y1,x2,y1,x2,y2,x1,y2);
 fprintf(c100,"\n%d %d  m  \nnormal setfont (TITEL:%s)  show 2 setlinewidth stroke",xu,yu,til);
 printf("Input figure number:");
 scanf("%d",&pig);

 fprintf(c100,"\n%d %d m \nbold setfont (FIG.%d:) show ",xl,yl,pig);
 fprintf(c100,"\n%d %d m \nsmall setfont (subdomains(%d elements) patitioned using SGM) show",xl+250,yl,ne); 
/* fprintf(c100,"\n%d %d translate",x1,y1);*/
}
return 1;
}

/* plot rect elements in ps file */
/* psplotquad(sf) */
 psplotquad(sf) 
 double sf; 

{
 int j,i,jj;
 int n4,ix,iy,ixq,iyq;
 double x4,y4,xdif,ydif,xc,yc,xq,yq;
 double x,y;/* kbug=0; */
 int np; 
 char *chstr=NULL;
 int kbug=0;
 /* plot elements */
if (nq>0) {
 for(j=1;j<=nq;j++)
   {
    n4=nod[j][4];
    x4=tcor[n4][1];
    y4=tcor[n4][2];
    x=sf*x4*scalefac+shiftx;
    y=sf*y4*scalefac+shifty;
    ix=(int)(x);
    iy=(int)(y);
    if(redfact>0)
      {
 /* find the center of element */
	xdif=0.0e+0;
	ydif=0.0e+0;
	for(jj=1;jj<=4;jj++)
	 {
	  xdif=xdif+tcor[nod[j][jj]][1];
	  ydif=ydif+tcor[nod[j][jj]][2];
	 }
	 xc=xdif/4;
	 yc=ydif/4;
 /* modify x3 y3 */
	 x4=x4+(xc-x4)*redfact;
	 y4=y4+(yc-y4)*redfact;
	 x4=sf*x4*scalefac+shiftx;
	 y4=sf*y4*scalefac+shifty;
	 ix=(int)(x4);
	 iy=(int)(y4);
       }
    fprintf(c100,"\n%d %d m",ix,iy);

    for(i=1;i<=4;i++)
       {
	np=nod[j][i];
	xq=tcor[np][1];
	yq=tcor[np][2];
	xq=sf*xq*scalefac+shiftx;
	yq=sf*yq*scalefac+shifty;
	ixq=(int)(xq);
	iyq=(int)(yq);
	if(redfact>0)
	  {
	    np=nod[j][i];
	    xq=tcor[np][1];
	    yq=tcor[np][2];
	    xq=xq+(xc-xq)*redfact;
	    yq=yq+(yc-yq)*redfact;
	    xq=sf*xq*scalefac+shiftx;
	    yq=sf*yq*scalefac+shifty;
	    ixq=(int)(xq);
	    iyq=(int)(yq);
	   }
	 fprintf(c100,"\n %d %d  l ", ixq,iyq);
	}

     if(err||stres)
      {
       if(norm==1)
	  shaderr1(j);
	  else shaderr(j);

       shadste(j);
      }
      else fprintf(c100,"   stroke");
  }

  if(norm==1)
   {
    fprintf(c100," \n/times-roman findfont 50 scalefont setfont\n 1200 0 m (relative error plot max error=%lf%) show",amaxer);
   }
   else
    {
     if(err)
       {
	 if(dec) goto c;
	  else fprintf(c100,"\n /times-roman findfont 50 scalefont setfont\n 1200 0 m (error plot) show");

       }

     if(stres)
       {
	switch (ipv)
	{
	  case 1: chstr="xx";
	  break;
	  case 2: chstr="yy";
	  break;
	  case 3: chstr="xy";
	  break;
	  case 4: chstr="map-p";
	  break;
	  case 5: chstr="min-p";
	  break;
	 }
	fprintf(c100,"\n 0 10 m /times-roman findfont 50 scalefont setfont\n (100% stress=%5c=%lf) show",chstr,amaxst);
	fprintf(c100," \n 1200 10 m (stress plot ) show");
       }
   }
}
c:   return 1;

}

/* shade the elements with respect to specified parameter */
/* function shaderr(j) */
shaderr(j) 
int j;


{
 double shade;

 if(err)
  {
   if(dec) errorr[j]=10*errorr[j];
   if(abs(errorr[j]>1)) shade=0.0;
   if(abs(errorr[j]<1)) shade=0.1;
   if(abs(errorr[j]<0.9)) shade=0.2;
   if(abs(errorr[j]<0.8)) shade=0.3;
   if(abs(errorr[j]<0.7)) shade=0.4;
   if(abs(errorr[j]<0.6)) shade=0.5;
   if(abs(errorr[j]<0.5)) shade=0.6;
   if(abs(errorr[j]<0.4)) shade=0.7;
   if(abs(errorr[j]<0.3)) shade=0.8;
   if(abs(errorr[j]<0.2)) shade=0.9;
   if(abs(errorr[j]<0.1)) shade=1.0;

   fprintf(c100,"\n closepath gsave %lf setgray fill grestore stroke",shade);
   fprintf(c100,"\n 0.0 setgray");
  }
return 1;
}

/* shade the elements with respect to specified parameter
   function shaderr1(j)
*/
 shaderr1(j) /*(int j) */
int j;


{
 double shade;

  amaxer=1.0;
 if((abs(errorr[j]/amaxer))>=1.0) shade=0.0;
 if((abs(errorr[j]/amaxer))<1.0) shade=0.1;
 if((abs(errorr[j]/amaxer))<0.9) shade=0.2;
 if((abs(errorr[j]/amaxer))<0.8) shade=0.3;
 if((abs(errorr[j]/amaxer))<0.7) shade=0.4;
 if((abs(errorr[j]/amaxer))<0.6) shade=0.5;
 if((abs(errorr[j]/amaxer))<0.5) shade=0.6;
 if((abs(errorr[j]/amaxer))<0.4) shade=0.7;
 if((abs(errorr[j]/amaxer))<0.3) shade=0.8;
 if((abs(errorr[j]/amaxer))<0.2) shade=0.9;
 if((abs(errorr[j]/amaxer))<0.1) shade=1.0;

 getrgberr(errorr[j]);

 fprintf(c100,"\nclosepath gsave  %lf setgray fill \ngrestore strok",shade);
 fprintf(c100,"\nclosepath gsave   %lf  %lf  %lf setgbcolor fill \ngrestore stroke",red,green,blue);
 fprintf(c100,"\n0.0 setgray");

return 1;
}

/* function getrgberr(evalue)  */
 getrgberr(evalue) 
double evalue;

{
  double btf;
  double colfac1,colfac2,colfac3,amaxstr;

  amaxstr=amaxer;
  btf=1.0-brightness;

  red=1.0;
  green=0.0;
  blue=1.0;
  colfac1=1.0-red;
  colfac2=1.0-green;
  colfac3=1.0-blue;
  red = 1. -  pow(  (evalue/amaxstr*colfac1) , btf );
  green=1. -  pow(  (evalue/amaxstr*colfac2) , btf);
  blue=  1. - pow(   (evalue/amaxstr*colfac3), btf);

  return 1;
}
/* shade the elements with respect to specified stress */

shadste(i) /*(int i)  */
int i;
{
 double shade;

 if(stres)
   {
amaxst=1.0;     
if(abs(abs(ste[i][ipv])/amaxst)>=1) shade=0.0;
     if(abs(abs(ste[i][ipv])/amaxst)<1) shade=0.1;
     if(abs(abs(ste[i][ipv])/amaxst)<0.9) shade=0.2;
     if(abs(abs(ste[i][ipv])/amaxst)<0.8) shade=0.3;
     if(abs(abs(ste[i][ipv])/amaxst)<0.7) shade=0.4;
     if(abs(abs(ste[i][ipv])/amaxst)<0.6) shade=0.5;
     if(abs(abs(ste[i][ipv])/amaxst)<0.5) shade=0.6;
     if(abs(abs(ste[i][ipv])/amaxst)<0.4) shade=0.7;
     if(abs(abs(ste[i][ipv])/amaxst)<0.3) shade=0.8;
     if(abs(abs(ste[i][ipv])/amaxst)<0.2) shade=0.9;
     if(abs(abs(ste[i][ipv])/amaxst)<0.1) shade=1.0;

     getrgbstr(ste[i][ipv]);

     printf("%lf %lf",red,green);
     fprintf(c100,"\nclosepath gsave %lf setgray fill \ngrestore stroke",shade);
     fprintf(c100,"\nclosepath gsave  %lf  %lf  %lf setrgbcolor fill \ngrestore stroke",red,green,blue);

     fprintf(c100,"\n0.0 setgray ");
   }

  return 1;
}

/* set rgb colours for stresses */
/* function getrgbstr */
 getrgbstr(esvalue) 
double esvalue;
{
  double btf;
  double amaxstr,colfac1,colfac2,colfac3;
  amaxstr=abs(aminst);
  if(abs(amaxst)>abs(aminst)) amaxstr=abs(amaxst);

  btf=1-brightness;

amaxstr=1.0;
  if(esvalue<0)
  {
    red=1.0;
    green=0.0;
    blue=0.0;
    colfac1=1.0-red;
    colfac2=1.0-green;
    colfac3=1.0-blue;
    amaxstr=-1.0*amaxstr;
    red=1.0-pow( (esvalue/amaxstr*colfac1), btf);   
    green=1.0-pow( (esvalue/amaxstr*colfac2), btf);          
    blue=1.0-pow(  (esvalue/amaxstr*colfac3), btf);           
   }
   else
    {
      red=0.0;
      green=1.0;
      blue=0.0;
      colfac1=1.0-red;
      colfac2=1.0-green;
      colfac3=1.0-blue;
      red=1.0-pow( (esvalue/amaxstr*colfac1), btf);         
      green=1.0-pow( (esvalue/amaxstr*colfac2),btf);         
      blue=1.0-pow(  (esvalue/amaxstr*colfac3),btf);           
   }
  return 1;
}

/* plot cable elements */
/* function pltcbl(sf) */
 pltcb1(sf)
double sf;
{
  int j,n3;
  double x3,y3,xq,yq;
  int ix,iy,ixq,iyq;
  if(nl>0)
    {
      fprintf(c100,"\n  stroke newpath");

      for(j=1;j<=nl;j++)
	{
	  n3=nodl[j][2];
	  x3=sf*tcor[n3][1]*scalefac+shiftx;
	  y3=sf*tcor[n3][2]*scalefac+shifty;
	  ix=(int)(x3);
	  iy=(int)(y3);

	  nq=nodl[j][1];
	  xq=sf*tcor[nq][1]*scalefac+shiftx;
	  yq=sf*tcor[nq][2]*scalefac+shifty;
	  ixq=(int)(xq);
	  iyq=(int)(yq);
	  fprintf(c100,"\n %d %d m %d %d l",ix,iy,ixq,iyq);
	}

     fprintf(c100,"\n1   setlinecap ");
     fprintf(c100,"\n20   setlinewidth stroke");
  }

 return 1;
}

/* plot geodesic strings */
/* funnction pltgst(sf) */
  pltgst(sf) 
double sf;
{
  int j,jx;
  double x3,y3;
  int nsu,nr,ix,iy;

  if(nstr>0)
    {
      fprintf(c100,"\n stroke newpath ");

      for(j=1;j<=nstr;j++)
	{
	  nsu=ngs[j];
	  nr=nsnod[j][1];
	  x3=sf*tcor[nr][1]*scalefac+shiftx;
	  y3=sf*tcor[nr][2]*scalefac+shifty;
	  ix=(int)(x3);
	  iy=(int)(y3);
	  fprintf(c100," \n%d %d m",ix,iy);

	  for(jx=2;jx<=(nsu+1);jx++)
	    {
	      nr=nsnod[j][jx];
	      x3=sf*tcor[nr][1]*scalefac+shiftx;
	      y3=sf*tcor[nr][2]*scalefac+shifty;
	      ix=(int)(x3);
	      iy=(int)(y3);
	      fprintf(c100,"\n%d %d m",ix,iy);
	     }
	 }

     fprintf(c100,"\nclosepath 3 setlinewidth");

  }

  return 1;
}

/* function closing */
 closing()
{
  if(err || stres) fprintf(c100,"\nshowpage");
  else fprintf(c100,"\n stroke 4.2 4.2 scale\nshowpage");
  return 1;
}

 data()

{
  int l,n1,iq,k,i,ii,n,jj,jj1;
  double fnn,fne,fnb,fnm,fnl,fndime,fnstr,fnbe,fkmax,fnmax,filn,fnq,fn;
  double fnx,nd11,nd22,nd33,nd44,fn1,fm;
  char buff[80];
  

  fgets(titel,80,in);
  fprintf(out,"\n\n data and results \n  %s", titel);
  if(fscanf(in,"%lf%lf",&dt,&damp)!=2)  printf("read error 1");
  fprintf(out,"\n timestep  dt=%lf     damp=%lf", dt,damp);
 
if(fscanf(in,"%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf",&fnn,&fne,&fnb,&fnm,&fnl,&fndime,&fnstr,&fnbe,&fkmax,&fnmax,&filn)!=11)
  printf("read errorr 2");
  fscanf(in,"%f",&fnq);

   nn=(int)(fnn);
   ne=(int)(fne);
   nb=(int)(fnb);
   nm=(int)(fnm);
   nl=(int)(fnl);
   ndime=(int)(fndime);
   nstr=(int)(fnstr);
   nbe=(int)(fnbe);
   kmax=(int)(fkmax);
   nmax=(int)(fnmax);
   iln=(int)(filn);
   nq=(int)(fnq);

  fprintf(out,"\n no of nodes=%d\n no of elements=%d",nn,ne);
  fprintf(out,"\n no of restrainted boundary nodes=%d\n no of material types=%d",nb,nm);
  fprintf(out,"\n no of links=%d\n no of dimensions=%d\n no of strs=%d\n no beams=%d",nl,ndime,nstr,nbe);
  fprintf(out,"\n no of itgrps=%d\n no of itbtwp=%d",kmax,nmax);
  fprintf(out,"\n\n no of quadrilaterals=%d",nq);
  fprintf(out," \n0 if no loads=%d",iln);
  printf("%d",iln);
  for (l=1;l<=nn; l++)
    {
      fscanf(in,"%lf",&fn);


    n=(int)(fn);
     for (i=1;i<=(ndime+1);i++)
      {
       fscanf(in,"%lf",&cord[n][i]);
       }
    }

  for(n1=1;n1<=nn;n1++)
    {
      fprintf(out,"\n node=%d                cords=",n1);
       for(i=1;i<=ndime;i++)
	  {
	    fprintf(out,"    %lf ", cord[n1][i]);
	  }
     }

  if (ne>0)
    {
		 for(jj=1;jj<=ne;jj++)
		   {
                      
              
		      fscanf(in,"%lf%lf%lf%lf",&fnx,&nd11,&nd22,&nd33);
                      fgets(buff,80,in); 
                       nd44=1.0;
                       nxx=(int)(fnx);
                       nod[jj][1]=(int)(nd11);
                       nod[jj][2]=(int)(nd22);
                       nod[jj][3]=(int)(nd33);
                       nod[jj][4]=(int)(nd44); 
		    
                     
		    }

                 for(jj1=1;jj1<=ne;jj1++)
                    {
                      fprintf(out,"\n element =%d node1=%d node2=%d node3=%d mat no=%d\n",jj1,nod[jj1][1],nod[jj1][2],nod[jj1][3],nod[jj1][4]);
                     }
      }

  if (nl>0){
		 for(l=1;l<=nl;l++)
		    {
		       fscanf(in,"%d%d%d%d", &n,&nodl[l][1],&nodl[l][2],&nodl[l][3]);
		       fprintf(out,"\n link=%d   nod1=%d   node2=%d    mat no=%d",n,nodl[n][1],nodl[n][2],nodl[n][3]);
		    }
	    }

  if (nq>0){
		 fprintf(out,"\n Quadrilateral elements\n element           nodal topology           material no");
		 for(iq=1;iq<=nq;iq++)
		    {
		       fscanf(in,"%d%d%d%d%d%d",&n,&nodq[n][1],&nodq[n][2],&nodq[n][3],&nodq[n][4],&nodq[n][5]);
		       fprintf(out,"   %d     %d %d %d %d      %d", n,nodq[iq][1],nodq[iq][2],nodq[iq][3],nodq[iq][4],nodq[iq][5]);
		     }
	    }


   fprintf(out,"\n material data");

   for(l=1;l<=nm;l++){
		       fscanf(in,"%lf %lf %lf %lf %lf %lf %lf",&fn1,&fm,&amat[l][1],&amat[l][2],&amat[l][3],&amat[l][4],&amat[l][5]);
                       n=(int)(fn1);
                       mat[l]=(int)(fm);   
           	       fprintf(out," \nmaterial number %d   %d        %lf   %lf   %lf   %lf   %lf",n,mat[n],amat[n][1],amat[n][2],amat[n][3],amat[n][4],amat[n][5]);
		     }

   for(n=1;n<=nb;n++){
		       for(i=1;i<=(ndime+1);i++)
			{
			  fscanf(in,"%d ", &nco[n][i]);
			}
		      }
   fprintf(out,"\n  boundary conditions");
   for(n=1;n<=nb;n++){
		       for(i=1;i<=(ndime+1);i++)
			{
			  fprintf(out," node=%d",nco[n][i]);
			 }
		      }

/* read in the applied loads put in f array
   remember must have last line for last node even if no applied load */

   fprintf(out,"\n\n\n  loading conditions\n");

   if(iln>0){
	     iln=0;
  a:	     iln=iln+1;
	     i=iln;
	     fscanf(in,"%d ",&nc[i]);
	      for(ii=1;ii<=ndime;ii++)
		{
		   fscanf(in,"%lf",&aload[i][ii]);
		 }

	     fprintf(out,"node=%d",nc[i]);

	       for(ii=1;ii<=ndime;ii++)
		 {
		    fprintf(out,"%lf",aload[i][ii]);
		 }

	     if(nc[i]<nn) goto a;
	     }

    if(nstr>0) gsdata();

/* open and read error file */

    if(err){
	     if((eorr=fopen("error.dat","r"))==NULL){
		printf("Can not open file\n");
		exit(1);
		}
	      for (k=1;k<=ne;k++)
		 {
		   fscanf(eorr,"%lf",&errorr[k]);
		   if(norm==1) maxerr();
		      else errorr[k]=errorr[k]/100;
		  }
	      }

/* open and read stress file */

  if(stres){
	     if((stress=fopen("stress.dat","r"))==NULL)
	     {
		printf("Can not open file\n");
		exit(1);
	      }
	      printf(" Enter 1 2 3 4 5 for sx sy sxy smax smin\n");
	      scanf("%d",&ipv);

	      for (k=1;k<=ne;k++)
		{
		  fscanf(stress,"%lf %lf %lf %lf %lf", &ste[k][1],&ste[k][2],&ste[k][3],&ste[k][4],&ste[k][5]);
		}

	   }

    maxstr(ipv);
    return 1;
 }

 maxstr(ipv) 
int ipv;
{
 int i;
 amaxst=1.0e-10;

 for(i=1;i<=ne;i++)
     {
	if(amaxst<ste[i][ipv]) amaxst=ste[i][ipv];
	aminst=amaxst;
      }

 for(i=1;i<=ne;i++)
      {
	 if(aminst>ste[i][ipv]) aminst=ste[i][ipv];
       }

  return 1;
}

 maxerr()
{
  int i;
  amaxer=errorr[1];

  for(i=1;i<=ne;i++)
      {
	 if(amaxer<abs(errorr[i]))  amaxer=abs(errorr[i]);
	 aminer=amaxer;
      }

   for(i=1;i<=ne;i++)
      {
	  if(aminer>abs(errorr[i])) aminer=abs(errorr[i]);
      }

    return 1;
}


 gsdata()
{
  int j,jd;

  for(j=1;j<=nstr;j++)
     {
       fscanf(in,"%d",&ngs[j]);
       fprintf(out," string no=%d   no of links=%d\n  string node:",j,ngs[j]);
       for(jd=1;jd<=(ngs[j]+1);jd++)
       {
	 fscanf(in,"%d",&nsnod[j][jd]);
       }
       for(jd=1;jd<=(ngs[j]+1);jd++)
       {
	 fprintf(out," %d",nsnod[j][jd]);
       }
      }

   return 1;
}

 index()
{
  int i;
  double sc,ai;
  int jj,kk;
  if(err||stres)
  {
  sc=1/0.24;
  fprintf(c100," \n%lf %lf scale\n times-roman findfont 12 scalefont setfont 711 331 translate", sc,sc);
  for(i=0;i<=10;i++)
    {
      ai=1-i/10;
      jj=i*10;
      kk=(i+1)*10;
      if(kk>100) kk=100;
      fprintf(c100,"\n1  setlinewidth  %lf setgray 0 0 m 12 0 1 12 12 1 0 12 1 closepath gsave\n fill grestore 0 setgray stroke 17 0 m ( %d - %d %) show 0 15 translate", ai,jj,kk);
    }
   }

  return 1;
}

/* shade the elements with respect to specified parameter */

 shadedom(j) 
int j;
{
  int icerr;

  icerr=100*errorr[j];

  switch (icerr)
  {
    case 1:
     red=0;
     green=0;
     blue=1;
     break;

     case 2:
     red=0;
     green=1;
     blue=0;
     break;

     case 3:
     red= 0.9;
     green= 0;
     blue= 0.9;
     break;

     case 4:
     red= 0.9;
     green=0.9;
     blue= 0;
     break;

     case 5:
     red=0;
     green=0.9;
     blue=0.9;
     break;

     case 6:
     red= 0.9;
     green= 0.9;
     blue= 0.9;
     break;

     case 7:
     red= 0.9;
     green=0.7;
     blue=0.7;
     break;

     case 8:
     red= 0.9;
     green= 0.6;
     blue= 0.6;
     break;

     case 9:
     red= 0.9;
     green=0.4;
     blue= 0.4;
     break;

     case 10:
     red=0.8;
     green=0.8;
     blue=0.9;
     break;

     case 11:
     red= 0.2;
     green=0.6;
     blue=0.9;
     break;

     case 12:
     red= 0.7;
     green= 0.4;
     blue=0.9;
     break;

     case 13:
     red=0.7;
     green=0.9;
     blue= 0.7;
     break;

     case 14:
     red=0.7;
     green=0.9;
     blue=0.4;
     break;

     case 15:
     red= 0.5;
     green= 0.7;
     blue=0.5;
     break;

     case 16:
     red=0.5;
     green=0.5;
     blue=0.5;
     break;

   }

   fprintf(c100,"\nclosepath gsave %lf %lf %lf   setrgbcolor  fill             \ngrestore stroke", red,green,blue);
   fprintf(c100,"\n0.0  setgray");

   return 1;
}

/* paint the color legend for error and stress */

indexerrstr()
{
  int i,jj;
  double amaxstr,sc,ai;

  if (err || stres)
    {
      sc=1/0.24;
      fprintf(c100,"  %lf %lf  scale\n times-roman findfont 12 scalefont setfont 711 331 translate", sc,sc);
      for (i=0;i<=10;i++)
	{
	  if (stres)
	   {
	     amaxstr=abs(aminst);
	     if (abs(amaxst)>abs(aminst)) amaxstr=abs(amaxst);
	     if (i<5) ai=(5-i)/5*(-amaxstr);
	     else if (i>5) ai=(5-i)/5*amaxstr;
	     else ai=0;
	     getrgbstr(ai);
	   }
	   else
	    {
	     ai=i/10.*100;
	     getrgberr(ai);
	    }

	   jj=i*10;

	   if(err)

	      fprintf(c100,"\n1  setlinewidth %lf  %lf  %lf setrgbcolor 0 0 m 12 0 1 12 12 1 0 12 1 closepath gsave fill \ngrestore \n0 setgray stroke 17 0 m ( %d% ) show 0 15 translate", red, green, blue, jj);

	    else
	     fprintf(c100,"\n1 setlinewidth %lf %lf %lf setrgbcolor 0 0 m 12 0 1 12 12 1 0 12 1 closepath gsave fill \ngrestore \n0 setgray stroke 17 0 m ( %lf ) show 0 15 translate", red,green,blue,ai);
	}
      }
     return 1;
 }


