C*********** PLOT POSTSCRIPT PROGRAM
C
      INCLUDE 'PLOT.CMN'

      LOGICAL  VIEWS

      OPEN(NIN,STATUS='OLD',FILE='INPUT.DAT')
      OPEN(NOUT,STATUS='unknown',FILE='PLOTOUT.DAT')
      KBUG=0

      WRITE(6,*)'Output Device is PostScript file pltf*.plt'

      WRITE(6,*)'Plot membrane elements ? (T/F)' 
      READ(5,*)TRIANG

      write(6,*)'Plot element errors ? (T/F)'
      read(5,*)err
      if(err) then
      write(6,*)'If error plot w.r.t. max error is required [1]'
      read(5,*)norm
      end if

      if(err.ne. -1)  then
      write(6,*)'Plot Stress ? (T/F)'
      read(5,*)stres
      end if

      WRITE(6,*)'Plot cable elements ?    (T/F)'
      READ(5,*)CABLE

      WRITE(6,*)'Plot G strings ?   (T/F)'
      read(5,*)STRING

      WRITE(6,*)'Number nodes ?           (T/F)'
      READ(5,*)NUMYES

      WRITE(6,*)'Number elements ? (T/F)'
      READ(5,*)NUELE

      WRITE(6,*)'Element reduction factor ? (0.0 - 1.0)'
      READ(5,*)REDFACT

      WRITE(6,*)'Auto scale ?             (T/F)'
      READ(5,*)AUTOSCALE

      IF (.NOT.AUTOSCALE) THEN
          WRITE(6,*)'Scale factor ?'
          READ(5,*)SFS
      ENDIF

      CALL DATA                                                         

      WRITE(6,*)'PLOT SINGLE VIEW ? T/F'
      READ(5,*)VIEWS

      IF(VIEWS)THEN 
      WRITE (6,*)'VIEW NO   1/2/3/4 ?'
      READ(5,*)NOMB
      GOTO(11,12,13,14)NOMB
      ENDIF

  11  ND1=1                                                             
      ND2=2                                                             
      CALL PLOT(7,ND1,ND2,.FALSE.) 
      IF(VIEWS.EQV..TRUE.)GOTO 122

  12  ND1=1                                                             
      ND2=3                                                             
      CALL PLOT(8,ND1,ND2,.FALSE.)
      IF(VIEWS.EQV..TRUE.)GOTO 122

  13  ND1=2                                                             
      ND2=3                                                             
      CALL PLOT(9,ND1,ND2,.FALSE.)
      IF(VIEWS.EQV..TRUE.)GOTO 122

  14  CALL PLOT(10,1,1,.TRUE.)

122    END

         
      SUBROUTINE PLOT(ICHAN,ND1,ND2,ISOYES)
C****  THIS IS TO FORM A GRAPHICS SUBROUTINE                            

      INCLUDE 'PLOT.CMN'

      CHARACTER  *3     TEXT
      DOUBLE PRECISION  LINTHICK
      PARAMETER        (LINTHICK = .2,  PEN = 2)

      KBUG=0

C******* OPEN CHANNEL TO PLOTFILE

      CALL OPENCH (ICHAN,TWDOWX,TWDOWY)

C******* SET UP GRAPHICS COORDINATE ARRAY

      CALL SETGA  (ISOYES,ND1,ND2)

C******* FIND MAX AND MIN COORDINATE VALUES

      CALL MAXMIN (XMIN,XMAX,YMIN,YMAX,XRANGE,YRANGE,SF,
     .             TWDOWX,TWDOWY,CMXOFF2,CMYOFF2)

c******  Calculate the shift in origin and the scalefactor for PS

      call setscale(cmxoff2, cmyoff2)

C***** OPEN GRAPHICS WINDOW AND CLEAR SCREEN

      CALL OPENG (LINTHICK,TWDOWX,TWDOWY,CMXOFF2,SF,
     .            CMYOFF2,XMIN,YMIN,XMAX,YMAX)

        if(triang) then

        CALL PSPLOTTRI(sf,cmxoff2,cmyoff2)
        call psplotquad(sf)

        end if

        if(cable) call pltcbl(sf)

        if(string) call pltgst(sf)

        CALL  NODNUM (KBUG,sf,cmxoff2,cmyoff2)
   
        call  elemno(sf,cmxoff2,cmyoff2)

        call index

        call closing

      RETURN                                                            
      END


C  ************************************************************************
C  *                   Orthogonal viewing transformation                  *
C  ************************************************************************

       SUBROUTINE orthog(x,y,z,u1,v1)

       INCLUDE 'PLOT.CMN'

       u1=cang(2)*cang(3)*x-cang(2)*sang(3)*y+sang(2)*z
       v1=(sang(1)*sang(3)-cang(1)*sang(2)*cang(3))*x+(sang(1)*cang(3)+
     +   cang(1)*sang(2)*sang(3))*y+cang(1)*cang(2)*z

       RETURN
       END




C*******************************************************************************

                 SUBROUTINE OPENCH (ICHAN,TWDOWX,TWDOWY)

C******   OPEN CHANNEL TO PLOTFILE 

      INCLUDE      'PLOT.CMN'

      INTEGER       LINSCR, LINLAS
      PARAMETER    (LINSCR = 5, LINLAS = 1)

          PLOTLINE=LINLAS
          TWDOWX=250.00D+00
          TWDOWY=200.00D+00
        ICH=ICHAN-6

        GOTO(102,104,106,108) ICH
 102      PLOTFILE='PLTF1.PLT'
          GOTO 110
 104      PLOTFILE='PLTF2.PLT'
          GOTO 110
 106      PLOTFILE='PLTF3.PLT'
          GOTO 110
 108      PLOTFILE='PLTF4.PLT'
 110    CONTINUE
     

      RETURN
      END


C*******************************************************************************

                 SUBROUTINE SETGA (ISOYES,ND1,ND2)

C******   SET UP GRAPHICS COORDINATE ARRAY 

      INCLUDE    'PLOT.CMN'

      WRITE(6,*)' ISOYES =  ',ISOYES
      IF (ISOYES) THEN
          WRITE(6,*)'Input vertical angle'
          READ(5,*)a1
          WRITE(6,*)'Input horizontal angle'
          READ(5,*)a3
          a2=0.0D0
          PI=4.0D+00*ATAN(1.0D+00)
          a1=a1*pi/180.0D0
          a2=a2*pi/180.0D0
          a3=a3*pi/180.0D0
          cang(1)=COS(a1)
          sang(1)=SIN(a1)
          cang(2)=COS(a2)
          sang(2)=SIN(a2)
          cang(3)=COS(a3)
          sang(3)=SIN(a3)
          DO 10 I=1,NN
            CALL ORTHOG(CORD(I,1),CORD(I,2),CORD(I,3),
     +         TCOR(I,1),TCOR(I,2))
C            IF (I.LT.5) THEN
C            ENDIF
 10       CONTINUE
        ELSE
          DO 20 I=1,NN
          TCOR(I,1)=CORD(I,ND1)
          TCOR(I,2)=CORD(I,ND2)
 20       CONTINUE
      ENDIF

      RETURN
      END


C******************************************************************************

          SUBROUTINE MAXMIN (XMIN,XMAX,YMIN,YMAX,XRANGE,YRANGE,SF,
     .                       TWDOWX,TWDOWY,CMXOFF2,CMYOFF2)

C******     FIND MAX AND MIN COORDINATE VALUES

      INCLUDE   'PLOT.CMN'

      XMAX=TCOR(1,1)                                                  
      XMIN=TCOR(1,1)                                                  
      YMIN=TCOR(1,2)                                                  
      YMAX=TCOR(1,2)                                                  
      DO 678 J=1,NN                                                     
      XD=TCOR(J,1)                                                    
      YD=TCOR(J,2)                                                    
      IF(XD.LT.XMIN)XMIN=XD                                             
      IF(XD.GT.XMAX)XMAX=XD                                             
      IF(YD.LT.YMIN)YMIN=YD                                             
      IF(YD.GT.YMAX)YMAX=YD                                             
 678  CONTINUE                                                          
      XRANGE=XMAX-XMIN
      YRANGE=(YMAX-YMIN) * 1.1
      IF (AUTOSCALE) THEN
          IF (XRANGE.EQ.0.0D+00) THEN
              SF1=1.0D+10
          ELSE
              SF1=(TWDOWX-20.0D+00)/XRANGE
          ENDIF
          IF (YRANGE.EQ.0.0D+00) THEN
              SF2=1.0D+10
          ELSE
              SF2=(TWDOWY-20.0D+00)/YRANGE
          ENDIF
          IF (SF1.LT.SF2) THEN
              SF=SF1
          ELSE
              SF=SF2
          ENDIF
      ELSE
          SF=SFS
      ENDIF
      CMXRNG=SF*XRANGE
      CMYRNG=SF*YRANGE
      CMXMIN=SF*XMIN
      CMYMIN=SF*YMIN
      CMXOFF1=(TWDOWX-CMXRNG)/2.0D+00
      CMYOFF1=(TWDOWY-CMYRNG)/3.0D+00
      CMXOFF2=CMXOFF1-CMXMIN
      CMYOFF2=CMYOFF1-CMYMIN
      WRITE(NOUT,67)XMIN,XMAX,YMIN,YMAX                                    
 67   FORMAT(//,' MAX MIN VALUES:',4(3X,F10.4))                         

      RETURN
      END

c*****************************************************************************

                          subroutine setscale(cmxoff2, cmyoff2)
      include 'plot.cmn'

             scalefac = 72./25.4/.24

             shiftx = cmxoff2*scalefac 
             shifty = cmyoff2*scalefac
      return
      
      end


C******************************************************************************

      SUBROUTINE  OPENG (LINTHICK,TWDOWX,TWDOWY,CMXOFF2,SF,
     .                   CMYOFF2,XMIN,YMIN,XMAX,YMAX)
                 
C******  OPEN GRAPHICS WINDOW AND CLEAR SCREEN

      INCLUDE  'PLOT.CMN'

      DOUBLE PRECISION   LINTHICK

      IF (KBUG.GT.2) WRITE(6,5) PLOTFILE
 5    FORMAT(X,A15,'  OPENed ')
C***** DRAW BORDER
C----- CALL SR PBODER TO SET UP PS INSTRUCTIONS TO DRAW BORDER 
      CALL PBORDER(cmxoff2,cmyoff2,sf)
      RETURN
      END
C*****************************************************************************

                 SUBROUTINE PBORDER(cmxoff2,cmyoff2,sf)

       INCLUDE 'PLOT.CMN'
       CHARACTER*36 TIL
       OPEN(100, STATUS = 'unknown', FILE = PLOTFILE)
       WRITE(100,1000)
1000   FORMAT(' ','%!PS-Adobe-2.0 EPSF-2.0',/,' %%BoundingBox: 0 0 580 
     +  829',/,' /l {lineto} def /m {moveto} 
     +  def 577 14 translate 90 rotate ')
       WRITE(6,*)'Enter the Title'
	   READ(5,1202) TIL
 1202  FORMAT(A36)
	   WRITE(100,1203) TIL
1203   FORMAT(' ',' /Helvetica findfont 20 scalefont setfont 370 500
     + m',/,' (',A36,') show 2 setlinewidth stroke')
       WRITE(100,1001)
1001   FORMAT(' ','.24 .24 scale newpath')
       RETURN
       END

C******************************************************************************

                 SUBROUTINE  NODNUM (KBUG,sf,cmxoff2,cmyoff2)

C******   NUMBER NODES

      INCLUDE   'PLOT.CMN'

      IF (NUMYES) THEN

       ixo = int(shiftx)
       iyo = int(shifty)

       WRITE(100,1002)
1002   FORMAT(' ',' /Helvetica findfont
     + 10 .24 div scalefont setfont ')

          DO 56 JT=1,NN 
c          if(jt.eq.1) then                                                    
c          write(100,900)
c900       format(' ','  (1  ) show')
c          else
          x = sf*tcor(jt,1)*scalefac + shiftx
          y = sf*tcor(jt,2)*scalefac + shifty
          ix = int(x)
          iy = int(y)
          write(100,901)ix,iy,jt
901       format(' ',i5,i5,' m  (',i3,') show ')
c          end if
            IF (KBUG.GT.2) WRITE(NOUT,55) JT, (TCOR(JT,J), J=1,2)
 55         FORMAT('  TCOR(',I3,',*) :',2(4X,F12.5))
 56       CONTINUE                                                          
      ENDIF

      RETURN
      END

c*******************************************************************

             subroutine elemno(sf,cmxoff2,cmyoff2)

      include 'plot.cmn'
      kbug = 0
C******** MARK ELEMENTS IF REQUIRED
      IF(NUELE) THEN

        DO 285 J=1,NE
          XDIF=0.0D0
          YDIF=0.0D0
          DO 367 JJ=1,3
            XDIF=XDIF+TCOR(NOD(J,JJ),1)
            YDIF=YDIF+TCOR(NOD(J,JJ),2)
  367     CONTINUE
          XDIF= sf*XDIF/3.0D0*scalefac + shiftx
          YDIF= sf*YDIF/3.0D0*scalefac + shifty
          ixdif = int(xdif)
          iydif = int(ydif)

          WRITE(100,1004)ixdif,iydif,J
1004      FORMAT(' ',I5,I5,' m  (',I5,')',' show')
          IF (KBUG.GT.2) WRITE(NOUT,28) XDIF, YDIF
  28      FORMAT('  XDIF, YDIF : ',2(4X,F12.5))
  285   CONTINUE
      ENDIF

      return

      end

             SUBROUTINE  PSPLOTTRI(sf,cmxoff2,cmyoff2)

C******   PLOT TRIANGULAR ELEMENTS IN PS FILE

      INCLUDE      'PLOT.CMN'

      KBUG = 0

c---------------------------------- Plot elements
      DO 164 J=1,NE
        N3=NOD(J,3)
        X3=TCOR(N3,1)
        Y3=TCOR(N3,2)
        x = sf*X3*scalefac + shiftx
        y = sf*Y3*scalefac + shifty
        ix3 = int(x)
        iy3 = int(y)
        IF (REDFACT.GT.0.0) THEN
C ---------------------------------- Find Centre of Element
          XDIF=0.0D0
          YDIF=0.0D0
          DO 369 JJ=1,3
            XDIF=XDIF+TCOR(NOD(J,JJ),1)
            YDIF=YDIF+TCOR(NOD(J,JJ),2)
 369      CONTINUE
          XC=XDIF/3.0D0
          YC=YDIF/3.0D0
C ---------------------------------- Modify X3,Y3
          X3=X3 + (XC-X3)*REDFACT
          Y3=Y3 + (YC-Y3)*REDFACT
          x3 = sf*x3*scalefac + shiftx
          y3 = sf*y3*scalefac + shifty
          ix3 = int(X3)
          iy3 = int(Y3)
        ENDIF
        WRITE(100,1005) ix3,iy3
1005    format(' ',I5,I5,' m ')
        DO 165 I=1,3
          NP=NOD(J,I)
          XQ=TCOR(NP,1)
          YQ=TCOR(NP,2)
          xq = sf*xq*scalefac + shiftx
          yq = sf*yq*scalefac + shifty
          ixq = int(xq)
          iyq = int(yq)
          IF (REDFACT.GT.0.0) THEN
            np = nod(j,i)
            xq = tcor(np,1)
            yq = tcor(np,2)
            XQ=XQ + (XC-XQ)*REDFACT
            YQ=YQ + (YC-YQ)*REDFACT
            xq = sf*xq*scalefac + shiftx
            yq = sf*yq*scalefac + shifty
            ixq = int(xq)
            iyq = int(yq)
          ENDIF
          write(100,1006)ixq,iyq
1006      format(' ',I5,I5,' l ')          
165       CONTINUE

          if(err.or.stres) then

          if(norm.eq.1) then
          call shaderr1(j)
          else 
          call shaderr(j)
          end if

          call shadste(j)
     
          else
          
          write(100,1205)
1205      format(' ','stroke')

          end if
          
164   continue


      RETURN
      END


             SUBROUTINE  PSPLOTquad(sf)

C******   PLOT RECT ELEMENTS IN PS FILE

      INCLUDE      'PLOT.CMN'

      KBUG = 0

c---------------------------------- Plot elements
      DO 164 J=1,nq
        N4=NOD(J,4)
        X4=TCOR(N4,1)
        Y4=TCOR(N4,2)
        x = sf*X4*scalefac + shiftx
        y = sf*Y4*scalefac + shifty
        ix = int(x)
        iy = int(y)
        IF (REDFACT.GT.0.0) THEN
C ---------------------------------- Find Centre of Element
          XDIF=0.0D0
          YDIF=0.0D0
          DO 369 JJ=1,4
            XDIF=XDIF+TCOR(NOD(J,JJ),1)
            YDIF=YDIF+TCOR(NOD(J,JJ),2)
 369      CONTINUE
          XC=XDIF/4.0D0
          YC=YDIF/4.0D0
C ---------------------------------- Modify X3,Y3
          X4=X4 + (XC-X4)*REDFACT
          Y4=Y4 + (YC-Y4)*REDFACT
          x4 = sf*x4*scalefac + shiftx
          y4 = sf*y4*scalefac + shifty
          ix = int(X4)
          iy = int(Y4)
        ENDIF
        WRITE(100,1005) ix,iy
1005    format(' ',I5,I5,' m ')
        DO 165 I=1,4
          NP=NOD(J,I)
          XQ=TCOR(NP,1)
          YQ=TCOR(NP,2)
          xq = sf*xq*scalefac + shiftx
          yq = sf*yq*scalefac + shifty
          ixq = int(xq)
          iyq = int(yq)
          IF (REDFACT.GT.0.0) THEN
            np = nod(j,i)
            xq = tcor(np,1)
            yq = tcor(np,2)
            XQ=XQ + (XC-XQ)*REDFACT
            YQ=YQ + (YC-YQ)*REDFACT
            xq = sf*xq*scalefac + shiftx
            yq = sf*yq*scalefac + shifty
            ixq = int(xq)
            iyq = int(yq)
          ENDIF
          write(100,1006)ixq,iyq
1006      format(' ',I5,I5,' l ')          
165       CONTINUE
          

          
          if(err.or.stres) then
      
          if(norm.eq.1) then
          call shaderr1(j)
          else
          call shaderr(j)
          end if

          call shadste(j)
         
          else
          write(100,1204)
 1204     format(' ','stroke')
          end if          
        

164   continue

      
      if(norm.eq.1) then
      
      write(100,1850) amaxer
1850  format(' ','/Times-Roman findfont 50 scalefont setfont',/,
     .' 1200 0 m (Relative Error PLOT max error=',f5.1,'%) show')
      
      else
      if(err) then
      write(100,1802)
1802  format(' ','/Times-Roman findfont 50 scalefont setfont',/,
     .' 1200 0 m (Error PLOT) show')
      end if
      end if

      if(stres) then
         if(ipv.eq.1) chstr = 'xx'
         if(ipv.eq.2) chstr = 'yy'
         if(ipv.eq.3) chstr = 'xy'
         if(ipv.eq.4) chstr = 'max-p'
         if(ipv.eq.5) chstr = 'min-p'
	  write(100,1800) chstr,amaxst
1800  format(' ','0 10 m /Times-Roman findfont 50 
     .scalefont setfont',/,' (100% Stress ',A5,' = ',e12.5,') show')
      write(100,1801)
1801  format(' ','1200 10 m (STRESS PLOT) show')
      end if


      RETURN
      END

c******    Shade the elements with respect to specified parameter

      subroutine shaderr(j)

      include 'plot.cmn'

      if(err) then
         if(abs(errorr(j)).ge. 1.) shade = 0. 
         if(abs(errorr(j)).lt. 1.) shade = .1
         if(abs(errorr(j)).lt. 0.9) shade = .2
         if(abs(errorr(j)).lt. 0.8) shade = .3
         if(abs(errorr(j)).lt. 0.7) shade = .4
         if(abs(errorr(j)).lt. 0.6) shade = .5
         if(abs(errorr(j)).lt. 0.5) shade = .6
         if(abs(errorr(j)).lt. 0.4) shade = .7
         if(abs(errorr(j)).lt. 0.3) shade = .8
         if(abs(errorr(j)).lt. 0.2) shade = .9
         if(abs(errorr(j)).lt. 0.1) shade = 1.
          
      write(100,1008) shade
1008  format(' ','closepath gsave ',f4.1,' setgray fill
     + grestore stroke ')
      write(100,1009)
1009  format(' ','0.0 setgray')
      end if

      return

      end
c******    Shade the elements with respect to specified parameter

      subroutine shaderr1(j)

      include 'plot.cmn'

      if(err) then
         if(abs(errorr(j)/amaxer).ge. 1.) shade = 0. 
         if(abs(errorr(j)/amaxer).lt. 1.) shade = .1
         if(abs(errorr(j)/amaxer).lt. 0.9) shade = .2
         if(abs(errorr(j)/amaxer).lt. 0.8) shade = .3
         if(abs(errorr(j)/amaxer).lt. 0.7) shade = .4
         if(abs(errorr(j)/amaxer).lt. 0.6) shade = .5
         if(abs(errorr(j)/amaxer).lt. 0.5) shade = .6
         if(abs(errorr(j)/amaxer).lt. 0.4) shade = .7
         if(abs(errorr(j)/amaxer).lt. 0.3) shade = .8
         if(abs(errorr(j)/amaxer).lt. 0.2) shade = .9
         if(abs(errorr(j)/amaxer).lt. 0.1) shade = 1.

      write(100,1008) shade
1008  format(' ','closepath gsave ',f4.1,' setgray fill
     + grestore stroke ')
      write(100,1009)
1009  format(' ','0.0 setgray')
      end if

      return

      end
c******    Shade the elements with respect to specified stress

      subroutine shadste(i)

      include 'plot.cmn'

      if(stres) then

         if(abs(abs(ste(i,ipv))/amaxst).ge. 1.) shade = 0.
         if(abs(abs(ste(i,ipv))/amaxst).lt. 1.) shade = .1
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.9) shade = .2
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.8) shade = .3
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.7) shade = .4
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.6) shade = .5
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.5) shade = .6
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.4) shade = .7
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.3) shade = .8
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.2) shade = .9
         if(abs(abs(ste(i,ipv))/amaxst).lt. 0.1) shade = 1.
      write(100,1008) shade
1008  format(' ','closepath gsave ',f4.1,' setgray fill
     + grestore stroke ')
      write(100,1009)
1009  format(' ','0.0 setgray')
      end if

      return

      end

c****   Plot cable elements
      
       subroutine pltcbl(sf)
   
       include 'plot.cmn'

       
       if(nl .gt. 0) then

       write(100,1011)
1011   format(' ','stroke newpath ')

       do  461 j = 1,nl
          n3 = nodl(j,2)
          x3 = sf*tcor(n3,1)*scalefac + shiftx
          y3 = sf*tcor(n3,2)*scalefac + shifty
          ix = int(x3)
          iy = int(y3)

          nq = nodl(j,1)    
          xq = sf*tcor(nq,1)*scalefac + shiftx
          yq = sf*tcor(nq,2)*scalefac + shifty
          ixq = int(xq)
          iyq = int(yq)
          write(100,1013)ix,iy, ixq,iyq
1013      format(' ',i5,i5,' m ',i5,i5' l ')

461   continue
      write(100,*)' 1   setlinecap'
      write(100,*)' 20  setlinewidth stroke'
      end if
      return

      end


c***** Plot geodesic strings

      subroutine pltgst(sf)

      include 'plot.cmn'

      if(nstr.gt. 0) then

      write(100,1014)
1014  format(' ','stroke newpath')       

      do 58 j = 1,nstr

         nsu = ngs(j)
         nr = nsnod(j,1)
         x3 = sf*tcor(nr,1)*scalefac + shiftx
         y3 = sf*tcor(nr,2)*scalefac + shifty
         ix = int(x3)
         iy = int(y3)
         write(100,1015) ix,iy
1015     format(' ',i5,i5,' m')

         do 456 jx = 2, nsu + 1
            nr = nsnod(j,jx)
            x3 = sf*tcor(nr,1)*scalefac + shiftx
            y3 = sf*tcor(nr,2)*scalefac + shifty
            ix = int(x3)
            iy = int(y3)
            write(100,1016) ix,iy
1016        format(' ',i5,i5,' m ')
456     continue
58    continue

      write(100,*)' closepath 3 setlinewidth'
      end if

      return
   
      end         



c****************************************************************************

                            subroutine closing

       include 'plot.cmn'

      if(err.or.stres) then
      write(100,1010)
      else
      write(100,1007)
      end if
1007  format(' ','  stroke 4.2 4.2 scale',/,' showpage ')
1010  format(' ',' showpage')

      return
   
      end




C******************************************************************************

                            SUBROUTINE DATA 

C******   READ INPUT DATA FROM INPUT.DAT
      INCLUDE 'PLOT.CMN'
C****  DATA INPUT ROUTINE                                               
      READ (NIN,10)TITEL                                                 
   10 FORMAT(A32)                                                       
      WRITE(NOUT,20)TITEL                                                   
   20 FORMAT(      /   /,' DATA AND RESULTS  ',/,1X,A32)                
      READ(NIN,30)DT,DAMP
   30 FORMAT(BZ,2F10.5)
      WRITE(NOUT,40)DT,DAMP
   40 FORMAT(/,' TIMESTEP  DT=',F10.5,5X,'DAMP=',F10.5)
      READ(NIN,50) NN,NE,NB,NM,NL,NDIME,NSTR,NBE,KMAX,NMAX,ILN
      READ(NIN,50) NQ
   50 FORMAT(BZ,11I5)                                                   
      WRITE(NOUT,60) NN,NE,NB,NM,NL,NDIME,NSTR,NBE,KMAX,NMAX                 
   60 FORMAT(/,' NO OF NODES=',I5,/,' NO OF ELEMENTS=',I5,/,            
     1' NO OF RESTRAINED BOUNDARY NODES=',I5,/,' NO OF MATERIAL TYPES=',
     2I5,/,' NO OF LINKS=',I5,/,' NO OF DIMENSIONS=',I5,/,' NO OF STRS='
     3,I5,/,' NO BEAMS=',I5,/,' NO OF ITGRPS=',I5,/,' NO OF ITBTWP=',I5)
      WRITE(NOUT,65) NQ
   65 FORMAT(/,' NO OF QUADRILATERALS=',I5)
      WRITE(NOUT,70)ILN                                                   
   70 FORMAT(' O IF NO LOADS=',I5)                                      
      DO 80 L=1,NN                                                      
   80 READ(NIN,90) N,(CORD(N,I),I=1,NDIME)                                 
   90 FORMAT(BZ,I5,3F15.5) 
      DO 100 N=1,NN                                                     
  100 WRITE(NOUT,110) N,(CORD(N,I),I=1,NDIME )                               
  110 FORMAT(' NODE=',I5,10X,'CORDS=',3(2X ,F10.4))                     
      IF(NE.GT.0) THEN
        DO 120 L=1,NE                                                     
  120   READ(NIN,130)NXX,(NOD(L,I),I=1,4)                                     
  130   FORMAT(BZ,5I5)                                                    
        WRITE(NOUT,140)(N,(NOD(N,I),I=1,4),N=1,NE)                             
  140   FORMAT(' ELEMENT=',I3,2X,'NODE1=',I3,2X,'NODE2=',I3,2X,'NODE3='   
     1          ,I3,2X,'MAT NO=',I5)
      ENDIF                                              
      IF(NL.GT.0) THEN
        DO 150 L=1,NL                                                     
  150   READ(NIN,160) N,(NODL(L,I),I=1,3)                                    
  160   FORMAT(BZ,4I5)                                                    
        WRITE(NOUT,170)(N,(NODL(N,I),I=1,3),N=1,NL)                           
  170   FORMAT(' LINK=',I3,2X,'NODE1=',I3,2X,'NODE2=',I3,2X,              
     1         'MAT NO=',I5)
      ENDIF
      IF(NQ.GT.0) THEN
        WRITE(NOUT,171) 
  171   FORMAT(/,' QUADRILATERAL ELEMENTS ',
     .   /,' ELEMENT          NODAL TOPOLOGY             MATERIAL No')
        DO 172   IQ = 1,NQ
  172   READ(NIN,174) N,(NODQ(IQ,I),I=1,5)                                    
  174   FORMAT(BZ,6I5)                                                    
        WRITE(NOUT,176)(N,(NODQ(N,I),I=1,5),N=1,NQ)
  176   FORMAT(3X,I5,5X,4I5,5X,I5)
      ENDIF
      WRITE(NOUT,180)
  180 FORMAT( / ,' MATERIAL DATA')                                      
      DO 190 L=1,NM                                                     
      READ(NIN,200) N,MAT(N),(AMAT(N,I),I=1,5)                             
      WRITE(NOUT,210) N,MAT(N),(AMAT(N,I),I=1,5)
  190 CONTINUE
  200 FORMAT(BZ,2I5,5e12.5)                                             
  210 FORMAT('  MATERIAL NUMBER',I2,3X,I5,5X,5(3X,e12.5))               
      DO 220 N=1,NB                                                      
  220 READ(NIN,230)(NCO(N,I),I=1,(NDIME+1))                                 
  230 FORMAT(BZ,4I5)                                                    
      WRITE(NOUT,240)                                                        
  240 FORMAT(/,' BOUNDARY CONDITIONS')                                  
      DO 250 N=1,NB                                                     
  250 WRITE(NOUT,260)(NCO(N,I),I=1,(NDIME+1))                               
  260 FORMAT(  ' NODE=',I5,5X,3(5X,I2))                                 
C*** READ IN THE APPLIED LOADS PUT IN F ARRAY                           
C*** REMEMBER MUST HAVE LAST LINE FOR LAST NODE EVEN IF NO APPLIED LOAD 
      WRITE(NOUT,270)                                                      
  270 FORMAT(///, ' LOADING CONDITIONS'/)                               
      IF(ILN.GT.0)  THEN
        ILN=0                                                             
  280   ILN=ILN+1                                                         
        I=ILN                                                             
        READ(NIN,290)NC(I),(ALOAD(I,II),II=1,NDIME)                          
  290   FORMAT(I5,3F15.5)                                                 
        WRITE(NOUT,300)NC(I),(ALOAD(I,II),II=1,NDIME)                         
  300   FORMAT(1H ,'NODE=',I5,5X,3(4X,F15.5))                             
        IF (NC(I).LT.NN) GOTO 280
      ENDIF
      IF(NSTR.GT.0) CALL GSDATA

c----- open and read error file

      if(err) then
      open(95,status = 'old',file = 'error.dat')
      do 2000 k = 1,ne
      read(95,*)errorr(k)
         if(norm.eq.1) then
         call maxerr
         else
         errorr(k) = errorr(k)/100.
         end if
2000  continue
      end if

c----- open and read stress file

      if(stres) then
      open(90,status = 'old', file = 'stress.dat')
      write(6,*)'Enter 1 2 3 4 5 for Sx Sy Sxy Smax Smin'
      read(5,*) ipv

      do 2001 k = 1,ne
2001  read(90,1500)(ste(k,l),l = 1,5)
1500  format(5e12.5)
      end if      

      call maxstr

      RETURN                                                            
      END        


c****************************************************************************

                         subroutine maxstr
      include 'plot.cmn'
      
      amaxst = ste(1,ipv)    

      do 2000 i = 1, ne
2000      if(amaxst.lt.abs(ste(i,ipv))) amaxst = abs(ste(i,ipv))

      return
      end
c****************************************************************************

                         subroutine maxerr
      include 'plot.cmn'
      
      amaxer = errorr(1)    

      do 2000 i = 1, ne
2000      if(amaxer.lt.abs(errorr(i))) amaxer = abs(errorr(i))

      return
      end
                                                       
C******************************************************************************
 
                          SUBROUTINE GSDATA

C******  READ DATA FOR GEODESIC STRINGS

      INCLUDE 'PLOT.CMN'

C**** READS IN STRING DATA                                              DRE15150
      DO 58 J=1,NSTR                                                    DRE15160
      READ(NIN,781)NGS(J)                                                 DRE15170
  781 FORMAT(I5)                                                        DRE15180
      WRITE(NOUT,782)J,NGS(J)                                              DRE15190
  782 FORMAT(' STRING NO=',I5,'   NO OF LINKS=',I5,/,                   DRE15200
     .' STRING NODE:')                                                  DRE15210
      READ(NIN,784)(NSNOD(J,JD),JD=1,(NGS(J)+1))                          DRE15220
  784 FORMAT (8I5)                                                   
      WRITE(NOUT,785) (NSNOD(J,JD),JD=1,(NGS(J)+1))                        DRE15240
  785 FORMAT(1X,8I5)
   58 CONTINUE                                                          DRE15250
      RETURN                                                            DRE15540
      END                                                               DRE15550


c***** Paint the legend
 
      subroutine index

      include 'plot.cmn'


      if(err.or.stres) then

      sc = 1./.24

      write(100,1018)sc,sc
1018  format(' ',f4.1,f4.1,' scale /Times-Roman findfont 12 scalefont
     + setfont 711 331 translate')     

      do 777 i = 0, 10
      ai = 1. - i/10.
      jj = i*10
      kk = (i+1)*10
      if(kk.ge.100) kk = 100
      write(100,1017)ai, jj, kk
1017  format(' ',' 1. setlinewidth ',f4.1,' setgray   0 0 m 
     +12 0 l 12 12 l 0 12 l closepath gsave',/,' fill grestore 0 setgray 
     + stroke 17 0 m (',i3,'-',i3,'%) show 0 15 translate')
777   continue

      end if

      return
      end 
