/* program generates a file for use with plot program for ein5.c */
#define TOL 1.e-10
#define NN  1500
#define NE  2000
#define NM  1
#define NB  100
#define NC  100
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

void fileopen(char *name, char *mode, FILE **fp);
void alloc_array_f(float **arr, int no, char *s);
void alloc_array_i(int **arr, int no, char *s);
void rinput_sec(FILE *fp11);
void stack(int elem_g);
int  comp_st(float x, float y);
void revise_nod(int trace[], int *pjj, int mat_no);
void nb_iln(void);
void routput(FILE *fp00);


int    nn, ne, nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;
float dt,damp;
int    *nod;
int    mat[NM], nco[NB][3],  nc[NC];
float *cord; 
float amat[NM*5], aload[NC*3];

int    is;
float *dec;

int    nn_c, ne_c, nb_c,iln_c;
int    *nod_c;
int    nco_c[NB][3],  nc_c[NC];
float  *cord_c; 
float  aload_c[NC*3];

char   titel[256];

main()
{
FILE *fp, *fp1, *fp2, *fp3;
char file[30], file_sav[30], file_o[30], bf[100];
register i, j, k, l, m, o, p;
int nsub, nnn[3], nnn_c[3], edge, nod1, nod2, nodd1, nodd2, tot_edge;
float sum, xx[3], xx_c[3], yy[3], yy_c[3];

printf("\n*** Handles Nodes upto = %3d & Elems upto = %3d\n\n", NN, NE);

printf("Enter the project file name (.dat) assumed\n");
gets(file_sav);
strcpy(file, file_sav);
strcat(file, ".dat");

printf("Enter the number of subdomains to be mapped\n");
gets(bf); sscanf(bf,"%d", &nsub);

alloc_array_f(&cord, 3*NN, "cord");  /* overall mesh */
alloc_array_i(&nod , 4*NE, "nod ");
alloc_array_f(&dec, NE, "dec");

alloc_array_f(&cord_c, 3*NN/2, "cord_c");
alloc_array_i(&nod_c,  4*NE/2, "nod_c");


for(i = 0; i < NE; dec[i++] = 0.);

nn = 0;
ne = 0;
for(is = 0; is < nsub; is++)
{
    printf("Enter the %3d th subdomain file name (.dat assumed)\n", is+1);

    gets(file_o);
    strcat(file_o, ".dat");

    fileopen(file_o,"r", &fp1);
    rinput_sec(fp1);
    fclose(fp1);

    for(i = 0; i < ne_c; i++)
    stack(i);

}        

/* nb_iln(); */
nb = 0; iln = 0; 

fileopen(file, "w", &fp);
routput(fp);
fclose(fp);

strcpy(file, file_sav); strcat(file, ".dec");
fileopen(file,"w",&fp2);

for(i = 0; i < ne; i++)
fprintf(fp2,"%6.3f\n",dec[i]);
fclose(fp2);

strcpy(file, file_sav); strcat(file,".edg");
fileopen(file,"w",&fp3);
tot_edge = 0;
for(i = 0; i < nsub; i++)
{
 edge = 0;
 for(j = 0; j < ne; j++)
 {
 if(dec[j] != i+1) continue;
 for(k = 0; k < 3; k++)
 {
 l = k+1; if( l > 2) l = 0;
 nod1 = nod[4*j+k];  nod2 = nod[4*j+l];
   for(m = 0; m < ne; m++)
   {
   if(dec[m] == i+1) continue;
      for(o = 0; o < 3; o++)
      {
      p = o+1; if(p > 2) p = 0;
      nodd1 = nod[4*m+o]; nodd2 = nod[4*m+p];
      if((nod1 == nodd1 && nod2 == nodd2) || 
         (nod1 == nodd2 && nod2 == nodd1)) edge++;
      }
   }
 }  
 }
fprintf(fp3,"subdomain no.%3d cut edges = %5d\n",i+1, edge);
fprintf(stdout,"subdomain no.%3d cut edges = %5d\n",i+1, edge);
tot_edge += edge;
}
fprintf(fp3,"Total no. of edges cut = %5d\n", tot_edge);
fprintf(stdout,"Total no. of edges cut = %5d\n", tot_edge);
fclose(fp3);

printf("*** file %s.dat generated\n",file_sav);
printf("*** file %s.dec generated\n",file_sav);
printf("*** file %s.edg generated\n",file_sav);

return(1);
}       


void fileopen(char *name, char *mode, FILE **fp)
{
if((*fp=fopen(name, mode)) == (FILE  *) NULL)
{printf("cannot open %s\n", name);exit(1);}
}


void rinput_sec(FILE *fp11)
{
char bf[256];
int i,j,k,n, dum;
float x1,y1,z1, dumm;

   fgets(titel, 256, fp11);
   fputs(titel, stdout);
   fgets(bf,256,fp11);
   fgets(bf,256,fp11);

   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",&nn_c,&ne_c,&nb_c,&nm,&nl,
   &ndime, &nstr, &nbe, &kmax,&nmax, &iln_c);


   fgets(bf,256,fp11);


   for(i = 0; i < nn_c; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %f %f %f",&n, &x1, &y1,&z1);
   cord_c[3*i] = x1;
   cord_c[3*i + 1] = y1;
   cord_c[3*i + 2] = z1;
   }


   if(ne_c > 0)
   {
      for(i = 0; i < ne_c; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d",&n,&nod_c[4*i + 0],&nod_c[4*i + 1],
      &nod_c[4*i + 2],&nod_c[4*i + 3]);
      }
   }

   for(i = 0; i < nm; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %f %f %f %f %f",&n,&mat[i],&amat[5*i+0],
   &amat[5*i+1],&amat[5*i+2],&amat[5*i+3],&amat[5*i+4]);
   }



   for(i = 0; i < nb_c; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d",&nco_c[i][0],&nco_c[i][1],&nco_c[i][2],
          &nco_c[i][3]);
   }



   if(iln > 0)
   {
   for(i = 0; i < NC; nc_c[i++] = 0);/*zero for use in nb_iln */
   iln_c = 0;
more:
   iln_c++;
   i = iln_c - 1;

   fgets(bf,256,fp11);
   sscanf(bf,"%d %f %f %f",&nc_c[i],&aload_c[3*i+0],
   &aload_c[3*i+1],&aload_c[3*i+2]);

   if(nc_c[i] < nn_c)
   goto more;
   }

fclose(fp11);
}


void alloc_array_f(float **arr, int no, char *s)
{
if((*arr = (float *)calloc(no, (sizeof(float)))) == NULL)
{printf("out of core for %s\n", s); exit(1);}
}

void alloc_array_i(int **arr, int no, char *s)
{
if((*arr = (int *)calloc(no, (sizeof(int)))) == NULL)
{printf("out of core for %s\n", s); exit(1);}
}



void stack(int elem_g)
{
int i,ii,jj,test1;
int trace[3],node, mat_no;
float x[3], y[3];

   ii = nn ;
   jj = ne ;

   for(i = 0; i < 3; i++)
   {
   node = nod_c[4*elem_g + i] - 1;/*load the coordinates of the element*/
   x[i] = cord_c[3*node + 0];
   y[i] = cord_c[3*node + 1];
   }

   mat_no = nod_c[4*elem_g + 3];/* load the mat number */
   
   

   for(i = 0; i < 3; i++)
   {

     test1 = 0;
     test1 = comp_st(x[i],y[i]); /*test1 returns the compared node_st*/

     if(test1 == -1)
     {
	 cord[3*ii + 0] = x[i];
	 cord[3*ii + 1] = y[i];
     cord[3*ii + 2] = 0.;
     trace[i] = ii + 1;
     ii++;
     continue;
     }
     trace[i] = test1;
   }

   /* load in the new topology */

   revise_nod(trace, &jj, mat_no);
     

  nn = ii;
  ne = jj;

return;
}

/* function to compare the packet nodes with the stack nodes */
int comp_st(float x, float y)
{
int i;
float x_st, y_st;
float tol = 1.e-4;

   for(i = 0; i < nn; i++)
   {
   x_st = cord[3*i + 0];
   y_st = cord[3*i + 1];
      if((fabs(x - x_st) <= tol) && (fabs(y - y_st) <= tol))
      return(i + 1);
   }
return(-1);
}

/* function to revise the node topology */

void revise_nod(int trace[], int *pjj, int mat_no)
{
int jj = *pjj;
   nod[4*jj + 0] = trace[0];
   nod[4*jj + 1] = trace[1];
   nod[4*jj + 2] = trace[2];
   nod[4*jj + 3] = mat_no;
   dec[jj] = (float) (is+1);
   jj++;

*pjj = jj;

}

/* function to identify the restrained and loaded nodes from the
   compiled mesh */

void nb_iln(void)
{
int i,j,k,l,m,o, node;
float tol = pow(10.,-6);
float cx_b,cy_b,cx_l,cy_l;
   k = 0;
   m = 0;
   nb = 0;
   for(i = 0; i < nn; i++)
   {

      for(j = 0; j  < nb_c; j++)
      {
       node = nco_c[j][0] - 1;
	   cx_b = fabs(cord[3*i + 0] - cord_c[3*node + 0]);
	   cy_b = fabs(cord[3*i + 1] - cord_c[3*node + 1]);
       if(cx_b <= tol && cy_b<= tol)
       {
		nco[k][0] = i + 1;
	    nco[k][1] = nco_c[j][1];
	    nco[k][2] = nco_c[j][2];
	    nco[k][3] = nco_c[j][3];
	    k++;
	break;
       }
      }

       for(l = 0; nc_c[l] <= nn_c && nc_c[l] != nn; l++)
       {
	node = nc_c[l] - 1;
	cx_l = fabs(cord[3*i + 0] - cord_c[3*node + 0]);
	cy_l = fabs(cord[3*i + 1] - cord_c[3*node + 1]);
	if(cx_l <= tol &&  cy_l <= tol)
	{
		 nc[m] = i + 1;
		 for(o = 0; o < 3; o++)
		 aload[3*m+o] = aload_c[3*l+o];
	 m++;
	 break;
	}
       }           
   }
   nb = k;

   if(m == 0){
   nc[m] = nn;
   aload[3*m+0] = aload[3*m+1] = aload[3*m+2] = 0.;
   m++;
   iln = m;
   }
   else{
   nc[m] = nn;
   aload[3*m+0] = aload[3*m+1] = aload[3*m+2] = 0.;
   m++;
   iln = m;
   }
}
 


void routput(FILE *fp00)
{
int i,j,k,n, n1,n2,n3,n4;

   fputs(titel,fp00);
   fprintf(fp00,"%f %f\n", dt, damp);
   fprintf(fp00,"%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d\n",
    nn, ne, nb, nm, nl,
    ndime,  nstr,  nbe,  kmax, nmax,  iln);


   fprintf(fp00,"%5d\n", nq);

   for(i = 0; i <  nn; i++)
   {
   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",i+1, 
   ( cord)[3*i + 0], ( cord)[3*i + 1], ( cord)[3*i + 2]);
   }



   if( ne > 0)
   {  
      for(i = 0; i <  ne; i++)
      {
      n1 =  nod[4*i + 0];
      n2 =  nod[4*i + 1];
      n3 =  nod[4*i + 2];
      n4 =  nod[4*i + 3];

	  fprintf(fp00,"%5d%5d%5d%5d%5d\n",i+1,n1,n2,n3,n4);
      }
   }



   for(i = 0; i <  nm; i++)
   {
   fprintf(fp00,"%5d%5d%12.5e%12.5e%12.5e%12.5e%12.5e\n",i+1,
   ( mat)[i],( amat)[5*i+0],
   ( amat)[5*i+1],( amat)[5*i+2],( amat)[5*i+3],( amat)[5*i+4]);
   }



   for(i = 0; i <  nb; i++)
   {
   fprintf(fp00,"%5d%5d%5d%5d\n",( nco)[i][0],
   ( nco)[i][1],( nco)[i][2],( nco)[i][3]);
   }



   if( iln > 0)
   {
    iln = 0;
more:
    iln++;
   i =  iln - 1;

   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",
   ( nc)[i],( aload)[3*i+0],( aload)[3*i+1],
   ( aload)[3*i+2]);

   if( nc[i] <  nn)
   goto more;
   }

}
