/*Translated by FOR_C, v3.2 (-), on 03/19/92 at 17:21:04 */
/*FOR_C Options SET: alloc=2 c=2 do=r ftn=lvk op=i s=dv str=l */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include"fcrt.h"
/*   VERSION 2    DOES NOT USE EISPACK
 *
 * ------------------------------------------------------------------
 * */
void /*FUNCTION*/ dnlaso(op, iovect, n, nval, nfig, nperm, nmval, 
	 val, nmvec, vec, nblock, maxop, maxj, work, ind, ierr)
void (*op)(), (*iovect)();
long int *n, *nval, *nfig, *nperm, *nmval;
double *val;
long int *nmvec;
double *vec;
long int *nblock, *maxop, *maxj;
double work[];
long int ind[], *ierr;
{
#define VAL(I_,J_)	(*(val+(I_)*(*nmval)+(J_)))
#define VEC(I_,J_)	(*(vec+(I_)*(*nmvec)+(J_)))
static LOGICAL32 raritz, small;
static long int _l0, _l1, i, i1, i10, i11, i12, i13, i2, i3, i4, i5, 
	 i6, i7, i8, i9, i_, m, nband, nop, nv;
double ddot(), dnrm2();
static double delta, eps, tarr[1], temp;
void daxpy(), dcopy(), dlabcm(), dlabfc(), dlaeig(), dlager(), dlaran(), 
	 dmvpc(), dnppla(), dnwla(), dortqr(), dscal(), dswap(), dvsort();



	/* AUTHOR/IMPLEMENTER D.S.SCOTT-B.N.PARLETT/D.S.SCOTT
	 *
	 * COMPUTER SCIENCES DEPARTMENT
	 * UNIVERSITY OF TEXAS AT AUSTIN
	 * AUSTIN, TX 78712
	 *
	 * VERSION 2 ORIGINATED APRIL 1982
	 *
	 * REVISED VERSION  JUNE 1983
	 *
     * TRANSLATED FROM FORTRAN INTO C BY AI KHAN USING 
     * FOR_C TRANSLATOR BY COBALT BLUE, MARCH 1992  
     *
	 * DNLASO FINDS A FEW EIGENVALUES AND EIGENVECTORS AT EITHER END OF
	 * THE SPECTRUM OF A LARGE SPARSE SYMMETRIC MATRIX.  THE SUBROUTINE
	 * DNLASO IS PRIMARILY A DRIVER FOR SUBROUTINE DNWLA WHICH IMPLEMENTS
	 * THE LANCZOS ALGORITHM WITH SELECTIVE ORTHOGONALIZATION AND
	 * SUBROUTINE DNPPLA WHICH POST PROCESSES THE OUTPUT OF DNWLA.
	 * HOWEVER DNLASO DOES CHECK FOR INCONSISTENCIES IN THE CALLING
	 * PARAMETERS AND DOES PREPROCESS ANY USER SUPPLIED EIGENPAIRS.
	 * DNLASO ALWAYS LOOKS FOR THE SMALLEST (LEFTMOST) EIGENVALUES.  IF
	 * THE LARGEST EIGENVALUES ARE DESIRED DNLASO IMPLICITLY USES THE
	 * NEGATIVE OF THE MATRIX.
	 *
	 *
	 * ON INPUT
	 *
	 *
	 *   OP   A USER SUPPLIED SUBROUTINE WITH CALLING SEQUENCE
	 *     OP(N,M,P,Q).  P AND Q ARE N X M MATRICES AND Q IS
	 *     RETURNED AS THE MATRIX TIMES P.
	 *
	 *   IOVECT   A USER SUPPLIED SUBROUTINE WITH CALLING SEQUENCE
	 *     IOVECT(N,M,Q,J,K).  Q IS AN N X M MATRIX.  IF K = 0
	 *     THE COLUMNS OF Q ARE STORED AS THE (J-M+1)TH THROUGH
	 *     THE JTH LANCZOS VECTORS.  IF K = 1 THEN Q IS RETURNED
	 *     AS THE (J-M+1)TH THROUGH THE JTH LANCZOS VECTORS.  SEE
	 *     DOCUMENTATION FOR FURTHER DETAILS AND EXAMPLES.
	 *
	 *   N   THE ORDER OF THE MATRIX.
	 *
	 *   NVAL   NVAL SPECIFIES THE EIGENVALUES TO BE FOUND.
	 *     DABS(NVAL)  IS THE NUMBER OF EIGENVALUES DESIRED.
	 *     IF NVAL < 0 THE ALGEBRAICALLY SMALLEST (LEFTMOST)
	 *     EIGENVALUES ARE FOUND.  IF NVAL > 0 THE ALGEBRAICALLY
	 *     LARGEST (RIGHTMOST) EIGENVALUES ARE FOUND.  NVAL MUST NOT
	 *     BE ZERO.  DABS(NVAL) MUST BE LESS THAN  MAXJ/2.
	 *
	 *   NFIG   THE NUMBER OF DECIMAL DIGITS OF ACCURACY DESIRED IN THE
	 *     EIGENVALUES.  NFIG MUST BE GREATER THAN OR EQUAL TO 1.
	 *
	 *   NPERM   AN INTEGER VARIABLE WHICH SPECIFIES THE NUMBER OF USER
	 *     SUPPLIED EIGENPAIRS.  IN MOST CASES NPERM WILL BE ZERO.  SEE
	 *     DOCUMENTAION FOR FURTHER DETAILS OF USING NPERM GREATER
	 *     THAN ZERO.  NPERM MUST NOT BE LESS THAN ZERO.
	 *
	 *   NMVAL   THE ROW DIMENSION OF THE ARRAY VAL.  NMVAL MUST BE GREATER
	 *     THAN OR EQUAL TO DABS(NVAL).
	 *
	 *   VAL   A TWO DIMENSIONAL DOUBLE PRECISION ARRAY OF ROW
	 *     DIMENSION NMVAL AND COLUMN DIMENSION AT LEAST 4.  IF NPERM
	 *     IS GREATER THAN ZERO THEN CERTAIN INFORMATION MUST BE STORED
	 *     IN VAL.  SEE DOCUMENTATION FOR DETAILS.
	 *
	 *   NMVEC   THE ROW DIMENSION OF THE ARRAY VEC.  NMVEC MUST BE GREATER
	 *     THAN OR EQUAL TO N.
	 *
	 *   VEC   A TWO DIMENSIONAL DOUBLE PRECISION ARRAY OF ROW
	 *     DIMENSION NMVEC AND COLUMN DIMENSION AT LEAST DABS(NVAL).  IF
	 *     NPERM > 0 THEN THE FIRST NPERM COLUMNS OF VEC MUST
	 *     CONTAIN THE USER SUPPLIED EIGENVECTORS.
	 *
	 *   NBLOCK   THE BLOCK SIZE.  SEE DOCUMENTATION FOR CHOOSING
	 *     AN APPROPRIATE VALUE FOR NBLOCK.  NBLOCK MUST BE GREATER
	 *     THAN ZERO AND LESS THAN  MAXJ/6.
	 *
	 *   MAXOP   AN UPPER BOUND ON THE NUMBER OF CALLS TO THE SUBROUTINE
	 *     OP.  DNLASO TERMINATES WHEN MAXOP IS EXCEEDED.  SEE
	 *     DOCUMENTATION FOR GUIDELINES IN CHOOSING A VALUE FOR MAXOP.
	 *
	 *   MAXJ   AN INDICATION OF THE AVAILABLE STORAGE (SEE WORK AND
	 *     DOCUMENTATION ON IOVECT).  FOR THE FASTEST CONVERGENCE MAXJ
	 *     SHOULD BE AS LARGE AS POSSIBLE, ALTHOUGH IT IS USELESS TO HAVE
	 *     MAXJ LARGER THAN MAXOP*NBLOCK.
	 *
	 *   WORK   A DOUBLE PRECISION ARRAY OF DIMENSION AT LEAST AS
	 *     LARGE AS
	 *
	 *         2*N*NBLOCK + MAXJ*(NBLOCK+NV+2) + 2*NBLOCK*NBLOCK + 3*NV
	 *
	 *            + THE MAXIMUM OF
	 *                 N*NBLOCK
	 *                   AND
	 *         MAXJ*(2*NBLOCK+3) + 2*NV + 6 + (2*NBLOCK+2)*(NBLOCK+1)
	 *
	 *     WHERE NV = DABS(NVAL)
	 *
	 *     THE FIRST N*NBLOCK ELEMENTS OF WORK MUST CONTAIN THE DESIRED
	 *     STARTING VECTORS.  SEE DOCUMENTATION FOR GUIDELINES IN
	 *     CHOOSING STARTING VECTORS.
	 *
	 *   IND   AN INTEGER ARRAY OF DIMENSION AT LEAST DABS(NVAL). */

	/*   IERR   AN INTEGER VARIABLE.
	 *
	 *
	 * ON OUTPUT
	 *
	 *
	 *   NPERM   THE NUMBER OF EIGENPAIRS NOW KNOWN.
	 *
	 *   VEC   THE FIRST NPERM COLUMNS OF VEC CONTAIN THE EIGENVECTORS.
	 *
	 *   VAL   THE FIRST COLUMN OF VAL CONTAINS THE CORRESPONDING
	 *     EIGENVALUES.  THE SECOND COLUMN CONTAINS THE RESIDUAL NORMS OF
	 *     THE EIGENPAIRS WHICH ARE BOUNDS ON THE ACCURACY OF THE EIGEN-
	 *     VALUES.  THE THIRD COLUMN CONTAINS MORE DOUBLE PRECISIONISTIC ESTIMATES
	 *     OF THE ACCURACY OF THE EIGENVALUES.  THE FOURTH COLUMN CONTAINS
	 *     ESTIMATES OF THE ACCURACY OF THE EIGENVECTORS.  SEE
	 *     DOCUMENTATION FOR FURTHER INFORMATION ON THESE QUANTITIES.
	 *
	 *   WORK   IF WORK IS TERMINATED BEFORE COMPLETION (IERR = -2)
	 *     THE FIRST N*NBLOCK ELEMENTS OF WORK CONTAIN THE BEST VECTORS
	 *     FOR RESTARTING THE ALGORITHM AND DNLASO CAN BE IMMEDIATELY
	 *     RECALLED TO CONTINUE WORKING ON THE PROBLEM.
	 *
	 *   IND   IND(1)  CONTAINS THE ACTUAL NUMBER OF CALLS TO OP.  ON SOME
	 *     OCCASIONS THE NUMBER OF CALLS TO OP MAY BE SLIGHTLY LARGER
	 *     THAN MAXOP.
	 *
	 *   IERR   AN ERROR COMPLETION CODE.  THE NORMAL COMPLETION CODE IS
	 *     ZERO.  SEE THE DOCUMENTATION FOR INTERPRETATIONS OF NON-ZERO
	 *     COMPLETION CODES.
	 *
	 *
	 * INTERNAL VARIABLES.
	 *
	 * */

	/* NOP   RETURNED FROM DNWLA AS THE NUMBER OF CALLS TO THE
	 *   SUBROUTINE OP.
	 *
	 * NV   SET EQUAL TO DABS(NVAL), THE NUMBER OF EIGENVALUES DESIRED,
	 *   AND PASSED TO DNWLA.
	 *
	 * SMALL   SET TO .TRUE. IF THE SMALLEST EIGENVALUES ARE DESIRED.
	 *
	 * RARITZ   RETURNED FROM DNWLA AND PASSED TO DNPPLA.  RARITZ IS .TRUE.
	 *   IF A FINAL RAYLEIGH-RITZ PROCEDURE IS NEEDED.
	 *
	 * DELTA   RETURNED FROM DNWLA AS THE EIGENVALUE OF THE MATRIX
	 *   WHICH IS CLOSEST TO THE DESIRED EIGENVALUES.
	 *
	 * DNPPLA   A SUBROUTINE FOR POST-PROCESSING THE EIGENVECTORS COMPUTED
	 *   BY DNWLA.
	 *
	 * DNWLA   A SUBROUTINE FOR IMPLEMENTING THE LANCZOS ALGORITHM
	 *   WITH SELECTIVE ORTHOGONALIZATION.
	 *
	 * DMVPC   A SUBROUTINE FOR COMPUTING THE RESIDUAL NORM AND
	 *   ORTHOGONALITY COEFFICIENT OF GIVEN RITZ VECTORS.
	 *
	 * DORTQR   A SUBROUTINE FOR ORTHONORMALIZING A BLOCK OF VECTORS
	 *   USING HOUSEHOLDER REFLECTIONS.
	 *
	 * DAXPY,DCOPY,DDOT,DNRM2,DSCAL,DSWAP   A SUBSET OF THE BASIC LINEAR
	 *   ALGEBRA SUBPROGRAMS USED FOR VECTOR MANIPULATION.
	 *
	 * DLARAN   A SUBROUTINE TO GENERATE RANDOM VECTORS
	 *
	 * DLAEIG, DLAGER, DLABCM, DLABFC   SUBROUTINES FOR BAND EIGENVALUE
	 *   CALCULATIONS.
	 *
	 * ------------------------------------------------------------------
	 *
	 * THIS SECTION CHECKS FOR INCONSISTENCY IN THE INPUT PARAMETERS.
	 * */
	nv = labs( *nval );
	ind[0L] = 0L;
	*ierr = 0L;
	if( *n < 6L**nblock )
		*ierr = 1L;
	if( *nfig <= 0L )
		*ierr = *ierr + 2L;
	if( *nmvec < *n )
		*ierr = *ierr + 4L;
	if( *nperm < 0L )
		*ierr = *ierr + 8L;
	if( *maxj < 6L**nblock )
		*ierr = *ierr + 16L;
	if( nv < max( 1L, *nperm ) )
		*ierr = *ierr + 32L;
	if( nv > *nmval )
		*ierr = *ierr + 64L;
	if( nv > *maxop )
		*ierr = *ierr + 128L;
	if( nv >= *maxj/2L )
		*ierr = *ierr + 256L;
	if( *nblock < 1L )
		*ierr = *ierr + 512L;
	if( *ierr != 0L )
		return;

	small = *nval < 0L;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION SORTS AND ORTHONORMALIZES THE USER SUPPLIED VECTORS.
	 * IF A USER SUPPLIED VECTOR IS ZERO OR IF DSIGNIFICANT CANCELLATION
	 * OCCURS IN THE ORTHOGONALIZATION PROCESS THEN IERR IS SET TO  -1
	 * AND DNLASO TERMINATES.
	 * */
	if( *nperm == 0L )
		goto L_110;

	/* THIS NEGATES THE USER SUPPLIED EIGENVALUES WHEN THE LARGEST
	 * EIGENVALUES ARE DESIRED, SINCE DNWLA WILL IMPLICITLY USE THE
	 * NEGATIVE OF THE MATRIX.
	 * */
	if( small )
		goto L_20;
	for( i = 1L; i <= *nperm; i++ ){
		i_ = i - 1;
		VAL(0L,i_) = -VAL(0L,i_);
		}

	/* THIS SORTS THE USER SUPPLIED VALUES AND VECTORS.
	 * */
L_20:
	dvsort( nperm, val, &VAL(1L,0L), ADR(_l0,0L), tarr, nmvec, n, 
	 vec );

	/* THIS STORES THE NORMS OF THE VECTORS FOR LATER COMPARISON.
	 * IT ALSO INSURES THAT THE RESIDUAL NORMS ARE POSITIVE.
	 * */
	for( i = 1L; i <= *nperm; i++ ){
		i_ = i - 1;
		VAL(1L,i_) = fabs( VAL(1L,i_) );
		VAL(2L,i_) = dnrm2( n, &VEC(i_,0L), ADR(_l0,1L) );
		}

	/* THIS PERFORMS THE ORTHONORMALIZATION.
	 * */
	m = *n**nblock + 1L;
	dortqr( nmvec, n, nperm, vec, &work[m - 1L] );
	m = *n**nblock - *nperm;
	for( i = 1L; i <= *nperm; i++ ){
		i_ = i - 1;
		m = m + *nperm + 1L;
		if( fabs( work[m - 1L] ) > 0.9*VAL(2L,i_) )
			goto L_70;
		*ierr = -1L;
		return;

L_70:
		;
		}

	/* THIS COPIES THE RESIDUAL NORMS INTO THE CORRECT LOCATIONS IN
	 * THE ARRAY WORK FOR LATER REFERENCE IN DNWLA.
	 * */
	m = 2L**n**nblock + 1L;
	dcopy( nperm, &VAL(1L,0L), ADR(_l0,1L), &work[m - 1L], ADR(_l1,1L) );

	/* THIS SETS EPS TO AN APPROXIMATION OF THE RELATIVE MACHINE
	 * PRECISION
	 *
	 * ***THIS SHOULD BE REPLACED BY AN ASDSIGNMENT STATEMENT
	 * ***IN A PRODUCTION CODE
	 * */
L_110:
	eps = 1.0e0;
	for( i = 1L; i <= 1000L; i++ ){
		i_ = i - 1;
		eps = 0.5e0*eps;
		temp = 1.0e0 + eps;
		if( temp == 1.0e0 )
			goto L_130;
		}

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION CALLS DNWLA WHICH IMPLEMENTS THE LANCZOS ALGORITHM
	 * WITH SELECTIVE ORTHOGONALIZATION.
	 * */
L_130:
	nband = *nblock + 1L;
	i1 = 1L + *n**nblock;
	i2 = i1 + *n**nblock;
	i3 = i2 + nv;
	i4 = i3 + nv;
	i5 = i4 + nv;
	i6 = i5 + *maxj*nband;
	i7 = i6 + *nblock**nblock;
	i8 = i7 + *nblock**nblock;
	i9 = i8 + *maxj*(nv + 1L);
	i10 = i9 + *nblock;
	i11 = i10 + 2L*nv + 6L;
	i12 = i11 + *maxj*(2L**nblock + 1L);
	i13 = i12 + *maxj;
	dnwla( op, iovect, n, &nband, &nv, nfig, nperm, val, nmvec, vec, 
	 nblock, maxop, maxj, &nop, &work[0L], &work[i1 - 1L], &work[i2 - 1L], 
	 &work[i3 - 1L], &work[i4 - 1L], &work[i5 - 1L], &work[i6 - 1L], 
	 &work[i7 - 1L], &work[i8 - 1L], &work[i9 - 1L], &work[i10 - 1L], 
	 &work[i11 - 1L], &work[i12 - 1L], &work[i13 - 1L], ind, &small, 
	 &raritz, &delta, &eps, ierr );

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION CALLS DNPPLA (THE POST PROCESSOR).
	 * */
	if( *nperm == 0L )
		goto L_140;
	i1 = *n**nblock + 1L;
	i2 = i1 + *nperm**nperm;
	i3 = i2 + *nperm**nperm;
	i4 = i3 + max( *n**nblock, 2L**nperm**nperm );
	i5 = i4 + *n**nblock;
	i6 = i5 + 2L**nperm + 4L;
	dnppla( op, iovect, n, nperm, &nop, nmval, val, nmvec, vec, nblock, 
	 &work[i1 - 1L], &work[i2 - 1L], &work[i3 - 1L], &work[i4 - 1L], 
	 &work[i5 - 1L], &work[i6 - 1L], &delta, &small, &raritz, &eps );

L_140:
	ind[0L] = nop;
	return;
#undef	VAL
#undef	VEC
} /* end of function */

/* ------------------------------------------------------------------
 * */
void /*FUNCTION*/ dnppla(op, iovect, n, nperm, nop, nmval, val, nmvec, 
	 vec, nblock, h, hv, p, q, bound, d, delta, small, raritz, eps)
void (*op)(), (*iovect)();
long int *n, *nperm, *nop, *nmval;
double *val;
long int *nmvec;
double *vec;
long int *nblock;
double *h, *hv, *p, *q, bound[], d[], *delta;
LOGICAL32 *small, *raritz;
double *eps;
{
#define VAL(I_,J_)	(*(val+(I_)*(*nmval)+(J_)))
#define VEC(I_,J_)	(*(vec+(I_)*(*nmvec)+(J_)))
#define H(I_,J_)	(*(h+(I_)*(*nperm)+(J_)))
#define HV(I_,J_)	(*(hv+(I_)*(*nperm)+(J_)))
#define P(I_,J_)	(*(p+(I_)*(*n)+(J_)))
#define Q(I_,J_)	(*(q+(I_)*(*n)+(J_)))
static long int _d_l, _d_m, _do0, _do1, _do2, _do3, _do4, _do5, _l0, 
	 _l1, _l2, i, i_, j, j_, jj, k, k_, kk, l, m;
double ddot(), dnrm2();
static double _d0, dzero[1], hmax, hmin, temp;
void daxpy(), dcopy(), dlaeig(), dlager();



	/* THIS SUBROUTINE POST PROCESSES THE EIGENVECTORS.  BLOCK MATRIX
	 * VECTOR PRODUCTS ARE USED TO MINIMIZED THE NUMBER OF CALLS TO OP.
	 * */

	/* IF RARITZ IS .TRUE.  A FINAL RAYLEIGH-RITZ PROCEDURE IS APPLIED
	 * TO THE EIGENVECTORS.
	 * */
	dzero[0L] = 0.0e0;
	if( !*raritz )
		goto L_190;

	/* ------------------------------------------------------------------
	 *
	 * THIS CONSTRUCTS H=Q*AQ, WHERE THE COLUMNS OF Q ARE THE
	 * APPROXIMATE EIGENVECTORS.  TEMP = -1 IS USED WHEN SMALL IS
	 * FALSE TO AVOID HAVING TO RESORT THE EIGENVALUES AND EIGENVECTORS
	 * COMPUTED BY DLAEIG.
	 * */
	dcopy( ADR(_l0,*nperm**nperm), dzero, ADR(_l1,0L), h, ADR(_l2,1L) );
	temp = -1.0e0;
	if( *small )
		temp = 1.0e0;
	m = *nperm%*nblock;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dcopy( n, &VEC(i_,0L), ADR(_l0,1L), &P(i_,0L), ADR(_l1,1L) );
		}
	(*iovect)( n, &m, p, &m, ADR(_l0,0L) );
	(*op)( n, &m, p, q );
	*nop = *nop + 1L;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		for( j = i; j <= *nperm; j++ ){
			j_ = j - 1;
			jj = j - i + 1L;
			H(i_,jj - 1L) = temp*ddot( n, &VEC(j_,0L), ADR(_l0,1L), 
			 &Q(i_,0L), ADR(_l1,1L) );
			}
		}
	if( *nperm < *nblock )
		goto L_90;
L_40:
	m = m + *nblock;
	for( i = m, _do0=DOCNT(i,*nperm,_do1 = *nblock); _do0 > 0; i += _do1, _do0-- ){
		i_ = i - 1;
		for( j = 1L; j <= *nblock; j++ ){
			j_ = j - 1;
			l = i - *nblock + j;
			dcopy( n, &VEC(l - 1L,0L), ADR(_l0,1L), &P(j_,0L), ADR(_l1,1L) );
			}
		(*iovect)( n, nblock, p, &i, ADR(_l0,0L) );
		(*op)( n, nblock, p, q );
		*nop = *nop + 1L;
		for( j = 1L; j <= *nblock; j++ ){
			j_ = j - 1;
			l = i - *nblock + j;
			for( k = l; k <= *nperm; k++ ){
				k_ = k - 1;
				kk = k - l + 1L;
				H(l - 1L,kk - 1L) = temp*ddot( n, &VEC(k_,0L), ADR(_l0,1L), 
				 &Q(j_,0L), ADR(_l1,1L) );
				}
			}
		}

	/* THIS COMPUTES THE SPECTRAL DECOMPOSITION OF H.
	 * */
L_90:
	hmin = H(0L,0L);
	hmax = H(0L,0L);
	dlager( nperm, nperm, ADR(_l0,1L), h, &hmin, &hmax );
	dlaeig( nperm, nperm, ADR(_l0,1L), nperm, h, val, nperm, hv, bound, 
	 p, d, q, eps, &hmin, &hmax );

	/* THIS COMPUTES THE RITZ VECTORS--THE COLUMNS OF
	 * Y = QS WHERE S IS THE MATRIX OF EIGENVECTORS OF H.
	 * */
	for( i = 1L; i <= *nperm; i++ ){
		i_ = i - 1;
		dcopy( n, dzero, ADR(_l0,0L), &VEC(i_,0L), ADR(_l1,1L) );
		}
	m = *nperm%*nblock;
	if( m == 0L )
		goto L_150;
	(*iovect)( n, &m, p, &m, ADR(_l0,1L) );
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		for( j = 1L; j <= *nperm; j++ ){
			j_ = j - 1;
			daxpy( n, &HV(j_,i_), &P(i_,0L), ADR(_l0,1L), &VEC(j_,0L), 
			 ADR(_l1,1L) );
			}
		}
	if( *nperm < *nblock )
		goto L_190;
L_150:
	m = m + *nblock;
	for( i = m, _do2=DOCNT(i,*nperm,_do3 = *nblock); _do2 > 0; i += _do3, _do2-- ){
		i_ = i - 1;
		(*iovect)( n, nblock, p, &i, ADR(_l0,1L) );
		for( j = 1L; j <= *nblock; j++ ){
			j_ = j - 1;
			l = i - *nblock + j;
			for( k = 1L; k <= *nperm; k++ ){
				k_ = k - 1;
				daxpy( n, &HV(k_,l - 1L), &P(j_,0L), ADR(_l0,1L), 
				 &VEC(k_,0L), ADR(_l1,1L) );
				}
			}
		}

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION COMPUTES THE RAYLEIGH QUOTIENTS (IN VAL(*,1))
	 * AND RESIDUAL NORMS (IN VAL(*,2)) OF THE EIGENVECTORS.
	 * */
L_190:
	if( !*small )
		*delta = -*delta;
	m = *nperm%*nblock;
	if( m == 0L )
		goto L_220;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dcopy( n, &VEC(i_,0L), ADR(_l0,1L), &P(i_,0L), ADR(_l1,1L) );
		}
	(*op)( n, &m, p, q );
	*nop = *nop + 1L;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		VAL(0L,i_) = ddot( n, &P(i_,0L), ADR(_l0,1L), &Q(i_,0L), ADR(_l1,1L) );
		daxpy( n, ADR(_d0,-VAL(0L,i_)), &P(i_,0L), ADR(_l0,1L), &Q(i_,0L), 
		 ADR(_l1,1L) );
		VAL(1L,i_) = dnrm2( n, &Q(i_,0L), ADR(_l0,1L) );
		}
	if( *nperm < *nblock )
		goto L_260;
L_220:
	m = m + 1L;
	for( i = m, _do4=DOCNT(i,*nperm,_do5 = *nblock); _do4 > 0; i += _do5, _do4-- ){
		i_ = i - 1;
		for( j = 1L; j <= *nblock; j++ ){
			j_ = j - 1;
			l = i - 1L + j;
			dcopy( n, &VEC(l - 1L,0L), ADR(_l0,1L), &P(j_,0L), ADR(_l1,1L) );
			}
		(*op)( n, nblock, p, q );
		*nop = *nop + 1L;
		for( j = 1L; j <= *nblock; j++ ){
			j_ = j - 1;
			l = i - 1L + j;
			VAL(0L,l - 1L) = ddot( n, &P(j_,0L), ADR(_l0,1L), &Q(j_,0L), 
			 ADR(_l1,1L) );
			daxpy( n, ADR(_d0,-VAL(0L,l - 1L)), &P(j_,0L), ADR(_l0,1L), 
			 &Q(j_,0L), ADR(_l1,1L) );
			VAL(1L,l - 1L) = dnrm2( n, &Q(j_,0L), ADR(_l0,1L) );
			}
		}

	/* THIS COMPUTES THE ACCURACY ESTIMATES.  FOR CONSISTENCY WITH DILASO
	 * A DO LOOP IS NOT USED.
	 * */
L_260:
	i = 0L;
L_270:
	i = i + 1L;
	if( i > *nperm )
		return;
	temp = *delta - VAL(0L,i - 1L);
	if( !*small )
		temp = -temp;
	VAL(3L,i - 1L) = 0.0e0;
	if( temp > 0.0e0 )
		VAL(3L,i - 1L) = VAL(1L,i - 1L)/temp;
	VAL(2L,i - 1L) = VAL(3L,i - 1L)*VAL(1L,i - 1L);
	goto L_270;

#undef	Q
#undef	P
#undef	HV
#undef	H
#undef	VEC
#undef	VAL
} /* end of function */

double /*FUNCTION*/ dnrm2(n, dx, incx)
long int *n;
double dx[];
long int *incx;
{
static long int _d_l, _d_m, _do0, _do1, i, j, j_, next, nn;
static double dnrm2_v, hitest, sum, xmax;
static double zero = 0.0e0;
static double one = 1.0e0;
static double cutlo = 8.232e-11;
static double cuthi = 1.304e19;


	/*     EUCLIDEAN NORM OF THE N-VECTOR STORED IN DX() WITH STORAGE
	 *     INCREMENT INCX .
	 *     IF    N .LE. 0 RETURN WITH RESULT = 0.
	 *     IF N .GE. 1 THEN INCX MUST BE .GE. 1
	 *
	 *           C.L.LAWSON, 1978 JAN 08
	 *
	 *     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE
	 *     HOPEFULLY APPLICABLE TO ALL MACHINES.
	 *         CUTLO = MAXIMUM OF  DSQRT(U/EPS)  OVER ALL KNOWN MACHINES.
	 *         CUTHI = MINIMUM OF  DSQRT(V)      OVER ALL KNOWN MACHINES.
	 *     WHERE
	 *         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
	 *         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
	 *         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
	 *
	 *     BRIEF OUTLINE OF ALGORITHM..
	 *
	 *     PHASE 1    SCANS ZERO COMPONENTS.
	 *     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
	 *     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
	 *     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
	 *     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
	 *
	 *     VALUES FOR CUTLO AND CUTHI..
	 *     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER
	 *     DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
	 *     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE
	 *                   UNIVAC AND DEC AT 2**(-103)
	 *                   THUS CUTLO = 2**(-51) = 4.44089E-16
	 *     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC.
	 *                   THUS CUTHI = 2**(63.5) = 1.30438E19
	 *     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.
	 *                   THUS CUTLO = 2**(-33.5) = 8.23181D-11
	 *     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
	 *     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
	 *     DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 / */

	if( *n > 0L )
		goto L_10;
	dnrm2_v = zero;
	goto L_300;

L_10:
	next = 30;
	sum = zero;
	nn = *n**incx;
	/*                                                 BEGIN MAIN LOOP */
	i = 1L;
L_20:
	switch( next ){
		case 30: goto L_30;
		case 50: goto L_50;
		case 70: goto L_70;
		case 110: goto L_110;
		}
L_30:
	if( fabs( dx[i - 1L] ) > cutlo )
		goto L_85;
	next = 50;
	xmax = zero;

	/*                        PHASE 1.  SUM IS ZERO
	 * */
L_50:
	if( dx[i - 1L] == zero )
		goto L_200;
	if( fabs( dx[i - 1L] ) > cutlo )
		goto L_85;

	/*                                PREPARE FOR PHASE 2. */
	next = 70;
	goto L_105;

	/*                                PREPARE FOR PHASE 4.
	 * */
L_100:
	i = j;
	next = 110;
	sum = (sum/dx[i - 1L])/dx[i - 1L];
L_105:
	xmax = fabs( dx[i - 1L] );
	goto L_115;

	/*                   PHASE 2.  SUM IS SMALL.
	 *                             SCALE TO AVOID DESTRUCTIVE UNDERFLOW.
	 * */
L_70:
	if( fabs( dx[i - 1L] ) > cutlo )
		goto L_75;

	/*                     COMMON CODE FOR PHASES 2 AND 4.
	 *                     IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.
	 * */
L_110:
	if( fabs( dx[i - 1L] ) <= xmax )
		goto L_115;
	sum = one + sum*powi(xmax/dx[i - 1L], 2L);
	xmax = fabs( dx[i - 1L] );
	goto L_200;

L_115:
	sum = sum + powi(dx[i - 1L]/xmax, 2L);
	goto L_200;


	/*                  PREPARE FOR PHASE 3.
	 * */
L_75:
	sum = (sum*xmax)*xmax;


	/*     FOR REAL OR D.P. SET HITEST = CUTHI/N
	 *     FOR COMPLEX      SET HITEST = CUTHI/(2*N)
	 * */
L_85:
	hitest = cuthi/(float)( *n );

	/*                   PHASE 3.  SUM IS MID-RANGE.  NO SCALING.
	 * */
	for( j = i, _do0=DOCNT(j,nn,_do1 = *incx); _do0 > 0; j += _do1, _do0-- ){
		j_ = j - 1;
		if( fabs( dx[j_] ) >= hitest )
			goto L_100;
		sum = sum + powi(dx[j_], 2L);
		}
	dnrm2_v = sqrt( sum );
	goto L_300;

L_200:
	;
	i = i + *incx;
	if( i <= nn )
		goto L_20;

	/*              END OF MAIN LOOP.
	 *
	 *              COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
	 * */
	dnrm2_v = xmax*sqrt( sum );
L_300:
	;
	return( dnrm2_v );
} /* end of function */

/* ------------------------------------------------------------------
 * */
void /*FUNCTION*/ dnwla(op, iovect, n, nband, nval, nfig, nperm, val, 
	 nmvec, vec, nblock, maxop, maxj, nop, p1, p0, res, tau, otau, 
	 t, alp, bet, s, p2, bound, atemp, vtemp, d, ind, small, raritz, 
	 delta, eps, ierr)
void (*op)(), (*iovect)();
long int *n, *nband, *nval, *nfig, *nperm;
double val[];
long int *nmvec;
double *vec;
long int *nblock, *maxop, *maxj, *nop;
double *p1, *p0, res[], tau[], otau[], *t, *alp, *bet, *s, *p2, bound[], 
	 atemp[], vtemp[], d[];
long int ind[];
LOGICAL32 *small, *raritz;
double *delta, *eps;
long int *ierr;
{
#define VEC(I_,J_)	(*(vec+(I_)*(*nmvec)+(J_)))
#define P1(I_,J_)	(*(p1+(I_)*(*n)+(J_)))
#define P0(I_,J_)	(*(p0+(I_)*(*n)+(J_)))
#define T(I_,J_)	(*(t+(I_)*(*nband)+(J_)))
#define ALP(I_,J_)	(*(alp+(I_)*(*nblock)+(J_)))
#define BET(I_,J_)	(*(bet+(I_)*(*nblock)+(J_)))
#define S(I_,J_)	(*(s+(I_)*(*maxj)+(J_)))
#define P2(I_,J_)	(*(p2+(I_)*(*n)+(J_)))
static LOGICAL32 enough, test;
static long int _d_l, _d_m, _do0, _do1, _l0, _l1, _l2, i, i1, i_, 
	 ii, j, k, k_, l, l_, m, mtemp, ng, ngood, nleft, nstart, ntheta, 
	 number;
double ddot(), dnrm2();
static double _d0, _d1, alpmax, alpmin, anorm, betmax, betmin, dzero[1], 
	 epsrt, pnorm, rnorm, tarr[1], temp, tmax, tmin, tola, tolg, utol;
void daxpy(), dcopy(), dlaeig(), dlager(), dlaran(), dmvpc(), dortqr(), 
	 dscal(), dswap(), dvsort();



	/* DNWLA IMPLEMENTS THE LANCZOS ALGORITHM WITH SELECTIVE
	 * ORTHOGONALIZATION.
	 *
	 *   NBAND  NBLOCK + 1  THE BAND WIDTH OF T.
	 *
	 *   NVAL   THE NUMBER OF DESIRED EIGENVALUES.
	 *
	 *   NPERM   THE NUMBER OF PERMANENT VECTORS (THOSE EIGENVECTORS
	 *     INPUT BY THE USER OR THOSE EIGENVECTORS SAVED WHEN THE
	 *     ALGORITHM IS ITERATED).  PERMANENT VECTORS ARE ORTHOGONAL
	 *     TO THE CURRENT KRYLOV SUBSPACE.
	 *
	 *   NOP   THE NUMBER OF CALLS TO OP.
	 *
	 *   P0, P1, AND P2   THE CURRENT BLOCKS OF LANCZOS VECTORS.
	 *
	 *   RES   THE (APPROXIMATE) RESIDUAL NORMS OF THE PERMANENT VECTORS.
	 *
	 *   TAU AND OTAU   USED TO MONITOR THE NEED FOR ORTHOGONALIZATION.
	 *
	 *   T   THE BAND MATRIX.
	 *
	 *   ALP   THE CURRENT DIAGONAL BLOCK.
	 *
	 *   BET   THE CURRENT OFF DIAGONAL BLOCK.
	 *
	 *   BOUND, ATEMP, VTEMP, D  TEMPORARY STORAGE USED BY THE BAND
	 *      EIGENVALUE SOLVER DLAEIG.
	 *
	 *   S   EIGENVECTORS OF T.
	 *
	 *   SMALL   .TRUE.  IF THE SMALL EIGENVALUES ARE DESIRED.
	 *
	 *   RARITZ  RETURNED AS  .TRUE.  IF A FINAL RAYLEIGH-RITZ PROCEDURE
	 *     IS TO BE DONE.
	 *
	 *   DELTA   RETURNED AS THE VALUE OF THE (NVAL+1)TH EIGENVALUE
	 *     OF THE MATRIX.  USED IN ESTIMATING THE ACCURACY OF THE
	 *     COMPUTED EIGENVALUES.
	 *
	 *
	 * INTERNAL VARIABLES USED  
	 * */

	/* J   THE CURRENT DIMENSION OF T.  (THE DIMENSION OF THE CURRENT
	 *    KRYLOV SUBSPACE. 
	 *
	 * NGOOD   THE NUMBER OF GOOD RITZ VECTORS (GOOD VECTORS
	 *    LIE IN THE CURRENT KRYLOV SUBSPACE).
	 *
	 * NLEFT   THE NUMBER OF VALUES WHICH REMAIN TO BE DETERMINED,
	 *    I.E.  NLEFT = NVAL - NPERM.
	 *
	 * NUMBER = NPERM + NGOOD.
	 *
	 * ANORM   AN ESTIMATE OF THE NORM OF THE MATRIX.
	 *
	 * EPS   THE RELATIVE MACHINE PRECISION.
	 *
	 * UTOL   THE USER TOLERANCE.
	 *
	 * TARR  AN ARRAY OF LENGTH ONE USED TO INSURE TYPE CONSISTENCY IN CALLS TO
	 *       DLAEIG
	 *
	 * DZERO AN ARRAY OF LENGTH ONE CONTAINING DZERO, USED TO INSURE TYPE
	 *       CONSISTENCY IN CALLS TO DCOPY
	 * */
	dzero[0L] = 0.0e0;
	rnorm = 0.0e0;
	if( *nperm != 0L )
		rnorm = fmax( -val[0L], val[*nperm - 1L] );
	pnorm = rnorm;
	*delta = 10.e30;
	epsrt = sqrt( *eps );
	nleft = *nval - *nperm;
	*nop = 0L;
	number = *nperm;
	*raritz = FALSE;
	utol = fmax( (double)( (float)( *n ) )**eps, pow(10.0e0, (double)( -(float)( *nfig ) )) );
	j = *maxj;

	/* ------------------------------------------------------------------
	 *
	 * ANY ITERATION OF THE ALGORITHM BEGINS HERE.
	 * */
L_30:
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		temp = dnrm2( n, &P1(i_,0L), ADR(_l0,1L) );
		if( temp == 0e0 )
			dlaran( n, &P1(i_,0L) );
		}
	if( *nperm == 0L )
		goto L_70;
	for( i = 1L; i <= *nperm; i++ ){
		i_ = i - 1;
		tau[i_] = 1.0e0;
		otau[i_] = 0.0e0;
		}
L_70:
	dcopy( ADR(_l0,*n**nblock), dzero, ADR(_l1,0L), p0, ADR(_l2,1L) );
	dcopy( ADR(_l0,*nblock**nblock), dzero, ADR(_l1,0L), bet, ADR(_l2,1L) );
	dcopy( ADR(_l0,j**nband), dzero, ADR(_l1,0L), t, ADR(_l2,1L) );
	mtemp = *nval + 1L;
	for( i = 1L; i <= mtemp; i++ ){
		i_ = i - 1;
		dcopy( &j, dzero, ADR(_l0,0L), &S(i_,0L), ADR(_l1,1L) );
		}
	ngood = 0L;
	tmin = 1.0e30;
	tmax = -1.0e30;
	test = TRUE;
	enough = FALSE;
	betmax = 0.0e0;
	j = 0L;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION TAKES A SINGLE BLOCK LANCZOS STEP.
	 * */
L_80:
	j = j + *nblock;

	/* THIS IS THE SELECTIVE ORTHOGONALIZATION.
	 * */
	if( number == 0L )
		goto L_110;
	for( i = 1L; i <= number; i++ ){
		i_ = i - 1;
		if( tau[i_] < epsrt )
			goto L_100;
		test = TRUE;
		tau[i_] = 0.0e0;
		if( otau[i_] != 0.0e0 )
			otau[i_] = 1.0e0;
		for( k = 1L; k <= *nblock; k++ ){
			k_ = k - 1;
			temp = -ddot( n, &VEC(i_,0L), ADR(_l0,1L), &P1(k_,0L), 
			 ADR(_l1,1L) );
			daxpy( n, &temp, &VEC(i_,0L), ADR(_l0,1L), &P1(k_,0L), 
			 ADR(_l1,1L) );

			/* THIS CHECKS FOR TOO GREAT A LOSS OF ORTHOGONALITY BETWEEN A
			 * NEW LANCZOS VECTOR AND A GOOD RITZ VECTOR.  THE ALGORITHM IS
			 * TERMINATED IF TOO MUCH ORTHOGONALITY IS LOST.
			 * */
			if( fabs( temp*BET(k_,k_) ) > (double)( (float)( *n ) )*
			 epsrt*anorm && i > *nperm )
				goto L_380;
			}
L_100:
		;
		}

	/* IF NECESSARY, THIS REORTHONORMALIZES P1 AND UPDATES BET.
	 * */
L_110:
	if( !test )
		goto L_160;
	dortqr( n, n, nblock, p1, alp );
	test = FALSE;
	if( j == *nblock )
		goto L_160;
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		if( ALP(i_,i_) > 0.0e0 )
			goto L_130;
		m = j - 2L**nblock + i;
		l = *nblock + 1L;
		for( k = i; k <= *nblock; k++ ){
			k_ = k - 1;
			BET(k_,i_) = -BET(k_,i_);
			T(m - 1L,l - 1L) = -T(m - 1L,l - 1L);
			l = l - 1L;
			m = m + 1L;
			}
L_130:
		;
		}

	/* THIS IS THE LANCZOS STEP.
	 * */
L_160:
	(*op)( n, nblock, p1, p2 );
	*nop = *nop + 1L;
	(*iovect)( n, nblock, p1, &j, ADR(_l0,0L) );

	/* THIS COMPUTES P2=P2-P0*BET(TRANSPOSE)
	 * */
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		for( k = i; k <= *nblock; k++ ){
			k_ = k - 1;
			daxpy( n, ADR(_d0,-BET(k_,i_)), &P0(k_,0L), ADR(_l0,1L), 
			 &P2(i_,0L), ADR(_l1,1L) );
			}
		}

	/* THIS COMPUTES ALP AND P2=P2-P1*ALP.
	 * */
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= i; k++ ){
			k_ = k - 1;
			ii = i - k + 1L;
			ALP(k_,ii - 1L) = ddot( n, &P1(i_,0L), ADR(_l0,1L), &P2(k_,0L), 
			 ADR(_l1,1L) );
			daxpy( n, ADR(_d0,-ALP(k_,ii - 1L)), &P1(i_,0L), ADR(_l0,1L), 
			 &P2(k_,0L), ADR(_l1,1L) );
			if( k != i )
				daxpy( n, ADR(_d0,-ALP(k_,ii - 1L)), &P1(k_,0L), ADR(_l0,1L), 
				 &P2(i_,0L), ADR(_l1,1L) );
			}
		}

	/*  REORTHOGONALIZATION OF THE SECOND BLOCK
	 * */
	if( j != *nblock )
		goto L_220;
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= i; k++ ){
			k_ = k - 1;
			temp = ddot( n, &P1(i_,0L), ADR(_l0,1L), &P2(k_,0L), ADR(_l1,1L) );
			daxpy( n, ADR(_d0,-temp), &P1(i_,0L), ADR(_l0,1L), &P2(k_,0L), 
			 ADR(_l1,1L) );
			if( k != i )
				daxpy( n, ADR(_d0,-temp), &P1(k_,0L), ADR(_l0,1L), 
				 &P2(i_,0L), ADR(_l1,1L) );
			ii = i - k + 1L;
			ALP(k_,ii - 1L) = ALP(k_,ii - 1L) + temp;
			}
		}

	/* THIS ORTHONORMALIZES THE NEXT BLOCK
	 * */
L_220:
	dortqr( n, n, nblock, p2, bet );

	/* THIS STORES ALP AND BET IN T.
	 * */
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		m = j - *nblock + i;
		for( k = i; k <= *nblock; k++ ){
			k_ = k - 1;
			l = k - i + 1L;
			T(m - 1L,l - 1L) = ALP(i_,l - 1L);
			}
		for( k = 1L; k <= i; k++ ){
			k_ = k - 1;
			l = *nblock - i + k + 1L;
			T(m - 1L,l - 1L) = BET(i_,k_);
			}
		}

	/* THIS NEGATES T IF SMALL IS FALSE.
	 * */
	if( *small )
		goto L_280;
	m = j - *nblock + 1L;
	for( i = m; i <= j; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= l; k++ ){
			k_ = k - 1;
			T(i_,k_) = -T(i_,k_);
			}
		}

	/* THIS SHIFTS THE LANCZOS VECTORS
	 * */
L_280:
	dcopy( ADR(_l0,*nblock**n), p1, ADR(_l1,1L), p0, ADR(_l2,1L) );
	dcopy( ADR(_l0,*nblock**n), p2, ADR(_l1,1L), p1, ADR(_l2,1L) );
	dlager( &j, nband, ADR(_l0,j - *nblock + 1L), t, &tmin, &tmax );
	anorm = vfmax( rnorm, tmax, -tmin, FEND );
	if( number == 0L )
		goto L_305;

	/* THIS COMPUTES THE EXTREME EIGENVALUES OF ALP.
	 * */
	dcopy( nblock, dzero, ADR(_l0,0L), p2, ADR(_l1,1L) );
	dlaeig( nblock, nblock, ADR(_l0,1L), ADR(_l1,1L), alp, tarr, nblock, 
	 p2, bound, atemp, d, vtemp, eps, &tmin, &tmax );
	alpmin = tarr[0L];
	dcopy( nblock, dzero, ADR(_l0,0L), p2, ADR(_l1,1L) );
	dlaeig( nblock, nblock, nblock, nblock, alp, tarr, nblock, p2, 
	 bound, atemp, d, vtemp, eps, &tmin, &tmax );
	alpmax = tarr[0L];

	/* THIS COMPUTES ALP = BET(TRANSPOSE)*BET.
	 * */
L_305:
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= i; k++ ){
			k_ = k - 1;
			l = i - k + 1L;
			ALP(k_,l - 1L) = ddot( ADR(_l0,*nblock - i + 1L), &BET(i_,i_), 
			 nblock, &BET(i_,k_), nblock );
			}
		}
	if( number == 0L )
		goto L_330;

	/* THIS COMPUTES THE SMALLEST SINGULAR VALUE OF BET.
	 * */
	dcopy( nblock, dzero, ADR(_l0,0L), p2, ADR(_l1,1L) );
	dlaeig( nblock, nblock, ADR(_l0,1L), ADR(_l1,1L), alp, tarr, nblock, 
	 p2, bound, atemp, d, vtemp, eps, ADR(_d0,0.0e0), ADR(_d1,anorm*
	 anorm) );
	betmin = sqrt( tarr[0L] );

	/* THIS UPDATES TAU AND OTAU.
	 * */
	for( i = 1L; i <= number; i++ ){
		i_ = i - 1;
		temp = (tau[i_]*fmax( alpmax - val[i_], val[i_] - alpmin ) + 
		 otau[i_]*betmax + *eps*anorm)/betmin;
		if( i <= *nperm )
			temp = temp + res[i_]/betmin;
		otau[i_] = tau[i_];
		tau[i_] = temp;
		}

	/* THIS COMPUTES THE LARGEST SINGULAR VALUE OF BET.
	 * */
L_330:
	dcopy( nblock, dzero, ADR(_l0,0L), p2, ADR(_l1,1L) );
	dlaeig( nblock, nblock, nblock, nblock, alp, tarr, nblock, p2, 
	 bound, atemp, d, vtemp, eps, ADR(_d0,0.0e0), ADR(_d1,anorm*anorm) );
	betmax = sqrt( tarr[0L] );
	if( j <= 2L**nblock )
		goto L_80;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION COMPUTES AND EXAMINES THE SMALLEST NONGOOD AND
	 * LARGEST DESIRED EIGENVALUES OF T TO SEE IF A CLOSER LOOK
	 * IS JUSTIFIED.
	 * */
	tolg = epsrt*anorm;
	tola = utol*rnorm;
	if( *maxj - j < *nblock || (*nop >= *maxop && nleft != 0L) )
		goto L_390;
	goto L_400;


	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION COMPUTES SOME EIGENVALUES AND EIGENVECTORS OF T TO
	 * SEE IF FURTHER ACTION IS INDICATED, ENTRY IS AT 380 OR 390 IF AN
	 * ITERATION (OR TERMINATION) IS KNOWN TO BE NEEDED, OTHERWISE ENTRY
	 * IS AT 400.
	 * */
L_380:
	j = j - *nblock;
	*ierr = -8L;
L_390:
	if( nleft == 0L )
		return;
	test = TRUE;
L_400:
	ntheta = min( j/2L, nleft + 1L );
	dlaeig( &j, nband, ADR(_l0,1L), &ntheta, t, &val[number], maxj, 
	 s, bound, atemp, d, vtemp, eps, &tmin, &tmax );
	dmvpc( nblock, bet, maxj, &j, s, &ntheta, atemp, vtemp, d );

	/* THIS CHECKS FOR TERMINATION OF A CHECK RUN
	 * */
	if( nleft != 0L || j < 6L**nblock )
		goto L_410;
	if( val[number] - atemp[0L] > val[*nperm - 1L] - tola )
		goto L_790;

	/* THIS UPDATES NLEFT BY EXAMINING THE COMPUTED EIGENVALUES OF T
	 * TO DETERMINE IF SOME PERMANENT VALUES ARE NO LONGER DESIRED.
	 * */
L_410:
	if( ntheta <= nleft )
		goto L_470;
	if( *nperm == 0L )
		goto L_430;
	m = number + nleft + 1L;
	if( val[m - 1L] >= val[*nperm - 1L] )
		goto L_430;
	*nperm = *nperm - 1L;
	ngood = 0L;
	number = *nperm;
	nleft = nleft + 1L;
	goto L_400;

	/* THIS UPDATES DELTA.
	 * */
L_430:
	m = number + nleft + 1L;
	*delta = fmin( *delta, val[m - 1L] );
	enough = TRUE;
	if( nleft == 0L )
		goto L_80;
	ntheta = nleft;
	vtemp[ntheta] = 1L;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION EXAMINES THE COMPUTED EIGENPAIRS IN DETAIL.
	 *
	 * THIS CHECKS FOR ENOUGH ACCEPTABLE VALUES.
	 * */
	if( !(test || enough) )
		goto L_470;
	*delta = fmin( *delta, anorm );
	pnorm = fmax( rnorm, fmax( -val[number], *delta ) );
	tola = utol*pnorm;
	nstart = 0L;
	for( i = 1L; i <= ntheta; i++ ){
		i_ = i - 1;
		m = number + i;
		if( fmin( atemp[i_]*atemp[i_]/(*delta - val[m - 1L]), atemp[i_] ) > 
		 tola )
			goto L_450;
		ind[i_] = -1L;
		goto L_460;

L_450:
		enough = FALSE;
		if( !test )
			goto L_470;
		ind[i_] = 1L;
		nstart = nstart + 1L;
L_460:
		;
		}

	/*  COPY VALUES OF IND INTO VTEMP
	 * */
	for( i = 1L; i <= ntheta; i++ ){
		i_ = i - 1;
		vtemp[i_] = (double)( (float)( ind[i_] ) );
		}
	goto L_500;

	/* THIS CHECKS FOR NEW GOOD VECTORS.
	 * */
L_470:
	ng = 0L;
	for( i = 1L; i <= ntheta; i++ ){
		i_ = i - 1;
		if( vtemp[i_] > tolg )
			goto L_480;
		ng = ng + 1L;
		vtemp[i_] = -1L;
		goto L_490;

L_480:
		vtemp[i_] = 1L;
L_490:
		;
		}

	if( ng <= ngood )
		goto L_80;
	nstart = ntheta - ng;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION COMPUTES AND NORMALIZES THE INDICATED RITZ VECTORS.
	 * IF NEEDED (TEST = .TRUE.), NEW STARTING VECTORS ARE COMPUTED.
	 * */
L_500:
	test = test && !enough;
	ngood = ntheta - nstart;
	nstart = nstart + 1L;
	ntheta = ntheta + 1L;

	/* THIS ALIGNS THE DESIRED (ACCEPTABLE OR GOOD) EIGENVALUES AND
	 * EIGENVECTORS OF T.  THE OTHER EIGENVECTORS ARE SAVED FOR
	 * FORMING STARTING VECTORS, IF NECESSARY.  IT ALSO SHIFTS THE
	 * EIGENVALUES TO OVERWRITE THE GOOD VALUES FROM THE PREVIOUS
	 * PAUSE.
	 * */
	dcopy( &ntheta, &val[number], ADR(_l0,1L), &val[*nperm], ADR(_l1,1L) );
	if( nstart == 0L )
		goto L_580;
	if( nstart == ntheta )
		goto L_530;
	dvsort( &ntheta, vtemp, atemp, ADR(_l0,1L), &val[*nperm], maxj, 
	 &j, s );

	/* THES ACCUMULATES THE J-VECTORS USED TO FORM THE STARTING
	 * VECTORS.
	 * */
L_530:
	if( !test )
		nstart = 0L;
	if( !test )
		goto L_580;

	/*  FIND MINIMUM ATEMP VALUE TO AVOID POSSIBLE OVERFLOW
	 * */
	temp = atemp[0L];
	for( i = 1L; i <= nstart; i++ ){
		i_ = i - 1;
		temp = fmin( temp, atemp[i_] );
		}
	m = ngood + 1L;
	l = ngood + min( nstart, *nblock );
	for( i = m; i <= l; i++ ){
		i_ = i - 1;
		dscal( &j, ADR(_d0,temp/atemp[i_]), &S(i_,0L), ADR(_l0,1L) );
		}
	m = (nstart - 1L)/ *nblock;
	if( m == 0L )
		goto L_570;
	l = ngood + *nblock;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= *nblock; k++ ){
			k_ = k - 1;
			l = l + 1L;
			if( l > ntheta )
				goto L_570;
			i1 = ngood + k;
			daxpy( &j, ADR(_d0,temp/atemp[l - 1L]), &S(l - 1L,0L), 
			 ADR(_l0,1L), &S(i1 - 1L,0L), ADR(_l1,1L) );
			}
		}
L_570:
	nstart = min( nstart, *nblock );

	/* THIS STORES THE RESIDUAL NORMS OF THE NEW PERMANENT VECTORS.
	 * */
L_580:
	if( ngood == 0L || !(test || enough) )
		goto L_600;
	for( i = 1L; i <= ngood; i++ ){
		i_ = i - 1;
		m = *nperm + i;
		res[m - 1L] = atemp[i_];
		}

	/* THIS COMPUTES THE RITZ VECTORS BY SEQUENTIALLY RECALLING THE
	 * LANCZOS VECTORS.
	 * */
L_600:
	number = *nperm + ngood;
	if( test || enough )
		dcopy( ADR(_l0,*n**nblock), dzero, ADR(_l1,0L), p1, ADR(_l2,1L) );
	if( ngood == 0L )
		goto L_620;
	m = *nperm + 1L;
	for( i = m; i <= number; i++ ){
		i_ = i - 1;
		dcopy( n, dzero, ADR(_l0,0L), &VEC(i_,0L), ADR(_l1,1L) );
		}
L_620:
	for( i = *nblock, _do0=DOCNT(i,j,_do1 = *nblock); _do0 > 0; i += _do1, _do0-- ){
		i_ = i - 1;
		(*iovect)( n, nblock, p2, &i, ADR(_l0,1L) );
		for( k = 1L; k <= *nblock; k++ ){
			k_ = k - 1;
			m = i - *nblock + k;
			if( nstart == 0L )
				goto L_640;
			for( l = 1L; l <= nstart; l++ ){
				l_ = l - 1;
				i1 = ngood + l;
				daxpy( n, &S(i1 - 1L,m - 1L), &P2(k_,0L), ADR(_l0,1L), 
				 &P1(l_,0L), ADR(_l1,1L) );
				}
L_640:
			if( ngood == 0L )
				goto L_660;
			for( l = 1L; l <= ngood; l++ ){
				l_ = l - 1;
				i1 = l + *nperm;
				daxpy( n, &S(l_,m - 1L), &P2(k_,0L), ADR(_l0,1L), 
				 &VEC(i1 - 1L,0L), ADR(_l1,1L) );
				}
L_660:
			;
			}
		}
	if( test || enough )
		goto L_690;

	/* THIS NORMALIZES THE RITZ VECTORS AND INITIALIZES THE
	 * TAU RECURRENCE.
	 * */
	m = *nperm + 1L;
	for( i = m; i <= number; i++ ){
		i_ = i - 1;
		temp = 1.0e0/dnrm2( n, &VEC(i_,0L), ADR(_l0,1L) );
		dscal( n, &temp, &VEC(i_,0L), ADR(_l0,1L) );
		tau[i_] = 1.0e0;
		otau[i_] = 1.0e0;
		}

	/*  SHIFT S VECTORS TO ALIGN FOR LATER CALL TO DLAEIG
	 * */
	dcopy( &ntheta, &val[*nperm], ADR(_l0,1L), vtemp, ADR(_l1,1L) );
	dvsort( &ntheta, vtemp, atemp, ADR(_l0,0L), tarr, maxj, &j, s );
	goto L_80;

	/* ------------------------------------------------------------------
	 *
	 * THIS SECTION PREPARES TO ITERATE THE ALGORITHM BY SORTING THE
	 * PERMANENT VALUES, RESETTING SOME PARAMETERS, AND ORTHONORMALIZING
	 * THE PERMANENT VECTORS.
	 * */
L_690:
	if( ngood == 0L && *nop >= *maxop )
		goto L_810;
	if( ngood == 0L )
		goto L_30;

	/* THIS ORTHONORMALIZES THE VECTORS
	 * */
	dortqr( nmvec, n, ADR(_l0,*nperm + ngood), vec, s );

	/* THIS SORTS THE VALUES AND VECTORS.
	 * */
	if( *nperm != 0L )
		dvsort( ADR(_l0,*nperm + ngood), val, res, ADR(_l1,0L), &temp, 
		 nmvec, n, vec );
	*nperm = *nperm + ngood;
	nleft = nleft - ngood;
	rnorm = fmax( -val[0L], val[*nperm - 1L] );

	/* THIS DECIDES WHERE TO GO NEXT.
	 * */
	if( *nop >= *maxop && nleft != 0L )
		goto L_810;
	if( nleft != 0L )
		goto L_30;
	if( val[*nval - 1L] - val[0L] < tola )
		goto L_790;

	/* THIS DOES A CLUSTER TEST TO SEE IF A CHECK RUN IS NEEDED
	 * TO LOOK FOR UNDISCLOSED MULTIPLICITIES.
	 * */
	m = *nperm - *nblock + 1L;
	if( m <= 0L )
		return;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		l = i + *nblock - 1L;
		if( val[l - 1L] - val[i_] < tola )
			goto L_30;
		}

	/* THIS DOES A CLUSTER TEST TO SEE IF A FINAL RAYLEIGH-RITZ
	 * PROCEDURE IS NEEDED.
	 * */
L_790:
	m = *nperm - *nblock;
	if( m <= 0L )
		return;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		l = i + *nblock;
		if( val[l - 1L] - val[i_] >= tola )
			goto L_800;
		*raritz = TRUE;
		return;
L_800:
		;
		}

	return;

	/* ------------------------------------------------------------------
	 *
	 * THIS REPORTS THAT MAXOP WAS EXCEEDED.
	 * */
L_810:
	*ierr = -2L;
	goto L_790;

#undef	S
#undef	BET
#undef	ALP
#undef	T
#undef	P2
#undef	P1
#undef	P0
#undef	VEC
} /* end of function */

/* ------------------------------------------------------------------
 * */
void /*FUNCTION*/ dortqr(nz, n, nblock, z, b)
long int *nz, *n, *nblock;
double *z, *b;
{
#define Z(I_,J_)	(*(z+(I_)*(*nz)+(J_)))
#define B(I_,J_)	(*(b+(I_)*(*nblock)+(J_)))
static long int _l0, _l1, i, i_, j, k, k_, length, m, m_;
double ddot(), dnrm2();
static double _d0, sigma, tau, temp;
void daxpy(), dscal();



	/* THIS SUBROUTINE COMPUTES THE QR FACTORIZATION OF THE N X NBLOCK
	 * MATRIX Z.  Q IS FORMED IN PLACE AND RETURNED IN Z.  R IS
	 * RETURNED IN B.
	 * */

	/* THIS SECTION REDUCES Z TO TRIANGULAR FORM.
	 * */
	for( i = 1L; i <= *nblock; i++ ){
		i_ = i - 1;

		/* THIS FORMS THE ITH REFLECTION.
		 * */
		length = *n - i + 1L;
		sigma = sign( dnrm2( &length, &Z(i_,i_), ADR(_l0,1L) ), Z(i_,i_) );
		B(i_,i_) = -sigma;
		Z(i_,i_) = Z(i_,i_) + sigma;
		tau = sigma*Z(i_,i_);
		if( i == *nblock )
			goto L_30;
		j = i + 1L;

		/* THIS APPLIES THE ROTATION TO THE REST OF THE COLUMNS.
		 * */
		for( k = j; k <= *nblock; k++ ){
			k_ = k - 1;
			if( tau == 0.0e0 )
				goto L_10;
			temp = -ddot( &length, &Z(i_,i_), ADR(_l0,1L), &Z(k_,i_), 
			 ADR(_l1,1L) )/tau;
			daxpy( &length, &temp, &Z(i_,i_), ADR(_l0,1L), &Z(k_,i_), 
			 ADR(_l1,1L) );
L_10:
			B(k_,i_) = Z(k_,i_);
			Z(k_,i_) = 0.0e0;
			}
L_30:
		;
		}

	/* THIS ACCUMULATES THE REFLECTIONS IN REVERSE ORDER.
	 * */
	for( m = 1L; m <= *nblock; m++ ){
		m_ = m - 1;

		/* THIS RECREATES THE ITH = NBLOCK-M+1)TH REFLECTION.
		 * */
		i = *nblock + 1L - m;
		sigma = -B(i - 1L,i - 1L);
		tau = Z(i - 1L,i - 1L)*sigma;
		if( tau == 0.0e0 )
			goto L_60;
		length = *n - *nblock + m;
		if( i == *nblock )
			goto L_50;
		j = i + 1L;

		/* THIS APPLIES IT TO THE LATER COLUMNS.
		 * */
		for( k = j; k <= *nblock; k++ ){
			k_ = k - 1;
			temp = -ddot( &length, &Z(i - 1L,i - 1L), ADR(_l0,1L), 
			 &Z(k_,i - 1L), ADR(_l1,1L) )/tau;
			daxpy( &length, &temp, &Z(i - 1L,i - 1L), ADR(_l0,1L), 
			 &Z(k_,i - 1L), ADR(_l1,1L) );
			}
L_50:
		dscal( &length, ADR(_d0,-1.0e0/sigma), &Z(i - 1L,i - 1L), 
		 ADR(_l0,1L) );
L_60:
		Z(i - 1L,i - 1L) = 1.0e0 + Z(i - 1L,i - 1L);
		}
	return;
#undef	B
#undef	Z
} /* end of function */

void /*FUNCTION*/ dscal(n, da, dx, incx)
long int *n;
double *da, dx[];
long int *incx;
{
static long int _d_l, _d_m, _do0, _do1, i, i_, m, mp1, nincx;


	/*     SCALES A VECTOR BY A CONSTANT.
	 *     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
	 *     JACK DONGARRA, LINPACK, 3/11/78.
	 * */

	if( *n <= 0L )
		return;
	if( *incx == 1L )
		goto L_20;

	/*        CODE FOR INCREMENT NOT EQUAL TO 1
	 * */
	nincx = *n**incx;
	for( i = 1L, _do0=DOCNT(i,nincx,_do1 = *incx); _do0 > 0; i += _do1, _do0-- ){
		i_ = i - 1;
		dx[i_] = *da*dx[i_];
		}
	return;

	/*        CODE FOR INCREMENT EQUAL TO 1
	 *
	 *
	 *        CLEAN-UP LOOP
	 * */
L_20:
	m = *n%5L;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dx[i_] = *da*dx[i_];
		}
	if( *n < 5L )
		return;
L_40:
	mp1 = m + 1L;
	for( i = mp1; i <= *n; i += 5L ){
		i_ = i - 1;
		dx[i_] = *da*dx[i_];
		dx[i_ + 1L] = *da*dx[i_ + 1L];
		dx[i_ + 2L] = *da*dx[i_ + 2L];
		dx[i_ + 3L] = *da*dx[i_ + 3L];
		dx[i_ + 4L] = *da*dx[i_ + 4L];
		}
	return;
} /* end of function */

/*-------------------------------------------------------------------
 * */
void /*FUNCTION*/ dvsort(num, val, res, iflag, v, nmvec, n, vec)
long int *num;
double val[], res[];
long int *iflag;
double v[];
long int *nmvec, *n;
double *vec;
{
#define VEC(I_,J_)	(*(vec+(I_)*(*nmvec)+(J_)))
static long int _l0, _l1, i, i_, k, k_, m;
static double temp;
void dswap();


	/*  THIS SUBROUTINE SORTS THE EIGENVALUES (VAL) IN ASCENDING ORDER
	 *  WHILE CONCURRENTLY SWAPPING THE RESIDUALS AND VECTORS. */
	if( *num <= 1L )
		return;
	for( i = 2L; i <= *num; i++ ){
		i_ = i - 1;
		m = *num - i + 1L;
		for( k = 1L; k <= m; k++ ){
			k_ = k - 1;
			if( val[k_] <= val[k_ + 1L] )
				goto L_10;
			temp = val[k_];
			val[k_] = val[k_ + 1L];
			val[k_ + 1L] = temp;
			temp = res[k_];
			res[k_] = res[k_ + 1L];
			res[k_ + 1L] = temp;
			dswap( n, &VEC(k_,0L), ADR(_l0,1L), &VEC(k_ + 1L,0L), 
			 ADR(_l1,1L) );
			if( *iflag == 0L )
				goto L_10;
			temp = v[k_];
			v[k_] = v[k_ + 1L];
			v[k_ + 1L] = temp;
L_10:
			;
			}
		}
	return;
#undef	VEC
} /* end of function */

void /*FUNCTION*/ daxpy(n, da, dx, incx, dy, incy)
long int *n;
double *da, dx[];
long int *incx;
double dy[];
long int *incy;
{
static long int i, i_, ix, iy, m, mp1;


	/*     CONSTANT TIMES A VECTOR PLUS A VECTOR.
	 *     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
	 *     JACK DONGARRA, LINPACK, 3/11/78.
	 * */

	if( *n <= 0L )
		return;
	if( *da == 0.0e0 )
		return;
	if( *incx == 1L && *incy == 1L )
		goto L_20;

	/*        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
	 *          NOT EQUAL TO 1
	 * */
	ix = 1L;
	iy = 1L;
	if( *incx < 0L )
		ix = (-*n + 1L)**incx + 1L;
	if( *incy < 0L )
		iy = (-*n + 1L)**incy + 1L;
	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		dy[iy - 1L] = dy[iy - 1L] + *da*dx[ix - 1L];
		ix = ix + *incx;
		iy = iy + *incy;
		}
	return;

	/*        CODE FOR BOTH INCREMENTS EQUAL TO 1
	 *
	 *
	 *        CLEAN-UP LOOP
	 * */
L_20:
	m = *n%4L;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dy[i_] = dy[i_] + *da*dx[i_];
		}
	if( *n < 4L )
		return;
L_40:
	mp1 = m + 1L;
	for( i = mp1; i <= *n; i += 4L ){
		i_ = i - 1;
		dy[i_] = dy[i_] + *da*dx[i_];
		dy[i_ + 1L] = dy[i_ + 1L] + *da*dx[i_ + 1L];
		dy[i_ + 2L] = dy[i_ + 2L] + *da*dx[i_ + 2L];
		dy[i_ + 3L] = dy[i_ + 3L] + *da*dx[i_ + 3L];
		}
	return;
} /* end of function */

void /*FUNCTION*/ dcopy(n, dx, incx, dy, incy)
long int *n;
double dx[];
long int *incx;
double dy[];
long int *incy;
{
static long int i, i_, ix, iy, m, mp1;


	/*     COPIES A VECTOR, X, TO A VECTOR, Y.
	 *     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
	 *     JACK DONGARRA, LINPACK, 3/11/78.
	 * */

	if( *n <= 0L )
		return;
	if( *incx == 1L && *incy == 1L )
		goto L_20;

	/*        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
	 *          NOT EQUAL TO 1
	 * */
	ix = 1L;
	iy = 1L;
	if( *incx < 0L )
		ix = (-*n + 1L)**incx + 1L;
	if( *incy < 0L )
		iy = (-*n + 1L)**incy + 1L;
	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		dy[iy - 1L] = dx[ix - 1L];
		ix = ix + *incx;
		iy = iy + *incy;
		}
	return;

	/*        CODE FOR BOTH INCREMENTS EQUAL TO 1
	 *
	 *
	 *        CLEAN-UP LOOP
	 * */
L_20:
	m = *n%7L;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dy[i_] = dx[i_];
		}
	if( *n < 7L )
		return;
L_40:
	mp1 = m + 1L;
	for( i = mp1; i <= *n; i += 7L ){
		i_ = i - 1;
		dy[i_] = dx[i_];
		dy[i_ + 1L] = dx[i_ + 1L];
		dy[i_ + 2L] = dx[i_ + 2L];
		dy[i_ + 3L] = dx[i_ + 3L];
		dy[i_ + 4L] = dx[i_ + 4L];
		dy[i_ + 5L] = dx[i_ + 5L];
		dy[i_ + 6L] = dx[i_ + 6L];
		}
	return;
} /* end of function */

double /*FUNCTION*/ ddot(n, dx, incx, dy, incy)
long int *n;
double dx[];
long int *incx;
double dy[];
long int *incy;
{
static long int i, i_, ix, iy, m, mp1;
static double ddot_v, dtemp;


	/*     FORMS THE DOT PRODUCT OF TWO VECTORS.
	 *     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
	 *     JACK DONGARRA, LINPACK, 3/11/78.
	 * */

	ddot_v = 0.0e0;
	dtemp = 0.0e0;
	if( *n <= 0L )
		return( ddot_v );
	if( *incx == 1L && *incy == 1L )
		goto L_20;

	/*        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
	 *          NOT EQUAL TO 1
	 * */
	ix = 1L;
	iy = 1L;
	if( *incx < 0L )
		ix = (-*n + 1L)**incx + 1L;
	if( *incy < 0L )
		iy = (-*n + 1L)**incy + 1L;
	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		dtemp = dtemp + dx[ix - 1L]*dy[iy - 1L];
		ix = ix + *incx;
		iy = iy + *incy;
		}
	ddot_v = dtemp;
	return( ddot_v );

	/*        CODE FOR BOTH INCREMENTS EQUAL TO 1
	 *
	 *
	 *        CLEAN-UP LOOP
	 * */
L_20:
	m = *n%5L;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dtemp = dtemp + dx[i_]*dy[i_];
		}
	if( *n < 5L )
		goto L_60;
L_40:
	mp1 = m + 1L;
	for( i = mp1; i <= *n; i += 5L ){
		i_ = i - 1;
		dtemp = dtemp + dx[i_]*dy[i_] + dx[i_ + 1L]*dy[i_ + 1L] + 
		 dx[i_ + 2L]*dy[i_ + 2L] + dx[i_ + 3L]*dy[i_ + 3L] + dx[i_ + 4L]*
		 dy[i_ + 4L];
		}
L_60:
	ddot_v = dtemp;
	return( ddot_v );
} /* end of function */


void /*FUNCTION*/ dlaeig(n, nband, nl, nr, a, eigval, lde, eigvec, 
	 bound, atemp, d, vtemp, eps, tmin, tmax)
long int *n, *nband, *nl, *nr;
double *a, eigval[];
long int *lde;
double *eigvec, bound[][2], atemp[], d[], vtemp[], *eps, *tmin, *tmax;
{
#define A(I_,J_)	(*(a+(I_)*(*nband)+(J_)))
#define EIGVEC(I_,J_)	(*(eigvec+(I_)*(*lde)+(J_)))
static long int i, i_, m, nval;
static double artol, atol;
void dlabcm();


	/*  THIS IS A SPECIALIZED VERSION OF THE SUBROUTINE BNDEIG TAILORED
	 *  SPECIFICALLY FOR USE BY THE LASO PACKAGE.
	 * */

	/*  LOCAL VARIABLES
	 * */

	/*  FUNCTIONS CALLED
	 * */

	/*  SUBROUTINES CALLED
	 *
	 *     DLABCM, DLABFC, DLAGER, DCOPY
	 *
	 *  SET PARAMETERS
	 * */
	atol = (double)( (float)( *n ) )**eps*fmax( *tmax, -*tmin );
	artol = atol/sqrt( *eps );
	nval = *nr - *nl + 1L;

	/*   CHECK FOR SPECIAL CASE OF N = 1
	 * */
	if( *n != 1L )
		goto L_30;
	eigval[0L] = A(0L,0L);
	EIGVEC(0L,0L) = 1.0e0;
	return;

	/*   SET UP INITIAL EIGENVALUE BOUNDS
	 * */
L_30:
	m = nval + 1L;
	for( i = 2L; i <= m; i++ ){
		i_ = i - 1;
		bound[i_][0L] = *tmin;
		bound[i_][1L] = *tmax;
		}
	bound[0L][1L] = *tmax;
	bound[nval + 1L][0L] = *tmin;
	if( *nl == 1L )
		bound[0L][1L] = *tmin;
	if( *nr == *n )
		bound[nval + 1L][0L] = *tmax;

L_60:
	dlabcm( n, nband, nl, nr, a, eigval, lde, eigvec, &atol, &artol, 
	 bound, atemp, d, vtemp );
	return;
#undef	EIGVEC
#undef	A
} /* end of function */

/************************************************************************
 * */
void /*FUNCTION*/ dlager(n, nband, nstart, a, tmin, tmax)
long int *n, *nband, *nstart;
double *a, *tmin, *tmax;
{
#define A(I_,J_)	(*(a+(I_)*(*nband)+(J_)))
static long int i, i_, k, k_, l, m;
static double temp;


	/*  THIS SUBROUTINE COMPUTES BOUNDS ON THE SPECTRUM OF A BY
	 *  EXAMINING THE GERSCHGORIN CIRCLES. ONLY THE NEWLY CREATED
	 *  CIRCLES ARE EXAMINED
	 *
	 *  FORMAL PARAMETERS
	 * */

	/*  LOCAL VARIABLES
	 * */

	/*  FUNCTIONS CALLED
	 * */

	for( k = *nstart; k <= *n; k++ ){
		k_ = k - 1;
		temp = 0.0e0;
		for( i = 2L; i <= *nband; i++ ){
			i_ = i - 1;
			temp = temp + fabs( A(k_,i_) );
			}
L_20:
		l = min( k, *nband );
		if( l == 1L )
			goto L_40;
		for( i = 2L; i <= l; i++ ){
			i_ = i - 1;
			m = k - i + 1L;
			temp = temp + fabs( A(m - 1L,i_) );
			}
L_40:
		*tmin = fmin( *tmin, A(k_,0L) - temp );
		*tmax = fmax( *tmax, A(k_,0L) + temp );
		}
	return;
#undef	A
} /* end of function */

/************************************************************************
 * */
void /*FUNCTION*/ dlaran(n, x)
long int *n;
double x[];
{
static long int i, i_;
double urand();
static long iurand = 0;


	/*  THIS SUBROUTINE SETS THE VECTOR X TO RANDOM NUMBERS
	 *
	 *  FORMAL PARAMETERS
	 * */

	/*  LOCAL VARIABLES
	 * */

	/*  FUNCTIONS CALLED
	 * */

	/*  SUBROUTINES CALLED
	 *
	 *     NONE
	 *
	 *  INITIALIZE SEED
	 * */

	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		x[i_] = (double)( urand( &iurand ) ) - 0.5e0;
		}
	return;
} /* end of function */

/* ------------------------------------------------------------------
 * */
void /*FUNCTION*/ dmvpc(nblock, bet, maxj, j, s, number, resnrm, orthcf, 
	 rv)
long int *nblock;
double *bet;
long int *maxj, *j;
double *s;
long int *number;
double resnrm[], orthcf[], rv[];
{
#define BET(I_,J_)	(*(bet+(I_)*(*nblock)+(J_)))
#define S(I_,J_)	(*(s+(I_)*(*maxj)+(J_)))
static long int _l0, i, i_, k, k_, m;
double ddot(), dnrm2();



	/* THIS SUBROUTINE COMPUTES THE NORM AND THE SMALLEST ELEMENT
	 * (IN ABSOLUTE VALUE) OF THE VECTOR BET*SJI, WHERE SJI
	 * IS AN NBLOCK VECTOR OF THE LAST NBLOCK ELEMENTS OF THE ITH
	 * EIGENVECTOR OF T.  THESE QUANTITIES ARE THE RESIDUAL NORM
	 * AND THE ORTHOGONALITY COEFFICIENT RESPECTIVELY FOR THE
	 * CORRESPONDING RITZ PAIR.  THE ORTHOGONALITY COEFFICIENT IS
	 * NORMALIZED TO ACCOUNT FOR THE LOCAL REORTHOGONALIZATION.
	 * */

	m = *j - *nblock + 1L;
	for( i = 1L; i <= *number; i++ ){
		i_ = i - 1;
		for( k = 1L; k <= *nblock; k++ ){
			k_ = k - 1;
			rv[k_] = ddot( nblock, &S(i_,m - 1L), ADR(_l0,1L), &BET(0L,k_), 
			 nblock );
			if( k == 1L )
				orthcf[i_] = fabs( rv[k_] );
			orthcf[i_] = fmin( orthcf[i_], fabs( rv[k_] ) );
			}
		resnrm[i_] = dnrm2( nblock, rv, ADR(_l0,1L) );
		}
	return;
#undef	S
#undef	BET
} /* end of function */

void /*FUNCTION*/ dswap(n, dx, incx, dy, incy)
long int *n;
double dx[];
long int *incx;
double dy[];
long int *incy;
{
static long int i, i_, ix, iy, m, mp1;
static double dtemp;


	/*     INTERCHANGES TWO VECTORS.
	 *     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.
	 *     JACK DONGARRA, LINPACK, 3/11/78.
	 * */

	if( *n <= 0L )
		return;
	if( *incx == 1L && *incy == 1L )
		goto L_20;

	/*       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
	 *         TO 1
	 * */
	ix = 1L;
	iy = 1L;
	if( *incx < 0L )
		ix = (-*n + 1L)**incx + 1L;
	if( *incy < 0L )
		iy = (-*n + 1L)**incy + 1L;
	for( i = 1L; i <= *n; i++ ){
		i_ = i - 1;
		dtemp = dx[ix - 1L];
		dx[ix - 1L] = dy[iy - 1L];
		dy[iy - 1L] = dtemp;
		ix = ix + *incx;
		iy = iy + *incy;
		}
	return;

	/*       CODE FOR BOTH INCREMENTS EQUAL TO 1
	 *
	 *
	 *       CLEAN-UP LOOP
	 * */
L_20:
	m = *n%3L;
	if( m == 0L )
		goto L_40;
	for( i = 1L; i <= m; i++ ){
		i_ = i - 1;
		dtemp = dx[i_];
		dx[i_] = dy[i_];
		dy[i_] = dtemp;
		}
	if( *n < 3L )
		return;
L_40:
	mp1 = m + 1L;
	for( i = mp1; i <= *n; i += 3L ){
		i_ = i - 1;
		dtemp = dx[i_];
		dx[i_] = dy[i_];
		dy[i_] = dtemp;
		dtemp = dx[i_ + 1L];
		dx[i_ + 1L] = dy[i_ + 1L];
		dy[i_ + 1L] = dtemp;
		dtemp = dx[i_ + 2L];
		dx[i_ + 2L] = dy[i_ + 2L];
		dy[i_ + 2L] = dtemp;
		}
	return;
} /* end of function */
/*   from Forsythe, Malcolm, and Moler */
double /*FUNCTION*/ urand(iy)
long int *iy;
{
static long int ia, ic, m, mic;
static float s, urand_v;
static double halfm;
static long m2 = 0;
static long itwo = 2;


	/*      URAND IS A UNIFORM RANDOM NUMBER GENERATOR BASED  ON  THEORY  AND
	 *  SUGGESTIONS  GIVEN  IN  D.E. KNUTH (1969),  VOL  2.   THE INTEGER  IY
	 *  SHOULD BE INITIALIZED TO AN ARBITRARY INTEGER PRIOR TO THE FIRST CALL
	 *  TO URAND.  THE CALLING PROGRAM SHOULD  NOT  ALTER  THE  VALUE  OF  IY
	 *  BETWEEN  SUBSEQUENT CALLS TO URAND.  VALUES OF URAND WILL BE RETURNED
	 *  IN THE INTERVAL (0,1).
	 * */
	if( m2 != 0L )
		goto L_20;

	/*  IF FIRST ENTRY, COMPUTE MACHINE INTEGER WORD LENGTH
	 * */
	m = 1L;
L_10:
	m2 = m;
	m = itwo*m2;
	if( m > m2 )
		goto L_10;
	halfm = m2;

	/*  COMPUTE MULTIPLIER AND INCREMENT FOR LINEAR CONGRUENTIAL METHOD
	 * */
	ia = 8L*(long)( halfm*atan( 1.e0 )/8.e0 ) + 5L;
	ic = 2L*(long)( halfm*(0.5e0 - sqrt( 3.e0 )/6.e0) ) + 1L;
	mic = (m2 - ic) + m2;

	/*  S IS THE SCALE FACTOR FOR CONVERTING TO FLOATING POINT
	 * */
	s = 0.5/halfm;

	/*  COMPUTE NEXT RANDOM NUMBER
	 * */
L_20:
	*iy = *iy*ia;

	/*  THE FOLLOWING STATEMENT IS FOR COMPUTERS WHICH DO NOT ALLOW
	 *  INTEGER OVERFLOW ON ADDITION
	 * */
	if( *iy > mic )
		*iy = (*iy - m2) - m2;

	*iy = *iy + ic;

	/*  THE FOLLOWING STATEMENT IS FOR COMPUTERS WHERE THE
	 *  WORD LENGTH FOR ADDITION IS GREATER THAN FOR MULTIPLICATION
	 * */
	if( *iy/2L > m2 )
		*iy = (*iy - m2) - m2;

	/*  THE FOLLOWING STATEMENT IS FOR COMPUTERS WHERE INTEGER
	 *  OVERFLOW AFFECTS THE SIGN BIT
	 * */
	if( *iy < 0L )
		*iy = (*iy + m2) + m2;
	urand_v = (float)( *iy )*s;
	return( urand_v );
} /* end of function */

/************************************************************************
 * */
void /*FUNCTION*/ dlabcm(n, nband, nl, nr, a, eigval, lde, eigvec, 
	 atol, artol, bound, atemp, d, vtemp)
long int *n, *nband, *nl, *nr;
double *a, eigval[];
long int *lde;
double *eigvec, *atol, *artol, bound[][2], atemp[], d[], vtemp[];
{
#define A(I_,J_)	(*(a+(I_)*(*nband)+(J_)))
#define EIGVEC(I_,J_)	(*(eigvec+(I_)*(*lde)+(J_)))
static LOGICAL32 flag;
static long int _l0, _l1, _l2, _l3, i, i_, j, j_, l, m, numl, numvec, 
	 nval;
double ddot(), dnrm2();
static double _d0, errb, gap, resid, rq, sigma, vnorm;
void daxpy(), dcopy(), dlabax(), dlabfc(), dlaran(), dscal();


	/*  THIS SUBROUTINE ORGANIZES THE CALCULATION OF THE EIGENVALUES
	 *  FOR THE BNDEIG PACKAGE.  EIGENVALUES ARE COMPUTED BY 
	 *  A MODIFIED RAYLEIGH QUOTIENT ITERATION.  THE EIGENVALUE COUNT
	 *  OBTAINED BY EACH FACTORIZATION IS USED TO OCCASIONALLY OVERRIDE
	 *  THE COMPUTED RAYLEIGH QUOTIENT WITH A DIFFERENT SHIFT TO 
	 *  INSURE CONVERGENCE TO THE DESIRED EIGENVALUES.
	 *
	 *  FORMAL PARAMETERS.
	 * */


	/*  LOCAL VARIABLES
	 * */


	/*  FUNCTIONS CALLED
	 * */

	/*  SUBROUTINES CALLED
	 *
	 *     DLABAX, DLABFC, DLARAN, DAXPY, DCOPY, DSCAL
	 *
	 *  REPLACE ZERO VECTORS BY RANDOM
	 * */
	nval = *nr - *nl + 1L;
	flag = FALSE;
	for( i = 1L; i <= nval; i++ ){
		i_ = i - 1;
		if( ddot( n, &EIGVEC(i_,0L), ADR(_l0,1L), &EIGVEC(i_,0L), 
		 ADR(_l1,1L) ) == 0.0e0 )
			dlaran( n, &EIGVEC(i_,0L) );
		}

	/*  LOOP OVER EIGENVALUES
	 * */
	sigma = bound[nval][1L];
	for( j = 1L; j <= nval; j++ ){
		j_ = j - 1;
		numl = j;

		/*  PREPARE TO COMPUTE FIRST RAYLEIGH QUOTIENT
		 * */
L_10:
		dlabax( n, nband, a, &EIGVEC(j_,0L), vtemp );
		vnorm = dnrm2( n, vtemp, ADR(_l0,1L) );
		if( vnorm == 0.0e0 )
			goto L_20;
		dscal( n, ADR(_d0,1.0e0/vnorm), vtemp, ADR(_l0,1L) );
		dscal( n, ADR(_d0,1.0e0/vnorm), &EIGVEC(j_,0L), ADR(_l0,1L) );
		daxpy( n, ADR(_d0,-sigma), &EIGVEC(j_,0L), ADR(_l0,1L), vtemp, 
		 ADR(_l1,1L) );

		/*  LOOP OVER SHIFTS
		 *
		 *  COMPUTE RAYLEIGH QUOTIENT, RESIDUAL NORM, AND CURRENT TOLERANCE
		 * */
L_20:
		vnorm = dnrm2( n, &EIGVEC(j_,0L), ADR(_l0,1L) );
		if( vnorm != 0.0e0 )
			goto L_30;
		dlaran( n, &EIGVEC(j_,0L) );
		goto L_10;

L_30:
		rq = sigma + ddot( n, &EIGVEC(j_,0L), ADR(_l0,1L), vtemp, 
		 ADR(_l1,1L) )/vnorm/vnorm;
		daxpy( n, ADR(_d0,sigma - rq), &EIGVEC(j_,0L), ADR(_l0,1L), 
		 vtemp, ADR(_l1,1L) );
		resid = fmax( *atol, dnrm2( n, vtemp, ADR(_l0,1L) )/vnorm );
		dscal( n, ADR(_d0,1.0/vnorm), &EIGVEC(j_,0L), ADR(_l0,1L) );

		/*  ACCEPT EIGENVALUE IF THE INTERVAL IS SMALL ENOUGH
		 * */
		if( bound[j_ + 1L][1L] - bound[j_ + 1L][0L] < 3.0e0**atol )
			goto L_300;

		/*  COMPUTE MINIMAL ERROR BOUND
		 * */
		errb = resid;
		gap = fmin( bound[j_ + 2L][0L] - rq, rq - bound[j_][1L] );
		if( gap > resid )
			errb = fmax( *atol, resid*resid/gap );

		/*  TENTATIVE NEW SHIFT
		 * */
		sigma = 0.5e0*(bound[j_ + 1L][0L] + bound[j_ + 1L][1L]);

		/*  CHECK FOR TERMINALTION
		 * */
		if( resid > 2.0e0**atol )
			goto L_40;
		if( rq - errb > bound[j_][1L] && rq + errb < bound[j_ + 2L][0L] )
			goto L_310;

		/*  RQ IS TO THE LEFT OF THE INTERVAL
		 * */
L_40:
		if( rq >= bound[j_ + 1L][0L] )
			goto L_50;
		if( rq - errb > bound[j_][1L] )
			goto L_100;
		if( rq + errb < bound[j_ + 1L][0L] )
			dlaran( n, &EIGVEC(j_,0L) );
		goto L_200;

		/*  RQ IS TO THE RIGHT OF THE INTERVAL
		 * */
L_50:
		if( rq <= bound[j_ + 1L][1L] )
			goto L_100;
		if( rq + errb < bound[j_ + 2L][0L] )
			goto L_100;

		/*  SAVE THE REJECTED VECTOR IF INDICATED
		 * */
		if( rq - errb <= bound[j_ + 1L][1L] )
			goto L_200;
		for( i = j; i <= nval; i++ ){
			i_ = i - 1;
			if( bound[i_ + 1L][1L] > rq )
				goto L_70;
			}
		goto L_80;

L_70:
		dcopy( n, &EIGVEC(j_,0L), ADR(_l0,1L), &EIGVEC(i - 1L,0L), 
		 ADR(_l1,1L) );

L_80:
		dlaran( n, &EIGVEC(j_,0L) );
		goto L_200;

		/*  PERTURB RQ TOWARD THE MIDDLE
		 * */
L_100:
		if( sigma < rq )
			sigma = fmax( sigma, rq - errb );
		if( sigma > rq )
			sigma = fmin( sigma, rq + errb );

		/*  FACTOR AND SOLVE
		 * */
L_200:
		for( i = j; i <= nval; i++ ){
			i_ = i - 1;
			if( sigma < bound[i_ + 1L][0L] )
				goto L_220;
			}
		i = nval + 1L;
L_220:
		numvec = i - j;
		numvec = min( numvec, *nband + 2L );
		if( resid < *artol )
			numvec = min( 1L, numvec );
		dcopy( n, &EIGVEC(j_,0L), ADR(_l0,1L), vtemp, ADR(_l1,1L) );
		dlabfc( n, nband, a, &sigma, &numvec, lde, &EIGVEC(j_,0L), 
		 &numl, ADR(_l0,2L**nband - 1L), atemp, d, atol );

		/*  PARTIALLY SCALE EXTRA VECTORS TO PREVENT UNDERFLOW OR OVERFLOW
		 * */
		if( numvec == 1L )
			goto L_227;
		l = numvec - 1L;
		for( i = 1L; i <= l; i++ ){
			i_ = i - 1;
			m = j + i;
			dscal( n, ADR(_d0,1.0e0/vnorm), &EIGVEC(m - 1L,0L), ADR(_l0,1L) );
			}

		/*  UPDATE INTERVALS
		 * */
L_227:
		numl = numl - *nl + 1L;
		if( numl >= 0L )
			bound[0L][1L] = fmin( bound[0L][1L], sigma );
		for( i = j; i <= nval; i++ ){
			i_ = i - 1;
			if( sigma < bound[i_ + 1L][0L] )
				goto L_20;
			if( numl < i )
				bound[i_ + 1L][0L] = sigma;
			if( numl >= i )
				bound[i_ + 1L][1L] = sigma;
			}
		if( numl < nval + 1L )
			bound[nval + 1L][0L] = fmax( sigma, bound[nval + 1L][0L] );
		goto L_20;

		/*  ACCEPT AN EIGENPAIR
		 * */
L_300:
		dlaran( n, &EIGVEC(j_,0L) );
		flag = TRUE;
		goto L_310;

L_305:
		flag = FALSE;
		rq = 0.5e0*(bound[j_ + 1L][0L] + bound[j_ + 1L][1L]);
		dlabfc( n, nband, a, &rq, &numvec, lde, &EIGVEC(j_,0L), &numl, 
		 ADR(_l0,2L**nband - 1L), atemp, d, atol );
		vnorm = dnrm2( n, &EIGVEC(j_,0L), ADR(_l0,1L) );
		if( vnorm != 0.0 )
			dscal( n, ADR(_d0,1.0e0/vnorm), &EIGVEC(j_,0L), ADR(_l0,1L) );

		/*  ORTHOGONALIZE THE NEW EIGENVECTOR AGAINST THE OLD ONES
		 * */
L_310:
		eigval[j_] = rq;
		if( j == 1L )
			goto L_330;
		m = j - 1L;
		for( i = 1L; i <= m; i++ ){
			i_ = i - 1;
			daxpy( n, ADR(_d0,-ddot( n, &EIGVEC(i_,0L), ADR(_l0,1L), 
			 &EIGVEC(j_,0L), ADR(_l1,1L) )), &EIGVEC(i_,0L), ADR(_l2,1L), 
			 &EIGVEC(j_,0L), ADR(_l3,1L) );
			}
L_330:
		vnorm = dnrm2( n, &EIGVEC(j_,0L), ADR(_l0,1L) );
		if( vnorm == 0.0e0 )
			goto L_305;
		dscal( n, ADR(_d0,1.0e0/vnorm), &EIGVEC(j_,0L), ADR(_l0,1L) );

		/*   ORTHOGONALIZE LATER VECTORS AGAINST THE CONVERGED ONE
		 * */
		if( flag )
			goto L_305;
		if( j == nval )
			return;
		m = j + 1L;
		for( i = m; i <= nval; i++ ){
			i_ = i - 1;
			daxpy( n, ADR(_d0,-ddot( n, &EIGVEC(j_,0L), ADR(_l0,1L), 
			 &EIGVEC(i_,0L), ADR(_l1,1L) )), &EIGVEC(j_,0L), ADR(_l2,1L), 
			 &EIGVEC(i_,0L), ADR(_l3,1L) );
			}
		}
	return;

L_500:
	;
	return;
#undef	EIGVEC
#undef	A
} /* end of function */

/************************************************************************
 * */
void /*FUNCTION*/ dlabfc(n, nband, a, sigma, number, lde, eigvec, 
	 numl, ldad, atemp, d, atol)
long int *n, *nband;
double *a, *sigma;
long int *number, *lde;
double *eigvec;
long int *numl, *ldad;
double *atemp, *d, *atol;
{
#define A(I_,J_)	(*(a+(I_)*(*nband)+(J_)))
#define EIGVEC(I_,J_)	(*(eigvec+(I_)*(*lde)+(J_)))
#define ATEMP(I_,J_)	(*(atemp+(I_)*(*ldad)+(J_)))
#define D(I_,J_)	(*(d+(I_)*(*ldad)+(J_)))
static long int _l0, _l1, _l2, i, i_, j, j_, k, k_, kk, kk_, l, la, 
	 ld, lpm, m, nb1;
static double _d0, zero[1];
void daxpy(), dcopy(), dswap();


	/*  THIS SUBROUTINE FACTORS (A-SIGMA*I) WHERE A IS A GIVEN BAND
	 *  MATRIX AND SIGMA IS AN INPUT PARAMETER.  IT ALSO SOLVES ZERO
	 *  OR MORE SYSTEMS OF LINEAR EQUATIONS.  IT RETURNS THE NUMBER
	 *  OF EIGENVALUES OF A LESS THAN SIGMA BY COUNTING THE STURM
	 *  SEQUENCE DURING THE FACTORIZATION.  TO OBTAIN THE STURM 
	 *  SEQUENCE COUNT WHILE ALLOWING NON-SYMMETRIC PIVOTING FOR
	 *  STABILITY, THE CODE USES A GUPTA'S MULTIPLE PIVOTING
	 *  ALGORITHM.
	 *
	 *  FORMAL PARAMETERS
	 * */

	/*  LOCAL VARIABLES
	 * */

	/*  FUNCTIONS CALLED
	 * */

	/*  SUBROUTINES CALLED
	 *
	 *     DAXPY, DCOPY, DSWAP
	 *
	 *
	 *  INITIALIZE
	 * */
	zero[0L] = 0.0e0;
	nb1 = *nband - 1L;
	*numl = 0L;
	dcopy( ADR(_l0,*ldad**nband), zero, ADR(_l1,0L), d, ADR(_l2,1L) );

	/*   LOOP OVER COLUMNS OF A
	 * */
	for( k = 1L; k <= *n; k++ ){
		k_ = k - 1;

		/*   ADD A COLUMN OF A TO D
		 * */
		D(*nband - 1L,*nband - 1L) = A(k_,0L) - *sigma;
		m = min( k, *nband ) - 1L;
		if( m == 0L )
			goto L_20;
		for( i = 1L; i <= m; i++ ){
			i_ = i - 1;
			la = k - i;
			ld = *nband - i;
			D(*nband - 1L,ld - 1L) = A(la - 1L,i_ + 1L);
			}

L_20:
		m = min( *n - k, nb1 );
		if( m == 0L )
			goto L_40;
		for( i = 1L; i <= m; i++ ){
			i_ = i - 1;
			ld = *nband + i;
			D(*nband - 1L,ld - 1L) = A(k_,i_ + 1L);
			}

		/*   TERMINATE
		 * */
L_40:
		lpm = 1L;
		if( nb1 == 0L )
			goto L_70;
		for( i = 1L; i <= nb1; i++ ){
			i_ = i - 1;
			l = k - *nband + i;
			if( D(*nband - 1L,i_) == 0.0e0 )
				goto L_60;
			if( fabs( D(i_,i_) ) >= fabs( D(*nband - 1L,i_) ) )
				goto L_50;
			if( (D(*nband - 1L,i_) < 0.0e0 && D(i_,i_) < 0.0e0) || 
			 (D(*nband - 1L,i_) > 0.0e0 && D(i_,i_) >= 0.0e0) )
				lpm = -lpm;
			dswap( ADR(_l0,*ldad - i + 1L), &D(i_,i_), ADR(_l1,1L), 
			 &D(*nband - 1L,i_), ADR(_l2,1L) );
			dswap( number, &EIGVEC(0L,l - 1L), lde, &EIGVEC(0L,k_), 
			 lde );
L_50:
			daxpy( ADR(_l0,*ldad - i), ADR(_d0,-D(*nband - 1L,i_)/
			 D(i_,i_)), &D(i_,i_ + 1L), ADR(_l1,1L), &D(*nband - 1L,i_ + 1L), 
			 ADR(_l2,1L) );
			daxpy( number, ADR(_d0,-D(*nband - 1L,i_)/D(i_,i_)), &EIGVEC(0L,l - 1L), 
			 lde, &EIGVEC(0L,k_), lde );
L_60:
			;
			}

		/*  UPDATE STURM SEQUENCE COUNT
		 * */
L_70:
		if( D(*nband - 1L,*nband - 1L) < 0.0e0 )
			lpm = -lpm;
		if( lpm < 0L )
			*numl = *numl + 1L;
		if( k == *n )
			goto L_110;

		/*   COPY FIRST COLUMN OF D INTO ATEMP  */
		if( k < *nband )
			goto L_80;
		l = k - nb1;
		dcopy( ldad, d, ADR(_l0,1L), &ATEMP(l - 1L,0L), ADR(_l1,1L) );

		/*   SHIFT THE COLUMNS OF D OVER AND UP
		 * */
		if( nb1 == 0L )
			goto L_100;
L_80:
		for( i = 1L; i <= nb1; i++ ){
			i_ = i - 1;
			dcopy( ADR(_l0,*ldad - i), &D(i_ + 1L,i_ + 1L), ADR(_l1,1L), 
			 &D(i_,i_), ADR(_l2,1L) );
			D(i_,*ldad - 1L) = 0.0e0;
			}
L_100:
		;
		}

	/*  TRANSFER D TO ATEMP
	 * */
L_110:
	for( i = 1L; i <= *nband; i++ ){
		i_ = i - 1;
		l = *n - *nband + i;
		dcopy( ADR(_l0,*nband - i + 1L), &D(i_,i_), ADR(_l1,1L), &ATEMP(l - 1L,0L), 
		 ADR(_l2,1L) );
		}

	/*   BACK SUBSTITUTION
	 * */
	if( *number == 0L )
		return;
	for( kk = 1L; kk <= *n; kk++ ){
		kk_ = kk - 1;
		k = *n - kk + 1L;
		if( fabs( ATEMP(k - 1L,0L) ) <= *atol )
			ATEMP(k - 1L,0L) = sign( *atol, ATEMP(k - 1L,0L) );

L_130:
		for( i = 1L; i <= *number; i++ ){
			i_ = i - 1;
			EIGVEC(i_,k - 1L) = EIGVEC(i_,k - 1L)/ATEMP(k - 1L,0L);
			m = min( *ldad, k ) - 1L;
			if( m == 0L )
				goto L_150;
			for( j = 1L; j <= m; j++ ){
				j_ = j - 1;
				l = k - j;
				EIGVEC(i_,l - 1L) = EIGVEC(i_,l - 1L) - ATEMP(l - 1L,j_ + 1L)*
				 EIGVEC(i_,k - 1L);
				}
L_150:
			;
			}
		}
	return;
#undef	D
#undef	ATEMP
#undef	EIGVEC
#undef	A
} /* end of function */

/************************************************************************
 * */
void /*FUNCTION*/ dlabax(n, nband, a, x, y)
long int *n, *nband;
double *a, x[], y[];
{
#define A(I_,J_)	(*(a+(I_)*(*nband)+(J_)))
static long int _l0, _l1, i, i_, k, k_, l, m;
static double zero[1];
void dcopy();


	/*  THIS SUBROUTINE SETS Y = A*X
	 *  WHERE X AND Y ARE VECTORS OF LENGTH N
	 *  AND A IS AN  N X NBAND  SYMMETRIC BAND MATRIX
	 *
	 *  FORMAL PARAMETERS
	 * */

	/*  LOCAL VARIABLES
	 * */

	/*  FUNCTIONS CALLED
	 * */

	/*  SUBROUTINES CALLED
	 *
	 *     DCOPY
	 * */
	zero[0L] = 0.0e0;
	dcopy( n, zero, ADR(_l0,0L), y, ADR(_l1,1L) );
	for( k = 1L; k <= *n; k++ ){
		k_ = k - 1;
		y[k_] = y[k_] + A(k_,0L)*x[k_];
		m = min( *n - k + 1L, *nband );
		if( m < 2L )
			goto L_20;
		for( i = 2L; i <= m; i++ ){
			i_ = i - 1;
			l = k + i - 1L;
			y[l - 1L] = y[l - 1L] + A(k_,i_)*x[k_];
			y[k_] = y[k_] + A(k_,i_)*x[l - 1L];
			}
L_20:
		;
		}
	return;
#undef	A
} /* end of function */

