#define TOL 1.e-10
#define NN  650
#define NE  1200
#define NM  1
#define NB  10
#define NC  5
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

void fileopen(char *name, char *mode, FILE **fp);
void alloc_array_f(float **arr, int no, char *s);
void alloc_array_i(int **arr, int no, char *s);
void rinput(FILE *fp11);
void rindec(FILE *fp2);


int    nn, ne, nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;
float dt,damp;
int    *nod;
int    mat[NM], nco[NB][3],  nc[NC];
float *cord; 
float amat[NM*5], aload[NC*3];

float *dec;

char   titel[256];

main()
{
FILE *fp1, *fp2, *fp3;
char file[30], file_sav[30], file_o[30], bf[100];
register i, j, k, l, m, o, p;
int nsub, edge, nod1, nod2, nodd1, nodd2, tot_edge;

printf("\n*** Handles Nodes upto = %3d & Elems upto = %3d\n\n", NN, NE);

alloc_array_f(&cord, 3*NN, "cord");  /* overall mesh */
alloc_array_i(&nod , 4*NE, "nod ");
alloc_array_f(&dec, NE, "dec");

printf("Enter the project file name (.dat) assumed\n");
gets(file_sav);
strcpy(file, file_sav);
strcat(file, ".dat");
fileopen(file,"r",&fp1);
rinput(fp1);
fclose(fp1);

printf("Enter the number of sudomains for this file\n");
gets(bf); sscanf(bf,"%d",&nsub);

strcpy(file,file_sav); strcat(file,".dec");
fileopen(file,"r",&fp2);
rindec(fp2);
fclose(fp2);

strcpy(file, file_sav); strcat(file,".edg");
fileopen(file,"w",&fp3);
tot_edge = 0;
for(i = 0; i < nsub; i++)
{
 edge = 0;
 for(j = 0; j < ne; j++)
 {
 if(dec[j] != i+1) continue;
 for(k = 0; k < 3; k++)
 {
 l = k+1; if( l > 2) l = 0;
 nod1 = nod[4*j+k];  nod2 = nod[4*j+l];
   for(m = 0; m < ne; m++)
   {
   if(dec[m] == i+1) continue;
      for(o = 0; o < 3; o++)
      {
      p = o+1; if(p > 2) p = 0;
      nodd1 = nod[4*m+o]; nodd2 = nod[4*m+p];
      if((nod1 == nodd1 && nod2 == nodd2) || 
         (nod1 == nodd2 && nod2 == nodd1)) edge++;
      }
   }
 }  
 }
fprintf(fp3,"subdomain no.%3d cut edges = %5d\n",i+1, edge);
fprintf(stdout,"subdomain no.%3d cut edges = %5d\n",i+1, edge);
tot_edge += edge;
}
fprintf(fp3,"Total no. of edges cut = %5d\n", tot_edge);
fprintf(stdout,"Total no. of edges cut = %5d\n", tot_edge);
fclose(fp3);

printf("*** file %s.edg generated\n",file_sav);

return(1);
}       


void fileopen(char *name, char *mode, FILE **fp)
{
if((*fp=fopen(name, mode)) == (FILE  *) NULL)
{printf("cannot open %s\n", name);exit(1);}
}


void rinput(FILE *fp11)
{
char bf[256];
int i,j,k,n, dum;
float x1,y1,z1, dumm;

   fgets(titel, 256, fp11);
   fputs(titel, stdout);
   fgets(bf,256,fp11);
   fgets(bf,256,fp11);

   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",&nn ,&ne ,&nb ,&nm,&nl,
   &ndime, &nstr, &nbe, &kmax,&nmax, &iln );


   fgets(bf,256,fp11);


   for(i = 0; i < nn ; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %f %f %f",&n, &x1, &y1,&z1);
   cord [3*i] = x1;
   cord [3*i + 1] = y1;
   cord [3*i + 2] = z1;
   }


   if(ne  > 0)
   {
      for(i = 0; i < ne ; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d",&n,&nod [4*i + 0],&nod [4*i + 1],
      &nod [4*i + 2],&nod [4*i + 3]);
      }
   }

   for(i = 0; i < nm; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %f %f %f %f %f",&n,&mat[i],&amat[5*i+0],
   &amat[5*i+1],&amat[5*i+2],&amat[5*i+3],&amat[5*i+4]);
   }



   for(i = 0; i < nb ; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d",&nco [i][0],&nco [i][1],&nco [i][2],
          &nco [i][3]);
   }



   if(iln > 0)
   {
   for(i = 0; i < NC; nc [i++] = 0);/*zero for use in nb_iln */
   iln  = 0;
more:
   iln ++;
   i = iln  - 1;

   fgets(bf,256,fp11);
   sscanf(bf,"%d %f %f %f",&nc [i],&aload [3*i+0],
   &aload [3*i+1],&aload [3*i+2]);

   if(nc [i] < nn )
   goto more;
   }

fclose(fp11);
}


void alloc_array_f(float **arr, int no, char *s)
{
if((*arr = calloc(no, (sizeof(float)))) == NULL)
{printf("out of core for %s\n", s); exit(1);}
}

void alloc_array_i(int **arr, int no, char *s)
{
if((*arr = calloc(no, (sizeof(int)))) == NULL)
{printf("out of core for %s\n", s); exit(1);}
}



void rindec(FILE *fp2)
{
char bf[256];
register i;

for(i = 0; i < ne; i++)
{fgets(bf,256,fp2); sscanf(bf,"%f",&dec[i]);}

}