
#define UnBalance  30
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define NEmax  1200
#define NEsub  600
#define NNsub  450
#define LIL 2
#define MM  5
#define NC  5
#define LASTNODE 1000

int nn,ne,nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;

int *nod,nodl[LIL][3],nodq[LIL][5],
nco[MM][4],nsnod[LIL][5],
mat[5],nc[NC],ngs[LIL];

int *ne_g, t_sds, nsd1;

char titel[50];

double dt,damp;

double *cord;

double amat[5][10],aload[NC][3];

int *elems_sd, *elem_sdno;

short/*  *A,*/ *AL, *I, *J;

int n_compact;

double E[10], *V;

char *file_buf;

typedef struct{

int nn,ne,nb,nm,nl,ndime,nstr,nbe,kmax,nmax,iln,nq;

int nod[4*NEsub],nodl[LIL][3],nodq[LIL][5],
nco[MM][4],nsnod[LIL][5],
mat[5],nc[5],ngs[LIL];

char titel[50];

double dt,damp;

short ne_g[NEmax];

double cord[3*NNsub];

double amat[5][10],aload[5][3];

double tL[3], rL;
} sub_t;

typedef struct{int NE; double V;} mrk_t;



void rinput(int , FILE *); 

void routput(sub_t *, FILE *);

void Lap(void);

int compar();

void form_col(int ni);

void form_diag(int i);

int  edge(int *, int *);

stack(sub_t * , int elem_g);

int comp_st(double x, double y, sub_t *);

void revise_nod(int trace[], int *pjj, int mat_no,  sub_t *);

void nb_iln(sub_t *);

void partition(mrk_t *MRK, sub_t  *, FILE *, FILE *);

void init_idec(int *ne_orig);

void rindec(int it, FILE *fp3);

void routdec(int start, sub_t *SUB,int nex, FILE *fp4);

void form_decomp_dec(int nrec, int ne_orig);

void load_elem_sdno(register i, int ne_sd);

void alloc_array_short(short **A, int no, char *s);

void alloc_array(double **A, int no, char *s);

void alloc_array_mrk(mrk_t **A, int no, char *s);

void drv1(int argc, char *argv[], long ne, double *E, double *V);

void cpy(char *arg1, char *arg2);

/* void Lap_count(void);*/



main(argc, argv)
int argc; char *argv[];
{
FILE *fp, *fp1, *fp2, *fp3, *fp4, *finf;
char file[30], file_sav[30];
register i,j, it, rc;
int flag,nrec, idx, ne_orig,nsd, icom;
mrk_t   *MRK;
sub_t SUB;
time_t tim1, tim2;

printf("\n***This Program can handle upto %d Elements***\n",NEmax);
printf("Enter the input file (.dat assumed)\n");
gets(file_sav);
strcpy(file,file_sav); strcat(file,".dat");
cpy(file,"i.dat");

strcpy(file,file_sav); strcat(file,".in"); /* open info file */
if((finf=fopen(file,"w")) == (FILE *) NULL)
{printf("cannot open %s\n",file); exit(1);}

printf("\n*The number of subdomains to be formed N = 2^(no_of_recursions)*\n");
printf("\nEnter the no_of_recursions\n"); 
scanf("%d",&nrec); 

time(&tim1);

t_sds = (int) pow(2.,nrec); /* total no. of subdomains at any instance */

init_idec(&ne_orig);

for(it = 0; it < nrec; it++)
{
if(fmod(it,2) == 0) flag = 0; else flag = 1;
nsd1 = pow(2, it+1); /* no of subdomains to be generated in this recursion*/
nsd = pow(2,it);

if(flag == 0)
{
if((fp = fopen("i.dat","r")) == (FILE *) NULL)
{printf("cannot open i.dat(r)\n"); exit(1);} 
if((fp2 = fopen("o.dat","w")) == (FILE *) NULL)
{printf("cannot open o.dat(w)\n"); exit(1);} 

if((fp3 = fopen("i.dec","r")) == (FILE *) NULL)
{printf("cannot open i.dec(r)\n"); exit(1);}
if((fp4 = fopen("o.dec","w")) == (FILE *) NULL)
{printf("cannot open o.dec(w)\n"); exit(1);}
}
else
{
if((fp = fopen("o.dat","r")) == (FILE *) NULL)
{printf("cannot open o.dat(r)\n"); exit(1);} 
if((fp2 = fopen("i.dat","w")) == (FILE *) NULL)
{printf("cannot open i.dat(w)\n"); exit(1);} 

if((fp3 = fopen("o.dec","r")) == (FILE *) NULL)
{printf("cannot open o.dec(r)\n"); exit(1);}
if((fp4 = fopen("i.dec","w")) == (FILE *) NULL)
{printf("cannot open i.dec(w)\n"); exit(1);}
}

   for(rc = 0; rc < nsd; rc++)
   {
   rinput(it,fp);
   rindec(it, fp3);

/*   Lap_count(); */

   n_compact = 4*ne;   /* a maximun estimate */

   if(it == 0){
/*    alloc_array_short(&A, ne*ne*sizeof(short), "A"); */
    alloc_array_short(&AL, n_compact*sizeof(short), "I"); 
    alloc_array_short(&I, n_compact*sizeof(short), "I"); 
    alloc_array_short(&J, n_compact*sizeof(short), "J"); 
   
    alloc_array(&V, ne*sizeof(double), "V");
    alloc_array_mrk(&MRK, ne*sizeof(mrk_t), "MRK");
   }

   Lap();
/*
   for(knt = 0; knt < n_compact; knt++)
   printf("%5d  %3d\n",knt+1, AL[knt]);
   exit(1);
*/                                                    
   for(icom = 0;icom < n_compact ; icom++)
   {
   if(AL[icom] == 0) 
   {
   break;
   }
   }
   n_compact = icom;

   printf("The revised non zeroes in A are = %d\n", n_compact); 

   /*aux();*/                     /* TEMP ADDITION */

   printf("Entering drv1\n");
   drv1(argc, argv, (long) ne, E, V);   
   printf("Exiting drv1\n");

   for(i = 0; i < ne; i++){MRK[i].NE = i+1; MRK[i].V = V[i];}


   qsort(MRK, ne, sizeof(MRK[0]), compar);

   if((fp1=fopen("debug.dat","w")) == (FILE *) NULL)
   {printf("cannot open debug.dat\n"); exit(1);}
   for(i = 0; i < ne; i++)
   fprintf(fp1,"%3d  %3d  %20.10f\n",i + 1, (MRK[i]).NE, (MRK[i]).V);
   fclose(fp1);

   partition(MRK, &SUB, fp2, fp4);          
   }
printf("Recursion no.%3d completed\n", it+1);
fclose(fp);
fclose(fp2);
fclose(fp3);
fclose(fp4);
}

form_decomp_dec(nrec, ne_orig);


if(fmod(nrec,2) == 0)
{
cpy("i.dat","o.dat");
printf("***The Decomposed File Generated as o.dat***\n");
strcpy(file,file_sav); strcat(file,".dec");
cpy("decomp.dec",file);
printf("***The Plot FILE Generated as %s***\n",file);
}
else  
{
printf("***The Decomposed File Generated as o.dat***\n");  
strcpy(file,file_sav); strcat(file,".dec");
cpy("decomp.dec",file);
printf("***The Plot FILE GEnerated as %s ***\n", file);
}

free(file_buf);

remove("decomp.dec");
remove("i.dat");
time(&tim2);
printf("total Time = %f min.\n",((double) tim2 - (double)tim1)/60.);
fprintf(finf,"total Time = %f min.\n",((float) tim2 - (float)tim1)/60.);
fclose(finf);
printf("***information file %s.in generated***\n",file_sav);
return(1);
}


int compar(void *c1, void *c2)
{
mrk_t *d1, *d2;
d1 = c1;
d2 = c2;
if(d1->V < d2->V) return -1;
if(d1->V > d2->V) return 1;
return 0;
}



/* function to read in the data from the primary data file */

void rinput(int it, FILE *fp11)
{
char bf[256];
int i,j,k,n;
double x1,y1,z1;

   fgets(titel,50,fp11);
   fputs(titel,stdout);
   fgets(bf,256,fp11);
   sscanf(bf,"%lf%lf",&dt,&damp);
   printf("%f %f \n",dt,damp);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d %d %d %d",&nn,&ne,&nb,&nm,&nl,
   &ndime, &nstr, &nbe, &kmax,&nmax, &iln);

   fgets(bf,256,fp11);
   sscanf(bf,"%d",&nq);

   switch(it){
   case 0:
   if((cord = calloc(3*nn, sizeof(double))) == NULL)
   {printf("out of core for cord\n"); exit(1);}
 
   if((nod = calloc(4*ne, sizeof(int))) == NULL)
   {printf("out of core for nod\n"); exit(1);}
   break;

   default:
   break;
   }

   for(i = 0; i < nn; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",&n, &x1, &y1,&z1);
   cord[3*i] = x1;
   cord[3*i + 1] = y1;
   cord[3*i + 2] = z1;
   }



   if(ne > 0)
   {
      for(i = 0; i < ne; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d",&n,&nod[4*i + 0],&nod[4*i + 1],
      &nod[4*i + 2],&nod[4*i + 3]);
      }
   }



   if(nl > 0)
   {
      for(i = 0; i < nl;i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d",&n,&nodl[i][0],&nodl[i][1],
      &nodl[i][2]);
      }
   }



   if(nq > 0)
   {
      for(i = 0; i < nq; i++)
      {
	  fgets(bf,256,fp11);
      sscanf(bf,"%d %d %d %d %d %d",&n,&nodq[i][0],&nodq[i][1],
      &nodq[i][2],&nodq[i][3],&nodq[i][4]);
      }
   }



   for(i = 0; i < nm; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %lf %lf %lf %lf %lf",&n,&mat[i],&amat[i][0],&amat[i][1],
   &amat[i][2],&amat[i][3],&amat[i][4]);
   }



   for(i = 0; i < nb; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d",&nco[i][0],&nco[i][1],&nco[i][2],&nco[i][3]);
   }



   if(iln > 0)
   {
   for(i = 0; i < NC; nc[i++] = 0);/*zero for use in nb_iln */
   iln = 0;
more:
   iln++;
   i = iln - 1;

   fgets(bf,256,fp11);
   sscanf(bf,"%d %lf %lf %lf",&nc[i],&aload[i][0],&aload[i][1],&aload[i][2]);

   if(nc[i] < nn)
   goto more;
   }

   if(nstr > 0)
   {
   for(i = 0; i < nstr; i++)
   {
   fgets(bf,256,fp11);
   sscanf(bf,"%d",&ngs[i]);
   fgets(bf,256,fp11);
   sscanf(bf,"%d %d %d %d %d %d %d %d",&nsnod[i][0],&nsnod[i][1],
   &nsnod[i][2],&nsnod[i][3],&nsnod[i][4],&nsnod[i][5],&nsnod[i][6],
   &nsnod[i][7]);
   }
   }
}

void Lap(void)
{
register i,j,k, ic;
int ni[3], nj[3], result, count;

/* zero A for recursions */
/*
for(i = 0; i < ne; i++)              
for(j = 0; j < ne; j++)
A[ne*i+j] = 0;
*/

for(i = 0; i < n_compact; AL[i++] = 0);
for(i = 0; i < n_compact; I[i++] = 0);
for(i = 0; i < n_compact; J[i++] = 0);

ic = 0;   /* compact counters */


for(i = 0; i < ne; i++)
{
   for(j = i; j < ne; j++)
   {

      if(i==j)                       
      {
/*      A[ne*i+j] = 0;*/
      goto next_j;
      }

      for(k=0; k < 3; k++)           
      ni[k] = nod[4*i+k];

      for(k=0; k < 3; k++)
      nj[k] = nod[4*j+k];

      result = edge(ni,nj);          

      if(result == 2)
      {
/*      A[ne*i+j] = 1;*/
      AL[ic] = 1;
      I[ic] = i;
      J[ic] = j;
      ic++;
      AL[ic] = 1;
      I[ic] = j;
      J[ic] = i;
      ic++;
      goto next_j;
      }

/*      A[ne*i+j] = 0;               */

    next_j:
    continue;
   }

/* form_diag(i); */
/* form_col(i);*/
}

count = ic;

for(i = 0; i < ne; i++)
{
  for(j = 0; j < count; j++)
  if(i == I[j])
  {
  AL[ic] -= AL[j]; 
  }
  I[ic] = i;
  J[ic] = i;
  ic++;
}

printf("The non zeroes in A are = %d\n", n_compact); 

}

/*
void form_col(int ni)
{
register i;

for(i = ni; i < ne; i++)
{
A[ne*i+ni] = A[ne*ni+i];

}

}


void form_diag(int i)
{
register j;
double tol;
short cnt;

tol = 1.e-4;
cnt = 0.;

for(j = 0; j < ne; j++)
if(fabs(A[ne*i+j] - 1) < tol)
cnt += 1;

A[ne*i+i] = -cnt;
}
*/

int edge(int ni[], int nj[])
{
register i, j;
int knt;

knt = 0;

for(i = 0; i < 3; i++)
   for(j = 0; j < 3; j++)
   if(ni[i] == nj[j])
   knt++;

return(knt);
}


/* function to write in the data to one of the two subdomain files*/

void routput(sub_t *SUB, FILE *fp00)
{
int i,j,k,n, n1,n2,n3,n4;

   fputs((SUB->titel),fp00);
   fprintf(fp00,"%f %f\n",SUB->dt,SUB->damp);
   fprintf(fp00,"%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d%5d\n",
   SUB->nn,SUB->ne,SUB->nb,SUB->nm,SUB->nl,
   SUB->ndime, SUB->nstr, SUB->nbe, SUB->kmax,SUB->nmax, SUB->iln);


   fprintf(fp00,"%5d\n",SUB->nq);

   for(i = 0; i < SUB->nn; i++)
   {
   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",i+1, 
   (SUB->cord)[3*i + 0], (SUB->cord)[3*i + 1], (SUB->cord)[3*i + 2] = 0.);
   }



   if(SUB->ne > 0)
   {  
      for(i = 0; i < SUB->ne; i++)
      {
      n1 = SUB->nod[4*i + 0];
      n2 = SUB->nod[4*i + 1];
      n3 = SUB->nod[4*i + 2];
      n4 = SUB->nod[4*i + 3];

	  fprintf(fp00,"%5d%5d%5d%5d%5d\n",i+1,n1,n2,n3,n4);
/*        (SUB->nod)[4*i+0],(SUB->nod)[4*i+1],
	  (SUB->nod)[4*i*2],(SUB->nod)[4*i+3]);*/
      }
   }



   if(SUB->nl > 0)
   {
	  for(i = 0; i < SUB->nl;i++)
      {
      fprintf(fp00,"%5d%5d%5d%5d%15.8f\n",i+1,
	  SUB->nodl[i][0],SUB->nodl[i][1],SUB->nodl[i][2],SUB->rL);
      }
   }



   if(SUB->nq > 0)
   {
	  for(i = 0; i < SUB->nq; i++)
      {
      fprintf(fp00,"%5d%5d%5d%5d%5d%5d",i+1,
	  SUB->nodq[i][0],SUB->nodq[i][1],
	  SUB->nodq[i][2],SUB->nodq[i][3],SUB->nodq[i][4]);
      }
   }



   for(i = 0; i < SUB->nm; i++)
   {
   fprintf(fp00,"%5d%5d%12.5e%12.5e%12.5e%12.5e%12.5e\n",i+1,
   (SUB->mat)[i],(SUB->amat)[i][0],
   (SUB->amat)[i][1],(SUB->amat)[i][2],(SUB->amat)[i][3],(SUB->amat)[i][4]);
   }



   for(i = 0; i < SUB->nb; i++)
   {
   fprintf(fp00,"%5d%5d%5d%5d\n",(SUB->nco)[i][0],
   (SUB->nco)[i][1],(SUB->nco)[i][2],(SUB->nco)[i][3]);
   }



   if(SUB->iln > 0)
   {
   SUB->iln = 0;
more:
   SUB->iln++;
   i = SUB->iln - 1;

   fprintf(fp00,"%5d%15.5f%15.5f%15.5f\n",
   (SUB->nc)[i],(SUB->aload)[i][0],(SUB->aload)[i][1],
   (SUB->aload)[i][2]);

   if(SUB->nc[i] < SUB->nn)
   goto more;
   }

   if(SUB->nstr > 0)
   {
   for(i = 0; i < SUB->nstr; i++)
   {
   fprintf(fp00,"%5d\n",SUB->ngs[i]);
   fprintf(fp00,"%5d%5d%5d%5d%5d%5d%5d%5d\n",
   SUB->nsnod[i][0],SUB->nsnod[i][1],
   SUB->nsnod[i][2],SUB->nsnod[i][3],
   SUB->nsnod[i][4],SUB->nsnod[i][5],
   SUB->nsnod[i][6],SUB->nsnod[i][7]);
   }
   }
}




/* The function loads in the data structure for a subdomain in SUB 
each element identified by MRK.NE has its global element  number
passed on to this function                                       */

stack(sub_t *SUB, int elem_g)
{
int i,ii,jj,test1;
int trace[3],node, mat_no;
double x[3], y[3];

   ii = SUB->nn ;
   jj = SUB->ne ;

   for(i = 0; i < 3; i++)
   {
   node = nod[4*(elem_g - 1) + i] - 1;/*load the coordinates of the element*/
   x[i] = cord[3*node + 0];
   y[i] = cord[3*node + 1];
   }

   mat_no = nod[4*(elem_g - 1) + 3];/* load the mat number */

   

   for(i = 0; i < 3; i++)
   {

     test1 = 0;
     test1 = comp_st(x[i], y[i], SUB); /*test1 returns the compared node_st*/  

     if(test1 == -1)
     {
	 SUB->cord[3*ii + 0] = x[i];
	 SUB->cord[3*ii + 1] = y[i];
     trace[i] = ii + 1;
     ii++;
     continue;
     }
     trace[i] = test1;
   }

   /* load in the new topology */

   revise_nod(trace, &jj, mat_no, SUB);
     

  SUB->nn = ii;
  SUB->ne = jj;

return;
}

/* function to compare the packet nodes with the stack nodes */
int comp_st(double x, double y, sub_t *SUB)
{
int i;
double x_st, y_st;
double tol = 1.e-4;

   for(i = 0; i < SUB->nn; i++)
   {
   x_st = SUB->cord[3*i + 0];
   y_st = SUB->cord[3*i + 1];
      if((fabs(x - x_st) <= tol) && (fabs(y - y_st) <= tol))
      return(i + 1);
   }
return(-1);
}

/* function to revise the node topology */

void revise_nod(int trace[], int *pjj, int mat_no, sub_t *SUB)
{
int jj = *pjj;
   SUB->nod[4*jj + 0] = trace[0];
   SUB->nod[4*jj + 1] = trace[1];
   SUB->nod[4*jj + 2] = trace[2];
   SUB->nod[4*jj + 3] = mat_no;
   jj++;

*pjj = jj;

}

/* function to identify the restrained and loaded nodes from the
   compiled mesh */

void nb_iln(sub_t *SUB)
{
int i,j,k,l,m, node;
double tol = pow(10.,-6);
double cx_b,cy_b,cx_l,cy_l;
   k = 0;
   m = 0;
   SUB->nb = 0;
   for(i = 0; i < SUB->nn; i++)
   {

      for(j = 0; j  < nb; j++)
      {
       node = nco[j][0] - 1;
	   cx_b = fabs(SUB->cord[3*i + 0] - cord[3*node + 0]);
	   cy_b = fabs(SUB->cord[3*i + 1] - cord[3*node + 1]);
       if(cx_b <= tol && cy_b<= tol)
       {
		SUB->nco[k][0] = i + 1;
	SUB->nco[k][1] = nco[j][1];
	SUB->nco[k][2] = nco[j][2];
	SUB->nco[k][3] = nco[j][3];
	k++;
	break;
       }
      }

       for(l = 0; nc[l] <= nn && nc[l] != LASTNODE; l++)
       {
	node = nc[l] - 1;
	cx_l = fabs(SUB->cord[3*i + 0] - cord[3*node + 0]);
	cy_l = fabs(SUB->cord[3*i + 1] - cord[3*node + 1]);
	if(cx_l <= tol &&  cy_l <= tol)
	{
		 SUB->nc[m] = i + 1;
		 memmove(SUB->aload[m], aload[l], sizeof(aload));
	 m++;
	 break;
	}
       }           
   }
   SUB->nb = k;

   if(m == 0){
   SUB->nc[m] = LASTNODE;
   SUB->aload[m][0] = SUB->aload[m][1] = SUB->aload[m][2] = 0.;
   m++;
   SUB->iln = m;
   }
   else{
   SUB->nc[m] = LASTNODE;
   SUB->aload[m][0] = SUB->aload[m][1] = SUB->aload[m][2] = 0.;
/*   memmove(SUB->aload[m], aload[m], sizeof(aload));*/
   m++;
   SUB->iln = m;
   }
}
 



void partition(mrk_t *MRK, sub_t  *SUB, FILE *fp2, FILE *fp4)
{
register i,l;
int elem_g, p1, p2;

memmove((SUB->titel),titel, sizeof(titel));
memmove((SUB->mat), mat, sizeof(mat));
memmove((SUB->amat),amat,sizeof(amat));
SUB->nn = 0;
SUB->ne = 0;
SUB->nq = 0;
SUB->dt = dt;
SUB->damp = damp;
SUB->ndime = ndime;
SUB->nm =  nm;
SUB->nl = nl;
SUB->nstr = nstr;
SUB->nbe = nbe;
SUB->kmax = kmax;
SUB->nmax = nmax;

p2 = ne/2;
p1 = ne - p2;

for(i = 0; i < p1; i++)
{
elem_g = MRK[i].NE;
stack(SUB, elem_g); 
SUB->ne_g[i] = ne_g[elem_g-1];
}
nb_iln(SUB);
routput(SUB, fp2); 
routdec(0, SUB, p1, fp4); 

SUB->nn = 0;
SUB->ne = 0;
for(i = p1; i < ne; i++)
{
elem_g = MRK[i].NE;
stack(SUB, elem_g); 
SUB->ne_g[i] = ne_g[elem_g-1];
}
nb_iln(SUB);
routput(SUB, fp2);
routdec(p1, SUB, ne, fp4); 
   
}




void init_idec(int *ne_orig)
{
register i;
FILE *fl1, *fl2;
char buf[256];

/* creates the first i.dec file containing the global element numbers
for the initial domain and  allocates men[] if choice == [1]*/

if((fl1 = fopen("i.dat","r")) == (FILE *) NULL)
{printf("cannot open i.dat in init_dec()\n"); exit(1);}
fgets(buf,256,fl1);
fgets(buf,256,fl1);
fgets(buf,256,fl1);
sscanf(buf,"%d %d %d %d %d %d %d %d %d %d %d",&nn,&ne,&nb,&nm,&nl,
&ndime, &nstr, &nbe, &kmax,&nmax, &iln);
*ne_orig = ne;
printf("ne = %5d\n",ne);
fclose(fl1);

if((fl2 = fopen("i.dec","w")) == (FILE *) NULL)
{printf("cannot open i.dec\n"); exit(1);}
fprintf(fl2,"%5d            %5d\n",1,ne);
for(i = 0; i < ne; i++)
fprintf(fl2,"%5d %5d\n",i+1, i+1);
fclose(fl2);
}


void rindec(int it, FILE *fp3)
{
register i;
int dum;
char buf[100];

switch(it){
case 0:
if((ne_g = calloc(ne, sizeof(int))) == NULL)
{printf("out of core for ne_g\n"); exit(1);}
break;

default:
break;
}

fgets(buf,100,fp3);

for(i = 0; i < ne; i++)
{fgets(buf,100,fp3);sscanf(buf,"%d %d",&dum, &ne_g[i]);}

}


void routdec(int start, sub_t *SUB, int nex, FILE *fp4)
{
register i;

fprintf(fp4,"%5d          %5d\n",nsd1, nex-start);

for(i = start; i < nex; i++)
fprintf(fp4,"%5d %5d\n",i+1, SUB->ne_g[i]);
}


void form_decomp_dec(int nrec, int ne_orig)
{
FILE *ff,*ff1;
char bf[256];
register i,j;
int dum, ne_sd;

ne_sd = ne_orig/t_sds + UnBalance; /* get an etimate on the no of
				   element in each subdomain */

if((elems_sd = calloc(ne_sd,sizeof(int))) == NULL)
{printf("cannot allocate for elems_sd in form_decopm_dec\n");exit(1);}

if((elem_sdno = calloc(ne_orig, sizeof(int))) == NULL)
{printf("cannot allocate for elem_sdno in form_decopm_dec\n");exit(1);}

if(fmod(nrec,2) == 0)
{
  if((ff= fopen("i.dec","r")) == (FILE *) NULL)
  {printf("cannot open i.dec for reading in form_decomp_dec()\n");exit(1);}
}else{
  if((ff= fopen("o.dec","r")) == (FILE *) NULL)
  {printf("cannot open o.dec for reading in form_decomp_dec()\n");exit(1);}
}

if((ff1= fopen("decomp.dec","w")) == (FILE *) NULL)
{printf("cannot open decomp.dec for reading in form_decomp_dec()\n");exit(1);}

for(i = 0;  i < t_sds; i++)
{
     fgets(bf,256,ff); sscanf(bf,"%d %d", &dum, &ne_sd);

     for(j = 0; j < ne_sd; j++)
     {
     fgets(bf,256,ff);
     sscanf(bf,"%d %d", &dum,&(elems_sd[j]));
     }

     load_elem_sdno(i, ne_sd);

}
free(elems_sd);
fclose(ff);

for(i = 0; i < ne_orig; i++)
fprintf(ff1,"%f\n",(float) elem_sdno[i]);

fclose(ff1);
free(elem_sdno);
}


void load_elem_sdno(register i, int ne_sd)
{
register j, pos;

for(j = 0;j < ne_sd; j++) {
pos = elems_sd[j]-1;
elem_sdno[pos] = i+1;
}

}

/*
aux()
{
register i, j;
FILE *fp;


if((fp = fopen("f02abf.dat","w")) == (FILE *) NULL)
{printf("cannot open f02abf.dat\n"); exit(1);} 

fprintf(fp,"Laplace matrix\n");
fprintf(fp," %3d\n", ne);

for(i = 0; i < ne; i++)
{
   for(j = 0; j < ne; j++)
   fprintf(fp," %3d", A[ne*i+j]);
fprintf(fp,"\n");
}

fprintf(fp,"\n\n");
fprintf(fp,"compact\n");
fprintf(fp,"n_compact = %d\n", n_compact);
for(i = 0; i < n_compact; i++)
fprintf(fp,"%5d %5d %5d %5d\n",i+1,AL[i],I[i],J[i]);


printf("file f02abf.dat generated\n");

fclose(fp);
return(1);
}
*/

void alloc_array_short(short **A, int no, char *s)
{
if((*A = malloc(no)) == NULL)
{printf("out of memory for %s\n", s); exit(1);}
}

void alloc_array(double **A, int no, char *s)
{
if((*A = malloc(no)) == NULL)
{printf("out of memory for %s\n", s); exit(1);}
}

void alloc_array_mrk(mrk_t **A, int no, char *s)
{
if((*A = malloc(no)) == NULL)
{printf("out of memory for %s\n", s); exit(1);}
}


void cpy(char *arg1, char *arg2)
{
FILE *fp1,*fp2;
static int count;

long f_size, no_of_bytes_read;

if((fp1=fopen(arg1,"rb")) == (FILE *) NULL)
{printf("cannot open %s\n",arg1); exit(1);}

if((fp2=fopen(arg2,"wb")) == (FILE *) NULL)
{printf("cannot open %s\n",arg2); exit(1);}

fseek(fp1,0,SEEK_END);
f_size = ftell(fp1);
rewind(fp1);

if(count == 0)
if((file_buf=malloc(f_size)) == NULL)
{printf("out of memory\n");exit(1);} 
count++;

no_of_bytes_read = fread(file_buf,1, f_size,fp1);
fwrite(file_buf,1,no_of_bytes_read, fp2);

fclose(fp1);
fclose(fp2);
}


/*
void Lap_count(void)
{
register i,j,k;
int ni[3], nj[3], result;



n_compact = ne;

for(i = 0; i < ne; i++)
{
   for(k=0; k < 3; k++)             
   ni[k] = nod[4*i+k];

   for(j = i; j < ne; j++)
   {
      if(i==j)                      
      goto next_j;

      for(k=0; k < 3; k++)
      nj[k] = nod[4*j+k];            

      result = edge(ni,nj);          

      if(result == 2)
      {
      n_compact++;                   
      n_compact++;                   
      goto next_j;
      }


    next_j:
    continue;
   }


}

printf("The non zeroes in A from Lap_count are = %d\n", n_compact); 

}
*/
